2004-04-19  Roland McGrath  <roland@redhat.com>

	* rt/tst-mqueue9.c (do_test): Initialize RESULT.

2004-04-19  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/mq_unlink.c (mq_unlink): Change EPERM into
	EACCES.
	* rt/Makefile (tests): Add tst-mqueue9.
	* rt/tst-mqueue9.c: New test.
	* rt/tst-mqueue4.c (do_test): Add test for mq_unlink of a too long
	name component.

2004-04-19  Ulrich Drepper  <drepper@redhat.com>

	* rt/tst-mqueue7.c (do_test): Make newargv const.

2004-04-18  Randolph Chung  <tausq@debian.org>

	* sysdeps/hppa/elf/entry.h: New file.
	* sysdeps/hppa/machine-gmon.h: New file.
	* sysdeps/unix/sysv/linux/hppa/profil-counter.h: Don't use x86 version.

2004-04-18  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/powerpc/rt-sysdep.c: New file.
	* sysdeps/unix/sysv/linux/powerpc/Makefile (librt-routines): Add
	rt-sysdep.

	* rt/tst-mqueue5.c (mqsend): Don't inline.
	(mqrecv): Likewise.

	* rt/tst-timer4.c: Include <string.h>.

2004-04-17  Jakub Jelinek  <jakub@redhat.com>

	* rt/Makefile (tests): Add tst-mqueue8.
	* rt/tst-mqueue8.c: New test.

	* sysdeps/unix/sysv/linux/s390/Makefile (librt-routines): Add
	rt-sysdep.
	* sysdeps/unix/sysv/linux/s390/rt-sysdep.S: New file.

2004-03-26  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/unix/sysv/linux/wordsize-64/fxstat.c (__fxstat): Don't
	use "struct kernel_stat".

2004-04-02  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/ia64/memcmp.S: Fix symbol.

2004-04-04  Carlos O'Donell  <carlos@baldric.uwo.ca>

	* sysdeps/hppa/Dist: Add bits/link.h elf/entry.h.

	* sysdeps/hppa/bits/link.h: New file.

	* sysdeps/hppa/dl-machine.h (__hppa_init_bootstrap_fdesc_table):
	Initialze the fdesc table for the generic code.
	(elf_machine_dynamic): Use asm version.
	(elf_machine_load_addresss): Simplify asm by calling
	elf_machine_dynamic.
	(elf_machine_fixup_plt): Correct comment.
	(elf_machine_profile_fixup_plt): New.
	(elf_machine_runtime_setup): Check PLT exists, if lazy=1  process
	normally, else relocate all the absolute entries.
	(RTLD_START): Fix comments.
	(TRAMPOLINE_TEMPLATE): Reformat assembly, add return pointer for
	calls to profile_fixup.
	(ELF_MACHINE_SIZEOF_JMP_SLOT, DL_STATIC_FUNCTION_ADDRESS,
	DL_PLATFORM_INIT): Define.
	(DL_FUNCTION_ADDRESS): Remove.
	(dl_platform_init): New.
	(elf_machine_rela): Use generic fdesc code, and process all COPY
	relocations. Use __attribute__((always_inline)).
	(elf_machine_rela_relative): Add sanity checks, remove IPLT
	processing, print error message in default case. Use
	__attribute__((always_inline)).
	(elf_machine_lazy_rel): Use __attribute__((always_inline)).

2004-04-05  Carlos O'Donell  <carlos@baldric.uwo.ca>

	* sysdeps/hppa/fpu/feupdateenv.c (feupdateenv): Use only sw[0]
	and call feraiseexcept.

2003-11-15  Randolph Chung  <tausq@debian.org>

	* gmon/gmon.c (__monstartup): Round kcountsize to multiples of
	the froms[] array so the array is properly aligned.

2004-04-05  H.J. Lu  <hongjiu.lu@intel.com>

	* Makeconfig (libgcc_eh): Add -Wl,.

	* configure.in: Add -lgcc_s for --as-needed check.

2004-04-16  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* sysdeps/sh/elf/configure.in: New file.

2004-04-17  Ulrich Drepper  <drepper@redhat.com>

	* iconvdata/gconv-modules: Add PT154 and RK1048 entries.
	* iconvdata/tst-tables.sh: Add PT154 and RK1048.
	* iconvdata/Makefile (modules): Add PT154 anhd RK1048.
	(distribute): Add pt154.c and rk1048.c.
	(gen-8bit-gap-modules): Add pt154 and rk1048.
	* icondata/pt154.c: New file.
	* iconvdata/rk1048.c: New file.

	* rt/tst-timer4.c: Disable some tests, mark errors better.

2004-04-16  Ulrich Drepper  <drepper@redhat.com>

	* rt/tst-mqueue6.c (mqsend): Don't inline.
	(mqrecv): Likewise.

	* rt/tst-mqueue3.c (do_test): Cope with kernel without mq support.

	* sysdeps/ieee754/bits/nan.h (__nan_union): Add __attribute_used__
	attribute to keep gcc quiet.

2004-04-16  Jakub Jelinek  <jakub@redhat.com>

	* misc/syslog.c (vsyslog): Avoid freeing failbuf.

2004-04-15  Jakub Jelinek  <jakub@redhat.com>

	* rt/Makefile (tests): Add tst-timer4.
	* rt/tst-timer4.c: New test.

2004-04-15  Jakub Jelinek  <jakub@redhat.com>

	* rt/tst-mqueue5.c (rtmin_code): New variable.
	(rtmin_handler): Set it.
	(thr, do_child, do_test): Also check rtmin_code.

2004-04-14  Jakub Jelinek  <jakub@redhat.com>

	* rt/Makefile (tests): Add tst-mqueue7.
	(tst-mqueue7-ARGS): Set.
	* rt/tst-mqueue7.c: New test.

2004-04-13  Jakub Jelinek  <jakub@redhat.com>

	* rt/Makefile (tests): Add tst-mqueue5 and tst-mqueue6.
	* rt/tst-mqueue1.c (do_one_test): Bitwise or check_attrs () into
	result instead of replacing it.  Use TEMP_FAILURE_RETRY around
	waitpid, kill child if waitpid failed.
	(do_test): Bitwise or check_attrs () into result instead of replacing
	it.  Change temp mq name.
	* rt/tst-mqueue5.c: New test.
	* rt/tst-mqueue6.c: New test.
	* rt/tst-mqueue.h: Include stdio.h, unistd.h, sys/uio.h.
	(temp_mq_list, delete_temp_mqs): Remove.
	(temp_mq_fd): New variable.
	(do_cleanup, do_prepare): New functions.
	(add_temp_mq): Rewritten to use a temp file.
	(PREPARE): Define.
	(CLEANUP_HANDLER): Change to do_cleanup ().

	* rt/tst-timer3.c: Don't fail if _POSIX_THREADS is not available.

2004-04-13  Thorsten Kukuk  <kukuk@suse.de>

	* sysdeps/s390/ffs.c: Include limits.h

2004-04-13  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* sysdeps/unix/sysv/linux/sh/sysdep.h (SUBSTITUTE_ARGS_1,
	SUBSTITUTE_ARGS_2, SUBSTITUTE_ARGS_3, SUBSTITUTE_ARGS_4,
	SUBSTITUTE_ARGS_5, SUBSTITUTE_ARGS_6, SUBSTITUTE_ARGS_7): Load
	argument values into temporary variables.

2004-04-15  Atsushi Nemoto <anemo@mba.ocn.ne.jp>

	* sysdeps/mips/dl-machine.h (RTLD_START): Do not use nested .end.

2004-04-12  Ulrich Drepper  <drepper@redhat.com>

	* rt/Makefile (tests): Add tst-timer3.
	* rt/tst-timer3.c: New file.  By Roland McGrath.

2004-04-08  Ulrich Drepper  <drepper@redhat.com>

	* rt/tst-mqueue3.c: New file.
	* rt/Makefile (tests): Add tst-mqueue3.

2004-04-08  Jakub Jelinek  <jakub@redhat.com>

	* rt/tst-mqueue1.c: New file.
	* rt/tst-mqueue2.c: New file.
	* rt/tst-mqueue4.c: New file.
	* rt/Makefile (tests): Add tst-mqueue1, tst-mqueue2, tst-mqueue4.

	* rt/Versions (librt): Add mq_*@@GLIBC_2.3.4.
	* rt/Makefile (headers): Add mqueue.h and bits/mqueue.h.
	(mq-routines): Set.
	(librt-routines): Use it.
	* rt/mqueue.h: New file.
	* include/mqueue.h: New file.
	* sysdeps/generic/bits/mqueue.h: New file.
	* sysdeps/generic/mq_setattr.c: New file.
	* sysdeps/generic/mq_getattr.c: New file.
	* sysdeps/generic/mq_notify.c: New file.
	* sysdeps/generic/mq_close.c: New file.
	* sysdeps/generic/mq_send.c: New file.
	* sysdeps/generic/mq_unlink.c: New file.
	* sysdeps/generic/mq_receive.c: New file.
	* sysdeps/generic/mq_timedreceive.c: New file.
	* sysdeps/generic/mq_timedsend.c: New file.
	* sysdeps/generic/mq_open.c: New file.
	* sysdeps/unix/sysv/linux/bits/local_lim.h (MQ_PRIO_MAX): Define.
	* sysdeps/unix/sysv/linux/bits/mqueue.h: New file.
	* sysdeps/unix/sysv/linux/syscalls.list: Add mq_timedsend,
	mq_timedreceive and mq_setattr.
	* sysdeps/unix/sysv/linux/mq_getattr.c: New file.
	* sysdeps/unix/sysv/linux/mq_notify.c: New file.
	* sysdeps/unix/sysv/linux/mq_close.c: New file.
	* sysdeps/unix/sysv/linux/mq_send.c: New file.
	* sysdeps/unix/sysv/linux/mq_unlink.c: New file.
	* sysdeps/unix/sysv/linux/mq_receive.c: New file.
	* sysdeps/unix/sysv/linux/mq_open.c: New file.

2004-04-09  Andreas Schwab  <schwab@suse.de>

	* sysdeps/unix/sysv/linux/ia64/sysdep.h (DO_INLINE_SYSCALL): Move
	LOAD_ARGS_##nr up front and add LOAD_REGS_##nr.
	(LOAD_ARGS_0, LOAD_ARGS_1, LOAD_ARGS_2, LOAD_ARGS_3, LOAD_ARGS_4)
	(LOAD_ARGS_5, LOAD_ARGS_6): Load argument values into temporary
	variables.
	(LOAD_REGS_0, LOAD_REGS_1, LOAD_REGS_2, LOAD_REGS_3, LOAD_REGS_4)
	(LOAD_REGS_5, LOAD_REGS_6): New macros to actually load the
	syscall argument registers.

	* sysdeps/unix/sysv/linux/x86_64/sysdep.h (INTERNAL_SYSCALL): Add
	LOAD_REGS_##nr.
	(LOAD_ARGS_0, LOAD_ARGS_1, LOAD_ARGS_2, LOAD_ARGS_3, LOAD_ARGS_4)
	(LOAD_ARGS_5, LOAD_ARGS_6): Load argument values into temporary
	variables.
	(LOAD_REGS_0, LOAD_REGS_1, LOAD_REGS_2, LOAD_REGS_3, LOAD_REGS_4)
	(LOAD_REGS_5, LOAD_REGS_6): New macros to actually load the
	syscall argument registers.

2004-04-09  Andreas Schwab  <schwab@suse.de>

	* sysdeps/unix/sysv/linux/m68k/sysdep.h (INTERNAL_SYSCALL): Add
	LOAD_REGS_##nr.
	(LOAD_ARGS_0, LOAD_ARGS_1, LOAD_ARGS_2, LOAD_ARGS_3, LOAD_ARGS_4)
	(LOAD_ARGS_5, LOAD_ARGS_6): Load argument values into temporary
	variables.
	(LOAD_REGS_0, LOAD_REGS_1, LOAD_REGS_2, LOAD_REGS_3, LOAD_REGS_4)
	(LOAD_REGS_5, LOAD_REGS_6): New macros to actually load the
	syscall argument registers.

2004-04-09  Thorsten Kukuk  <kukuk@suse.de>

	* sysdeps/s390/ffs.c: Don't add ffsl weak alias on s390x.

2004-04-09  Steven Munroe  <sjmunroe@us.ibm.com>

	* sysdeps/unix/sysv/linux/powerpc/powerpc64/umount.c: New file.

2004-04-08  Ulrich Drepper  <drepper@redhat.com>

	* po/nl.po: Update from translation team.

2004-04-04  Ulrich Drepper  <drepper@redhat.com>

	* math/test-tgmath.c: Declare compile_testl inly if we will define it.

2004-04-03  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/powerpc/powerpc64/ffsll.c: New file.

	* string/test-ffs.c: Also test ffsl and ffsll.

	* sysdeps/powerpc/ffs.c: Don't define ffsl for ppc64.

	* sysdeps/powerpc/powerpc64/bits/atomic.h: Never use matching
	constraints for asm mem parameters.
	* sysdeps/powerpc/bits/atomic.h: Likewise.

	* sysdeps/powerpc/elf/libc-start.c: No need for a separate
	function for __aux_init_cache.

	* inet/test-ifaddrs.c: Fight warnings.

	* argp/argp-help.c: Fight warnings.

	* include/time.h: Declare __difftime.

	* sysdeps/unix/sysv/linux/internal_statvfs.c: Restructure to avoid
	duplication in 64-bit version.
	* sysdeps/unix/sysv/linux/wordsize-64/internal_statvfs64.c: New file.

2004-04-03  Andreas Jaeger  <aj@suse.de>

	* nis/nss-nis.c: Include <string.h> for strncmp.

2004-03-30  H.J. Lu  <hongjiu.lu@intel.com>

	* Makeconfig (link-libc-static): Use $(static-gnulib) instead
	of $(gnulib).
	(libgcc_eh): New variable.
	(gnulib): Use it variable.
	(static-gnulib): New variable.
	* Makerules (LDLIBS-c.so): Use $(static-gnulib) instead of $(gnulib).
	* config.make.in (have-as-needed): New variable.
	* configure.in: Check if linker supports --as-needed.

2004-04-02  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/internal_statvfs64.c: New file.
	* sysdeps/unix/sysv/linux/Makefile [subdir=io] (sysdep_routines):
	Add internal_statvfs64.
	* sysdeps/unix/sysv/linux/internal_statvfs.c: Allow to be used to
	compile 64bit version.
	* sysdeps/unix/sysv/linux/statvfs64.c: Use __fstatfs64 and skip
	compatibility code if __ASSUME_STATFS64 is defined.
	* sysdeps/unix/sysv/linux/fstatvfs64.c: Likewise.

	* sysdeps/unix/sysv/linux/statfs64.c: Don't add __no_statfs64 if
	__ASSUME_STATFS64 != 0.

2004-04-02  Thorsten Kukuk  <kukuk@firun.suse.de>

	* nis/nss_nis/nis-ethers.c (saveit): Fix return codes in error case.
	* nis/nss_nis/nis-initgroups.c (saveit): Likewise.
	* nis/nss_nis/nis-proto.c (saveit): Likewise.
	* nis/nss_nis/nis-rpc.c (saveit): Likewise.
	* nis/nss_nis/nis-service.c (saveit): Likewise.

2004-04-02  Jakub Jelinek  <jakub@redhat.com>

	* nis/nss: Add SERVICES_AUTHORITATIVE.
	* nis/nss-nis.h (NSS_FLAG_SET, NSS_FLAG_NETID_AUTHORITATIVE,
	NSS_FLAG_SERVICES_AUTHORITATIVE): Define.
	(_nis_default_nss_flags, _nis_check_default_nss): New decls.
	(_nis_default_nss): New inline.
	* nis/nss-nis.c: Include ctype.h, stdio.h and stdio_ext.h.
	(_nis_default_nss_flags, default_nss): New variables.
	(_nis_check_default_nss): New function.
	* nis/nss_nis/nis-initgroups.c: Don't include stdio.h and
	stdio_ext.h.
	(check_default_nss, default_nss): Move to nss-nis.c.
	(init): Removed.
	(_nss_nis_initgroups_dyn): Use _nis_default_nss ().
	* nis/nss_nis/nis-services.c (_nss_nis_getservbyname_r): If
	NSS_FLAG_SERVICES_AUTHORITATIVE and services.byservicename lookup
	fails, return immediately.

2004-04-01  Roland McGrath  <roland@redhat.com>

	* elf/tst-execstack.c (do_test): Make F static.

2004-04-01  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/powerpc/powerpc32/getcontext.S: Use
	__sigprocmask not sigprocmask.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/setcontext.S: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/swapcontext.S: Likewise.

	* include/string.h: Add libc_hidden_builtin_proto for memcmp.
	* sysdeps/generic/memcmp.c: Add libc_hidden_builtin_def.
	* sysdeps/i386/memcmp.S: Likewise.
	* sysdeps/i386/i686/memcmp.S: Likewise.
	* sysdeps/ia64/memcmp.S: Likewise.
	* sysdeps/sparc/sparc64/memcmp.S: Likewise.

	* sysdeps/unix/sysv/linux/sigprocmask.c: Include <string.h>.
	* time/mktime.c: Likewise.
	* misc/getpass.c: Likewise.

	* time/difftime.c (__difftime): New renamed.  Make old name alias.
	Use __difftime in recursive call.

	* sysdeps/unix/sysv/linux/powerpc/ioctl.c (__ioctl): Use
	__tcgetattr() instead of tcgetattr().

	* sysdeps/unix/sysv/linux/powerpc/powerpc64/makecontext.S [SHARED]:
	Use __GI_exit.

	* sysdeps/unix/sysv/linux/powerpc/powerpc64/clone.S [SHARED]: Use
	__GI__exit.

	* sysdeps/powerpc/fpu/bits/mathinline.h: Add __signbitf and
	__signbit inlines.

	* sysdeps/unix/sysv/linux/powerpc/powerpc64/getcontext.S: Use
	__sigprocmask not sigprocmask.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/setcontext.S: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/swapcontext.S: Likewise.

	* elf/elf.h: Define more ppc64 specific dynamic tags.

2004-04-01  Jakub Jelinek  <jakub@redhat.com>

	* nis/nss_nis/nis-service.c (_nss_nis_getservbyname_r): If protocol
	is NULL, instead of trying yp_match (name/tcp), yp_match (name/udp),
	yp_all, try yp_match (name), yp_all.

2004-04-01  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/generic/dl-sysdep.c (_dl_show_auxv): Add handling for
	ignored entries.  Ignore AT_IGNOREPPC.

2004-03-31  Andreas Jaeger  <aj@suse.de>

	* libio/fileops.c (new_do_write): Return _IO_size_t to make 64-bit
        clean.

2004-03-31  Ulrich Drepper  <drepper@redhat.com>

	* locale/programs/localedef.c (construct_output_path): Remove
	remnants of CEN locale names.

2004-03-30  Thorsten Kukuk  <kukuk@suse.de>

	* sysdeps/unix/sysv/linux/alpha/bits/termios.h: Add IUTF8.
	* sysdeps/unix/sysv/linux/bits/termios.h: Likewise.
	* sysdeps/unix/sysv/linux/mips/bits/termios.h: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/bits/termios.h: Likewise.
	* sysdeps/unix/sysv/linux/sparc/bits/termios.h: Likewise.

2004-03-30  Richard Henderson  <rth@redhat.com>

	* sysdeps/alpha/remqu.S: Detect power-of-two special case.

2004-03-30  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/generic/libc-start.c (LIBC_START_MAIN)
	[HAVE_CLEANUP_JMP_BUF]: Call __nptl_deallocate_tsd.

2004-03-30  Jakub Jelinek  <jakub@redhat.com>

	* nis/nss_nis/nis-service.c (_nss_nis_getservbyname_r): If protocol
	== NULL, try name/tcp and name/udp first before falling back into
	the sequential scanning.  Use services.byname database for
	sequential scanning.
	(_nss_nis_getservbyport_r): Likewise.  Just allocate sizeof (int) * 3
	chars for integer.

	* nis/nss_nis/nis-service.c (_nss_nis_getservbyport_r): Convert
	proto to host by order for snprintf.

2004-03-30  Ulrich Drepper  <drepper@redhat.com>

	* nss/getent.c (services_keys): Don't implement lookups with
	missing protocol using getservent loop, just pass NULL.

	* sysdeps/unix/sysv/linux/i386/setgroups.c (setgroups): Avoid
	comparison with limit if we can rely on the syscall being available.

	* nis/nss_nis/nis-initgroups.c: Implement getting the information
	from the netid.byname map if the system administrator allows this.
	* nis/Makefile (distribute): Add nss.
	* nis/nss: New file.

	* grp/initgroups.c (initgroups): Limit the initial allocation to 64
	entries to not allocate too much on systems with really high limits.

2004-03-30  Jakub Jelinek  <jakub@redhat.com>

	* nis/nss_nis/nis-service.c (struct search_t): New type.
	(dosearch): New function.
	(_nss_nis_getservbyname_r): Use it.  Call yp_get_default_domain
	unconditionally.
	(_nss_nis_getservbyport_r): Likewise.

2004-03-29  Alexandre Oliva  <aoliva@redhat.com>

	* sysdeps/unix/sysv/linux/sched_getaffinity.c: Prepend GLIBC_ to
	version names is SHLIB_COMPAT check.
	* sysdeps/unix/sysv/linux/sched_setaffinity.c: Likewise.

2004-03-29  Ulrich Drepper  <drepper@redhat.com>

	* nis/nss_nis/nis-rpc.c (saveit): Improve memory handling.  No need to
	allocate multiple blocks.
	(internal_nis_endrpcent): Adjust accordingly.
	* nis/nss_nis/nis-proto.c (saveit): Improve memory handling.  No need
	to allocate multiple blocks.
	(internal_nis_endprotoent): Adjust accordingly.
	* nis/nss_nis/nis-initgroups.c (saveit): Improve memory handling.  No
	need to allocate multiple blocks.
	(_nss_nis_initgroups_dyn): Adjust accordingly.
	* nis/nss_nis/nis-ethers.c (saveit): Improve memory handling.  No need
	to allocate multiple blocks.
	(internal_nis_endetherent): Adjust accordingly.
	* nis/nss_nis/nis-service.c (saveit): Improve memory handling.  No need
	to allocate multiple blocks.
	(internal_nis_endservent): Adjust accordingly.

	* nss/getXXbyYY_r.c: Return 0 for NSS_STATUS_NOTFOUND.

2004-03-26  Thorsten Kukuk  <kukuk@suse.de>

	* nis/nss_nis/nis-grp.c (_nss_nis_getgrnam_r): Don't
	set errno if group does not exist.

2004-03-28  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/sysconf.c (__sysconf): Handle
	_SC_SIGQUEUE_MAX.

2004-03-26  Ulrich Drepper  <drepper@redhat.com>

	* elf/dl-caller.c: New file.
	* include/caller.h: New file.
	* Makefile (distribute): Add include/caller.h.
	* elf/Makefile (dl-routines): Add dl-caller.
	* elf/dl-load.c (_dl_map_object_from_fd): Record l_text_end.
	* elf/dl-open.c (check_libc_caller): Removed.
	(dl_open_worker): Use __check_caller instead.
	* elf/rtld.c (_rtld_global_ro): Initialize _dl_check_caller.
	(_dl_start_final): Record l_text_end for ld.so map.
	(dl_main): Record l_text_end for main object and vdso.
	* include/link.h (struct link_map): Add l_text_end field.
	* sysdeps/generic/ldsodefs.h (struct rtld_global_ro): Add
	_dl_check_caller field.
	Define enum allowmask.  Add declaration of _dl_check_caller.
	* sysdeps/unix/sysv/linux/dl-execstack.c: Also use __check_caller test.

2004-03-26  Richard Henderson  <rth@redhat.com>

	* sysdeps/alpha/Makefile <gnulib> (sysdep_routines): Merge divrem
	variable, add unsigned variants.
	* sysdeps/alpha/divrem.h: Remove file.
	* sysdeps/alpha/div_libc.h: New file.
	* sysdeps/alpha/divl.S: Rewrite from scratch.
	* sysdeps/alpha/reml.S: Likewise.
	* sysdeps/alpha/divq.S: Likewise.
	* sysdeps/alpha/remq.S: Likewise.
	* sysdeps/alpha/divlu.S: New file.
	* sysdeps/alpha/remlu.S: New file.
	* sysdeps/alpha/divqu.S: New file.
	* sysdeps/alpha/remqu.S: New file.

2004-03-26  Ulrich Drepper  <drepper@redhat.com>

	* elf/dl-open.c (check_libc_caller): Fix typo.

2004-03-26  Jakub Jelinek  <jakub@redhat.com>

	* elf/tst-dlmodcount.c: Include stddef.h and stdlib.h.

2003-03-25  Richard Henderson  <rth@redhat.com>

	* sysdeps/alpha/backtrace.c: New file.

2004-03-25  Ulrich Drepper  <drepper@redhat.com>

	* iconvdata/utf-7.c: Remove inline from isdirect, isxdirect, and
	isxbase64.

2004-03-25  Richard Henderson  <rth@redhat.com>

	* sysdeps/generic/strtol_l.c (__strtol_ul_max_tab,
	__strtol_ull_max_tab, __strtol_ull_rem_tab, __strtol_ul_rem_tab,
	cutoff_tab, cutlim_tab, jmax_tab): New.
	(__strtol_l): Use them to avoid runtime division.

2004-03-24  Roland McGrath  <roland@redhat.com>

	* Makerules ($(common-objpfx)shlib.lds): Don't use \n in rhs of sed
	substitutions; the semicolon terminators are enough for ld anyway.

	* elf/dl-deps.c (_dl_map_object_deps): Use alloca instead of
	dynamically sized auto array in function already using alloca.
	* locale/programs/ld-ctype.c (ctype_output): Likewise.
	* locale/programs/ld-time.c (time_output): Likewise.
	* elf/dl-misc.c (_dl_debug_vdprintf): Use macro instead of const for
	IOV array size.
	* locale/programs/charmap.c (charmap_read): Avoid alloca (or strdupa)
	when also using dynamically-sized auto array.
	* locale/programs/locfile.c (locfile_read): Likewise.
	* locale/programs/repertoire.c (repertoire_read): Likewise.
	* nis/nis_print_group_entry.c (nis_print_group_entry): Likewise.
	* locale/programs/locarchive.c (enlarge_archive): Likewise.
	* posix/annexc.c (check_header): Likewise.

	* iconv/gconv_int.h (norm_add_slashes): Don't handle null SUFFIX.
	strlen ("") gets optimized away just as well.
	* intl/loadmsgcat.c (_nl_init_domain_conv): Update caller.
	* wcsmbs/wcsmbsload.c (__wcsmbs_load_conv): Likewise.

	* Makefile ($(objpfx)c++-types-check.out): Reduce duplication in
	defining this target.  Also elide -Wstrict-prototypes from CFLAGS.

2004-03-24  Ulrich Drepper  <drepper@redhat.com>

	* stdio-common/vfscanf.c [!COMPILE_WSCANF] (TOLOWER): Cast first
	parameter to unsigned char.
	* sysdeps/generic/strcasestr.c [_LIBC] (TOLOWER): Likewise.

2004-03-24  Jakub Jelinek  <jakub@redhat.com>

	* stdlib/strtod_l.c (INTERNAL (__STRTOF)): Clear the rest of retval,
	not just one limb if RETURN_LIMB_SIZE > 2.  Fix shifting up if
	RETURN_LIMB_SIZE > 2.

	* stdio-common/printf_fp.c (__printf_fp): For IEEE quad long double
	on 32-bit architectures reserve 8 limbs instead of 4.

2004-03-23  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/alpha/sysdep.h (__NR_pread, __NR_pwrite):
	Define to __NR_p{read,write}64 if not defined.
	* sysdeps/unix/sysv/linux/s390/s390-64/sysdep.h (__NR_pread,
	__NR_pwrite): Define to __NR_p{read,write}64 if not defined instead
	of defining it the other way around.
	* sysdeps/unix/sysv/linux/alpha/syscalls.list: Move common syscalls
	for 64bit arches to sysdeps/unix/sysv/linux/wordsize-64/syscalls.list.
	* sysdeps/unix/sysv/linux/s390/s390-64/syscalls.list: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc64/syscalls.list: Likewise.
	* sysdeps/unix/sysv/linux/ia64/syscalls.list: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/syscalls.list: Likewise.
	* sysdeps/unix/sysv/linux/alpha/pread64.c: Removed.
	* sysdeps/unix/sysv/linux/alpha/getrlimit64.c: Removed.
	* sysdeps/unix/sysv/linux/alpha/glob64.c: Removed.
	* sysdeps/unix/sysv/linux/alpha/truncate64.c: Removed.
	* sysdeps/unix/sysv/linux/alpha/xstat64.c: Removed.
	* sysdeps/unix/sysv/linux/alpha/pwrite64.c: Removed.
	* sysdeps/unix/sysv/linux/alpha/posix_fadvise.c: Removed.
	* sysdeps/unix/sysv/linux/alpha/mmap64.c: Removed.
	* sysdeps/unix/sysv/linux/alpha/fxstat64.c: Removed.
	* sysdeps/unix/sysv/linux/alpha/setrlimit64.c: Removed.
	* sysdeps/unix/sysv/linux/alpha/ftruncate64.c: Removed.
	* sysdeps/unix/sysv/linux/alpha/sendfile64.c: Removed.
	* sysdeps/unix/sysv/linux/alpha/lxstat64.c: Removed.
	* sysdeps/unix/sysv/linux/alpha/posix_fadvise64.c: Removed.
	* sysdeps/unix/sysv/linux/alpha/statfs64.c: Removed.
	* sysdeps/unix/sysv/linux/alpha/fstatfs64.c: Removed.
	* sysdeps/unix/sysv/linux/s390/s390-64/pread64.c: Removed.
	* sysdeps/unix/sysv/linux/s390/s390-64/getrlimit64.c: Removed.
	* sysdeps/unix/sysv/linux/s390/s390-64/glob64.c: Removed.
	* sysdeps/unix/sysv/linux/s390/s390-64/readdir64_r.c: Removed.
	* sysdeps/unix/sysv/linux/s390/s390-64/truncate64.c: Removed.
	* sysdeps/unix/sysv/linux/s390/s390-64/xstat64.c: Removed.
	* sysdeps/unix/sysv/linux/s390/s390-64/pwrite64.c: Removed.
	* sysdeps/unix/sysv/linux/s390/s390-64/getdents64.c: Removed.
	* sysdeps/unix/sysv/linux/s390/s390-64/readdir_r.c: Removed.
	* sysdeps/unix/sysv/linux/s390/s390-64/lxstat.c: Removed.
	* sysdeps/unix/sysv/linux/s390/s390-64/readdir.c: Removed.
	* sysdeps/unix/sysv/linux/s390/s390-64/posix_fadvise.c: Removed.
	* sysdeps/unix/sysv/linux/s390/s390-64/mmap64.c: Removed.
	* sysdeps/unix/sysv/linux/s390/s390-64/xstat.c: Removed.
	* sysdeps/unix/sysv/linux/s390/s390-64/fxstat64.c: Removed.
	* sysdeps/unix/sysv/linux/s390/s390-64/setrlimit64.c: Removed.
	* sysdeps/unix/sysv/linux/s390/s390-64/ftruncate64.c: Removed.
	* sysdeps/unix/sysv/linux/s390/s390-64/getdents.c: Removed.
	* sysdeps/unix/sysv/linux/s390/s390-64/lxstat64.c: Removed.
	* sysdeps/unix/sysv/linux/s390/s390-64/posix_fadvise64.c: Removed.
	* sysdeps/unix/sysv/linux/s390/s390-64/readdir64.c: Removed.
	* sysdeps/unix/sysv/linux/s390/s390-64/fxstat.c: Removed.
	* sysdeps/unix/sysv/linux/s390/s390-64/statfs64.c: Removed.
	* sysdeps/unix/sysv/linux/s390/s390-64/fstatfs64.c: Removed.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/glob64.c: Removed.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/truncate64.c: Removed.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/xstat64.c: Removed.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/posix_fadvise.c: Removed.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/fxstat64.c: Removed.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/ftruncate64.c: Removed.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/lxstat64.c: Removed.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/posix_fadvise64.c: Removed.
	* sysdeps/unix/sysv/linux/sparc/sparc64/pread64.c: Removed.
	* sysdeps/unix/sysv/linux/sparc/sparc64/getrlimit64.c: Removed.
	* sysdeps/unix/sysv/linux/sparc/sparc64/glob64.c: Removed.
	* sysdeps/unix/sysv/linux/sparc/sparc64/readdir64_r.c: Removed.
	* sysdeps/unix/sysv/linux/sparc/sparc64/truncate64.c: Removed.
	* sysdeps/unix/sysv/linux/sparc/sparc64/xstat64.c: Removed.
	* sysdeps/unix/sysv/linux/sparc/sparc64/pwrite64.c: Removed.
	* sysdeps/unix/sysv/linux/sparc/sparc64/getdents64.c: Removed.
	* sysdeps/unix/sysv/linux/sparc/sparc64/readdir_r.c: Removed.
	* sysdeps/unix/sysv/linux/sparc/sparc64/readdir.c: Removed.
	* sysdeps/unix/sysv/linux/sparc/sparc64/posix_fadvise.c: Removed.
	* sysdeps/unix/sysv/linux/sparc/sparc64/mmap64.c: Removed.
	* sysdeps/unix/sysv/linux/sparc/sparc64/fxstat64.c: Removed.
	* sysdeps/unix/sysv/linux/sparc/sparc64/setrlimit64.c: Removed.
	* sysdeps/unix/sysv/linux/sparc/sparc64/ftruncate64.c: Removed.
	* sysdeps/unix/sysv/linux/sparc/sparc64/sendfile64.c: Removed.
	* sysdeps/unix/sysv/linux/sparc/sparc64/getdents.c: Removed.
	* sysdeps/unix/sysv/linux/sparc/sparc64/lxstat64.c: Removed.
	* sysdeps/unix/sysv/linux/sparc/sparc64/posix_fadvise64.c: Removed.
	* sysdeps/unix/sysv/linux/sparc/sparc64/readdir64.c: Removed.
	* sysdeps/unix/sysv/linux/sparc/sparc64/statfs64.c: Removed.
	* sysdeps/unix/sysv/linux/sparc/sparc64/fstatfs64.c: Removed.
	* sysdeps/unix/sysv/linux/ia64/pread64.c: Removed.
	* sysdeps/unix/sysv/linux/ia64/getrlimit64.c: Removed.
	* sysdeps/unix/sysv/linux/ia64/glob64.c: Removed.
	* sysdeps/unix/sysv/linux/ia64/readdir64_r.c: Removed.
	* sysdeps/unix/sysv/linux/ia64/truncate64.c: Removed.
	* sysdeps/unix/sysv/linux/ia64/xstat64.c: Removed.
	* sysdeps/unix/sysv/linux/ia64/pwrite64.c: Removed.
	* sysdeps/unix/sysv/linux/ia64/getdents64.c: Removed.
	* sysdeps/unix/sysv/linux/ia64/readdir_r.c: Removed.
	* sysdeps/unix/sysv/linux/ia64/lxstat.c: Removed.
	* sysdeps/unix/sysv/linux/ia64/readdir.c: Removed.
	* sysdeps/unix/sysv/linux/ia64/posix_fadvise.c: Removed.
	* sysdeps/unix/sysv/linux/ia64/mmap64.c: Removed.
	* sysdeps/unix/sysv/linux/ia64/xstat.c: Removed.
	* sysdeps/unix/sysv/linux/ia64/fxstat64.c: Removed.
	* sysdeps/unix/sysv/linux/ia64/setrlimit64.c: Removed.
	* sysdeps/unix/sysv/linux/ia64/ftruncate64.c: Removed.
	* sysdeps/unix/sysv/linux/ia64/sendfile64.c: Removed.
	* sysdeps/unix/sysv/linux/ia64/getdents.c: Removed.
	* sysdeps/unix/sysv/linux/ia64/lxstat64.c: Removed.
	* sysdeps/unix/sysv/linux/ia64/posix_fadvise64.c: Removed.
	* sysdeps/unix/sysv/linux/ia64/readdir64.c: Removed.
	* sysdeps/unix/sysv/linux/ia64/fxstat.c: Removed.
	* sysdeps/unix/sysv/linux/ia64/statfs64.c: Removed.
	* sysdeps/unix/sysv/linux/ia64/fstatfs64.c: Removed.
	* sysdeps/unix/sysv/linux/x86_64/pread64.c: Removed.
	* sysdeps/unix/sysv/linux/x86_64/getrlimit64.c: Removed.
	* sysdeps/unix/sysv/linux/x86_64/glob64.c: Removed.
	* sysdeps/unix/sysv/linux/x86_64/readdir64_r.c: Removed.
	* sysdeps/unix/sysv/linux/x86_64/truncate64.c: Removed.
	* sysdeps/unix/sysv/linux/x86_64/xstat64.c: Removed.
	* sysdeps/unix/sysv/linux/x86_64/pwrite64.c: Removed.
	* sysdeps/unix/sysv/linux/x86_64/getdents64.c: Removed.
	* sysdeps/unix/sysv/linux/x86_64/readdir_r.c: Removed.
	* sysdeps/unix/sysv/linux/x86_64/lxstat.c: Removed.
	* sysdeps/unix/sysv/linux/x86_64/readdir.c: Removed.
	* sysdeps/unix/sysv/linux/x86_64/posix_fadvise.c: Removed.
	* sysdeps/unix/sysv/linux/x86_64/mmap64.c: Removed.
	* sysdeps/unix/sysv/linux/x86_64/xstat.c: Removed.
	* sysdeps/unix/sysv/linux/x86_64/fxstat64.c: Removed.
	* sysdeps/unix/sysv/linux/x86_64/setrlimit64.c: Removed.
	* sysdeps/unix/sysv/linux/x86_64/ftruncate64.c: Removed.
	* sysdeps/unix/sysv/linux/x86_64/sendfile64.c: Removed.
	* sysdeps/unix/sysv/linux/x86_64/getdents.c: Removed.
	* sysdeps/unix/sysv/linux/x86_64/lxstat64.c: Removed.
	* sysdeps/unix/sysv/linux/x86_64/posix_fadvise64.c: Removed.
	* sysdeps/unix/sysv/linux/x86_64/readdir64.c: Removed.
	* sysdeps/unix/sysv/linux/x86_64/fxstat.c: Removed.
	* sysdeps/unix/sysv/linux/x86_64/statfs64.c: Removed.
	* sysdeps/unix/sysv/linux/x86_64/fstatfs64.c: Removed.
	* sysdeps/unix/sysv/linux/alpha/Implies: New file.
	* sysdeps/unix/sysv/linux/alpha/getdents64.c: New file.
	* sysdeps/unix/sysv/linux/s390/s390-64/Implies: New file.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/Implies: New file.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/syscalls.list: New file.
	* sysdeps/unix/sysv/linux/sparc/sparc64/Implies: New file.
	* sysdeps/unix/sysv/linux/sparc/sparc64/lxstat.c: New file.
	* sysdeps/unix/sysv/linux/sparc/sparc64/xstat.c: New file.
	* sysdeps/unix/sysv/linux/sparc/sparc64/fxstat.c: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/statvfs64.c: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/fstatvfs64.c: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/pread64.c: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/fstatvfs.c: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/getrlimit64.c: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/glob64.c: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/readdir64_r.c: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/truncate64.c: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/xstat64.c: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/pwrite64.c: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/getdents64.c: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/readdir_r.c: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/lxstat.c: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/readdir.c: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/posix_fadvise.c: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/mmap64.c: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/xstat.c: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/fxstat64.c: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/setrlimit64.c: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/ftruncate64.c: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/sendfile64.c: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/getdents.c: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/statvfs.c: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/lxstat64.c: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/posix_fadvise64.c: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/readdir64.c: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/syscalls.list: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/fxstat.c: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/statfs64.c: New file.
	* sysdeps/unix/sysv/linux/wordsize-64/fstatfs64.c: New file.
	* sysdeps/unix/sysv/linux/ia64/Implies: New file.
	* sysdeps/unix/sysv/linux/x86_64/Implies: New file.

2004-03-22  Richard Henderson  <rth@redhat.com>

	* sysdeps/alpha/s_fabs.S: Remove file.
	* sysdeps/alpha/s_copysign.S: Remove file.

2004-03-22  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/sparc/sparc32/getpagesize.c
	(__getpagesize): Avoid warning about writing into read-only memory.

	* string/Makefile (routines): Add xpg-strerror.
	* string/string.h (strerror_r): If __USE_XOPEN2K but not __USE_GNU,
	redirect strerror_r to __xpg_strerror_r.
	* string/Versions (libc): Add __xpg_strerror_r@@GLIBC_2.3.4.
	* sysdeps/generic/xpg-strerror.c: New file.
	* sysdeps/mach/xpg-strerror.c: New file.

2004-03-22  Joseph S. Myers  <jsm@polyomino.org.uk>

	* sunrpc/rpc/xdr.h (IXDR_GET_LONG, IXDR_PUT_LONG): Do not use
	casts as lvalues.

2004-03-22  Andreas Jaeger  <aj@suse.de>

	* elf/tst-dlmodcount.c (unload): Remove unused variable.

	* misc/tst-mntent.c (main): Use tmpfile instead of tmpnam.

2004-03-20  Roland McGrath  <roland@frob.com>

	* sysdeps/mach/hurd/dl-execstack.c: New file.

2004-03-20  Ulrich Drepper  <drepper@redhat.com>

	* po/ca.po: Update from translation team.

2004-03-20  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/sched_getaffinity.c
	(__sched_getaffinity_old): Fix interface.
	* sysdeps/unix/sysv/linux/sched_setaffinity.c
	(__sched_setaffinity_old): Likewise.

	* sysdeps/unix/sysv/linux/sched_setaffinity.c: Include <alloca.h>.

2004-03-17  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* sysdeps/unix/sysv/linux/kernel-features.h
	(__ASSUME_CLONE_THREAD_FLAGS ): Define for newer SH kernel.
	(__ASSUME_TGKILL, __ASSUME_UTIMES): Likewise.
	* sysdeps/unix/sysv/linux/sh/socket.S: Add unwind information.

2004-03-19  Ulrich Drepper  <drepper@redhat.com>

	* time/tzfile.c (__tzfile_default): Correct setting of rule_stdoff
	and rule_dstoff after reading the posixrules file.

2004-03-18  Ulrich Drepper  <drepper@redhat.com>

	* malloc/malloc.c (__posix_memalign): Correct alignment check.
	Reported by Don Heller <dheller@cse.psu.edu>.

2004-03-18  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/generic/dl-cache.c (_dl_load_cache_lookup): Remove hwcap
	variable and weak_extern for _dl_hwcap.
	(_DL_HWCAP_TLS_MASK): Define.
	(HWCAP_CHECK): Fix checking of non-platform hwcap bits.  Use
	lib->osversion instead of cache_new->libs[middle].osversion.

	* stdio-common/asprintf.c: Remove USE_IN_LIBIO conditionals.
	* stdio-common/dprintf.c: Likewise.
	* stdio-common/fprintf.c: Likewise.
	* stdio-common/getline.c: Likewise.
	* stdio-common/getw.c: Likewise.
	* stdio-common/perror.c: Likewise.
	* stdio-common/printf-prs.c: Likewise.
	* stdio-common/printf.c: Likewise.
	* stdio-common/printf_size.c: Likewise.
	* stdio-common/psignal.c: Likewise.
	* stdio-common/putw.c: Likewise.
	* stdio-common/scanf.c: Likewise.
	* stdio-common/snprintf.c: Likewise.
	* stdio-common/sprintf.c: Likewise.
	* stdio-common/sscanf.c: Likewise.
	* stdio-common/tstgetln.c: Likewise.
	* stdio-common/vfprintf.c: Likewise.

2004-03-18  Paul Eggert  <eggert@cs.ucla.edu>

	* posix/getopt.h (__GNUC_PREREQ) [!defined __THROW]: Define
	if not defined, fixing a typo (it used to be defined if
	__GNUC__ was not defined).

2004-03-18  Ulrich Drepper  <drepper@redhat.com>

	* posix/sched.h: Change sched_getaffinity and sched_setaffinity
	interfaces: add new second parameter.
	* sysdeps/generic/sched_getaffinity.c: Implement interface change.
	* sysdeps/generic/sched_setaffinity.c: Likewise.
	* sysdeps/unix/sysv/linux/sched_getaffinity.c: Likewise.  Add
	compatibility interface.
	* sysdeps/unix/sysv/linux/sched_setaffinity.c: Likewise.
	* sysdeps/unix/sysv/linux/Versions: Add versions for changed
	interfaces.

2004-03-18  Roland McGrath  <roland@redhat.com>

	* manual/Makefile (stamp-summary): Use -k option to sort,
	not traditional key selection syntax.
	Reported by Jim Gifford <giffordj@linkline.com>.

2004-03-18  Jakub Jelinek  <jakub@redhat.com>

	* elf/ldconfig.c: Include stdbool.h.

2004-03-18  Roland McGrath  <roland@redhat.com>

	* elf/ldconfig.c (parse_conf_include): New function.
	(parse_conf): Call it to parse lines starting with "include".
	Remaining words are glob patterns for more config files to read.
	Take additional bool argument to disable opt_chroot processing.
	(main): Update caller.

2004-03-17  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/ia64/ioperm.c (_iopl): Match EPERM error
	the x86 code produces in case of mission permissions.
	Patch by Bernd Schmidt <bernds@redhat.com>.

	* resolv/netdb.h: Define AI_IDN_ALLOW_UNASSIGNED,
	AI_IDN_USE_STD3_ASCII_RULES, NI_IDN_ALLOW_UNASSIGNED, and
	NI_IDN_USE_STD3_ASCII_RULES.
	* inet/getnameinfo.c (getnameinfo): Implement handling of
	NI_IDN_ALLOW_UNASSIGNED and NI_IDN_USE_STD3_ASCII_RULES.
	* sysdeps/posix/getaddrinfo.c (gaih_inet): Implement handling of
	AI_IDN_ALLOW_UNASSIGNED and AI_IDN_USE_STD3_ASCII_RULES.

2004-03-17  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/x86_64/hp-timing.h (HP_TIMING_NOW): Make asm volatile.

2004-03-16  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/powerpc/powerpc32/fpu/__longjmp.S: Spelling.
	(JB_SIZE): Undefine before including __longjmp-common.S again.
	* sysdeps/powerpc/powerpc32/fpu/setjmp.S: Spelling.
	(JB_SIZE): Undefine before including setjmp-common.S again.
	* sysdeps/powerpc/powerpc64/bsd-_setjmp.S: Spelling.
	* sysdeps/powerpc/powerpc64/bsd-setjmp.S: Spelling.
	* sysdeps/powerpc/powerpc32/bsd-_setjmp.S: Spelling.
	* sysdeps/powerpc/powerpc32/bsd-setjmp.S: Spelling.
	* sysdeps/powerpc/sigjmp.c: Spelling.

2004-03-16  Ulrich Drepper  <drepper@redhat.com>

	* include/ctype.h: For libc, define isdigit, isdigit_l, and
	__isdigit_l as simple comparison macros.
	* include/wctype.h: For libc, define iswdigit, iswdigit_l, and
	__iswdigit_l as simple comparison macros.
	* wctype/wcfuncs_l.c: #undef iswdigit and __iswdigit.

2004-03-15  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/sparc/fpu/bits/mathinline.h: Restore missing #ifdef.
	Patch by Richard Henderson.

2004-03-16  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/generic/strtold_l.c (STRING_TYPE, STRTOLD, __STRTOLD,
	__STRTOD, INTERNAL, INTERNAL1): Define, use them.
	[! USE_WIDE_CHAR] (INTERNAL (__STRTOLD)): Add libc_hidden_def.

	* inet/getnameinfo.c: Include stdlib.h.

2004-03-15  Richard Henderson  <rth@redhat.com>

	* math/Makefile (headers): Add bits/huge_valf.h, bits/huge_vall.h,
	and bits/inf.h.
	* math/math.h: Include them.

	* sysdeps/alpha/fpu/bits/mathdef.h: Remove INFINITY.
	* sysdeps/arm/fpu/bits/mathdef.h: Likewise.
	* sysdeps/generic/bits/mathdef.h: Likewise.
	* sysdeps/i386/fpu/bits/mathdef.h: Likewise.
	* sysdeps/ia64/fpu/bits/mathdef.h: Likewise.
	* sysdeps/m68k/fpu/bits/mathdef.h: Likewise.
	* sysdeps/mips/fpu/bits/mathdef.h: Likewise.
	* sysdeps/powerpc/fpu/bits/mathdef.h: Likewise.
	* sysdeps/sh/sh4/fpu/bits/mathdef.h: Likewise.
	* sysdeps/sparc/fpu/bits/mathdef.h: Likewise.
	* sysdeps/x86_64/fpu/bits/mathdef.h: Likewise.

	* sysdeps/arm/bits/huge_val.h (HUGE_VAL): Use __builtin_huge_val.
	(HUGE_VALF, HUGE_VALL): Remove.
	* sysdeps/ieee754/bits/huge_val.h: Likewise.
	* sysdeps/sh/bits/huge_val.h: Likewise.

	* sysdeps/generic/bits/huge_val.h (HUGE_VAL): Use __builtin_huge_val.
	* sysdeps/generic/bits/huge_valf.h: New file.
	* sysdeps/generic/bits/huge_vall.h: New file.
	* sysdeps/generic/bits/inf.h: New file.
	* sysdeps/ieee754/bits/huge_valf.h: New file.
	* sysdeps/ieee754/bits/inf.h: New file.
	* sysdeps/i386/bits/huge_val.h: Remove file.
	* sysdeps/i386/bits/huge_vall.h: New file.
	* sysdeps/ia64/bits/huge_val.h: Remove file.
	* sysdeps/ia64/bits/huge_vall.h: New file.
	* sysdeps/ieee754/ldbl-128/bits/huge_vall.h: New file.
	* sysdeps/m68k/bits/huge_val.h: Remove file.
	* sysdeps/m68k/bits/huge_vall.h: New file.
	* sysdeps/s390/bits/huge_val.h: Remove file.
	* sysdeps/sh/sh4/fpu/bits/huge_val.h: Remove file.
	* sysdeps/sparc/bits/huge_vall.h: New file.
	* sysdeps/sparc/sparc32/fpu/bits/huge_val.h: Remove file.
	* sysdeps/sparc/sparc64/fpu/bits/huge_val.h: Remove file.

	* sysdeps/ieee754/bits/nan.h (NAN): Use __builtin_nanf.
	* sysdeps/mips/bits/nan.h (NAN): Likewise.

2004-03-15  Ulrich Drepper  <drepper@redhat.com>

	* iconv/gconv_simple.c (__gconv_transform_utf8_internal): Use only
	one copy of error handling code.

	* stdio-common/vfscanf.c: Simplify error handling macros.  Use
	direct locale access functions.

	* sysdeps/generic/strcasestr.c (__strcasestr): Optimize use of
	tolower function.

2004-03-13  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/i386/sysconf.c (intel_02_known): Add const.
	(handle_amd): New function.
	(__sysconf): Handle _SC_LEVEL4_CACHE_LINESIZE here, not in
	linux_sysconf.  Call handle_amd on AuthenticAMD.
	* sysdeps/unix/sysv/linux/x86_64/sysconf.c: Likewise.

2004-03-14  Ulrich Drepper  <drepper@redhat.com>

	* wcsmbs/mbsrtowcs.c: Just a wrapper around __mbsrtowcs_l.
	* wcsmbs/mbsrtowcs_l.c (__mbsrtowcs_l): Add real implementation here.

	Make the non-_l functions wrappers around the _l functions.
	* include/monetary.h: Declare __vstrmon_l.
	* include/string.h: Add libc_hidden_proto for __strcoll_l and
	__strxfrm_l.
	* include/time.h: Define ptime_locale_status.  Declare
	__strptime_internal.
	* include/wchar.h: Add libc_hidden_proto for __wcscoll_l and
	__wcsxfrm_l.
	* stdlib/strfmon.c: Move the code to strfmon_l.c.  Add little
	wrapper around __vstrfmon_l.
	* stdlib/strfmon_l.c: Add real implementation.  Split into new
	function __vstrfmon_l to allow calling it from strfmon.
	* stdlib/strtod.c: Move real code to strtod_l.c and add wrapper.
	* stdlib/strtod_l.c: Add real implementation.
	* stdlib/strtof.c: Adjust to changed strtod.c.
	* stdlib/strtof_l.c: Include strtod_l.c now.
	* stdlib/strtold.c: New file.
	* stdlib/strtold_l.c: Removed.
	* string/strcoll.c: Move real code to strcoll_l.c: Add wrapper.
	* string/strcoll_l.c: Add real implementation.
	* string/strxfrm.c: Move real code to strxfrm_l.c: Add wrapper.
	* string/strxfrm_l.c: Add real implementation.
	* sysdeps/generic/strtol.c: Move real implementation to strtol_l.c.
	Add wrappers.
	* sysdeps/generic/strtol_l.c: Add real implementation.
	* sysdeps/generic/strtold.c: Removed.
	* sysdeps/generic/strtold_l.c: New file.
	* sysdeps/generic/strtoll_l.c: Include strtol_l.c now.  Adjust
	#defines.
	* sysdeps/generic/strtoul_l.c: Likewise.
	* sysdeps/generic/strtoull_l.c: Likewise.
	* sysdeps/generic/wcstol_l.c: Likewise.
	* sysdeps/generic/wcstoll_l.c: Likewise.
	* sysdeps/generic/wcstoul_l.c: Likewise.
	* sysdeps/generic/wcstoull_l.c: Likewise.
	* sysdeps/ieee754/ldbl-128/strtold.c: Removed.
	* sysdeps/ieee754/ldbl-128/strtold_l.c: New file.
	* sysdeps/ieee754/ldbl-96/strtold.c: Removed.
	* sysdeps/ieee754/ldbl-96/strtold_l.c: New file.
	* sysdeps/m68k/strtold.c: Removed.
	* sysdeps/m68k/strtold_l.c: New file.
	* time/strftime.c: Move real code to strftime_l.c.  Add wrapper.
	* time/strftime_l.c: Add real implementation.
	* time/strptime.c: Move real code to strptime_l.c.  Add wrapper.
	* time/strptime_l.c: Add real implementation.
	* time/wcsftime.c: Simplify since only wrappers are defined in
	strftime.c.
	* time/wcsftime_l.c: Include strftime_l.c.
	* wcsmbs/wcscoll.c: Simplify since the file is not used by wcscoll_l.c
	anymore.
	* wcsmbs/wcscoll_l.c: Include strcoll_l.c.
	* wcsmbs/wcsxfrm.c: Simplify since the file is not used by wcsxfrm_l.c
	anymore.
	* wcsmbs/wcsxfrm_l.c: Include strxfrm_l.c.
	* wcsmbs/wcstod.c: Prepare to include new strtod.c.
	* wcsmbs/wcstod_l.c: Include strtod_l.c.
	* wcsmbs/wcstof.c: Prepare to include new strtof.c.
	* wcsmbs/wcstof_l.c: Include strtof_l.c.
	* wcsmbs/wcstold.c: Prepare to include new strtold.c.
	* wcsmbs/wcstold_l.c: Include strtold_l.c.

	* locale/uselocale.c: Use _NL_CURRENT_LOCALE instead of __libc_tsd_get.

	* sysdeps/generic/strcasecmp.c: Optimize a bit.  It's better to get
	a reference to the current locale and then use the _l functions.
	* sysdeps/generic/strncase.c: Likewise.

2004-03-11  Jeroen Dekkers  <jeroen@dekkers.cx>

	* cppflags-iterator.mk: Change libof-$(cpp-src) to
	libof-$(notdir $(cpp-src)).

2004-03-13  Ulrich Drepper  <drepper@redhat.com>

	* resolv/netdb.h (EAI_OVERFLOW): Define.
	(NI_IDN): Define.
	* inet/getnameinfo.c (getnameinfo): Return error in case argument
	buffers overflow.  Implement NI_IDN.

2004-03-12  Ulrich Drepper  <drepper@redhat.com>

	* resolv/netdb.h: Define AI_CANONIDN.
	* sysdeps/posix/getaddrinfo.c: Implement AI_CANONIDN.

2004-03-12  Richard Henderson  <rth@redhat.com>

	* sysdeps/unix/sysv/linux/alpha/select.S: Fix unwind.  Propagate
	oldvalue from CENABLE to CDISABLE.

2004-03-12  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/sysconf.c: New file.

	* sysdeps/unix/sysv/linux/bits/local_lim.h: Define HOST_NAME_MAX.

	* posix/getconf.c (vars): Add _SC_ values for cache information.
	* sysdeps/generic/bits/confname.h: Add _SC_* values for cache
	information.
	* sysdeps/unix/sysv/linux/sysconf.c (__sysconf): Reorganize to
	allow yet another sysconf function to include the one in this file.
	* sysdeps/unix/sysv/linux/i386/sysconf.c: New file.
	* sysdeps/generic/sysconf.c: Add default handling for cache line info.

2004-03-11  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/posix/sysconf.c (__sysconf): Add missing support for
	some _SC_* values.

2004-03-10  Chris Heath  <chris@heathens.co.nz>

	* iconvdata/gconv.map: Add gconv_end (fixes memory leak).

2004-03-11  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/powerpc/powerpc32/__longjmp.S (JB_SIZE): Undefine before
	including __longjmp-common.S again.
	* sysdeps/powerpc/powerpc64/__longjmp.S (JB_SIZE): Likewise.
	* sysdeps/powerpc/powerpc32/setjmp.S (JB_SIZE): Undefine before
	including setjmp-common.S again.
	* sysdeps/powerpc/powerpc64/setjmp.S (JB_SIZE): Likewise.
	* sysdeps/powerpc/novmxsetjmp.h (__novmx__longjmp): Fix type of
	first argument in the prototype.
	* sysdeps/powerpc/longjmp.c (__vmx__longjmp, __vmx__libc_longjmp):
	Remove bogus semicolons.

	* sysdeps/s390/dl-tls.h: Only add __tls_get_offset assembly if
	IS_IN_rtld.
	(__TLS_GET_ADDR): Use __tls_get_offset, not __tls_get_addr.

2004-03-11  Ulrich Drepper  <drepper@redhat.com>

	* resolv/ns_ttl.c: Don't add ns_parse_ttl for libresolv.so.

2004-03-10  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/generic/errno.c: Include <dl-sysdep.h>.  Use
	RTLD_PRIVATE_ERRNO to decide whether errno compat symbols are needed.

	* elf/dl-sym.c: Unify _dl_sym and _dl_vsym code and make the entry
	points wrappers around the unified code.

2004-03-11  Richard Henderson  <rth@redhat.com>

	* sysdeps/unix/sysv/linux/alpha/kernel_stat.h (kernel_stat64): New.
	(glibc21_stat): New.
	* sysdeps/unix/sysv/linux/alpha/fxstat.c: New file.
	* sysdeps/unix/sysv/linux/alpha/lxstat.c: New file.
	* sysdeps/unix/sysv/linux/alpha/xstat.c: New file.
	* sysdeps/unix/sysv/linux/alpha/xstatconv.c (__xstat_conv): Add
	code for _STAT_VER_GLIBC2_3_4.
	(__libc_missing_axp_stat64): New.
	* sysdeps/unix/sysv/linux/alpha/xstatconv.h: New file.
	* sysdeps/unix/sysv/linux/alpha/bits/stat.h (__ST_TIME): New.
	(_STAT_VER_GLIBC2_3_4, _STAT_VER_KERNEL64): New.
	(struct stat, struct stat64): Update to new format.
	(_STATBUF_ST_NSEC): New.

2004-03-11  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/powerpc/powerpc32/swapcontext.S
	(__novec_swapcontext): Branch to novec_* labels.

2004-03-10  Ulrich Drepper  <drepper@redhat.com>

	* posix/getopt.c (_): Don't define here for glibc.

2004-03-10  Jakub Jelinek  <jakub@redhat.com>

	* include/libc-symbols.h [__ASSEMBLY__] (compat_text_section,
	compat_data_section): Define.
	* sysdeps/unix/sysv/linux/alpha/adjtime.c (ADJTIME): Add
	attribute_compat_text_section.
	* sysdeps/unix/sysv/linux/alpha/wordexp.c (__old_wordexp): Likewise.
	* sysdeps/unix/sysv/linux/alpha/oldglob.c (__old_glob,
	__old_globfree): Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-32/chown.c (__chown_is_lchown):
	Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-32/posix_fadvise64.c
	(__posix_fadvise64_l32): Likewise.
	* sysdeps/unix/sysv/linux/msgctl.c (__old_msgctl): Likewise.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/posix_fadvise64.c
	(__posix_fadvise64_l32): Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc32/semctl.c (__old_semctl):
	Likewise.
	* sysdeps/unix/sysv/linux/semctl.c (__old_semctl): Likewise.
	* sysdeps/unix/sysv/linux/posix_fadvise64.c (__posix_fadvise64_l32):
	Likewise.
	* sysdeps/unix/sysv/linux/shmctl.c (__old_shmctl): Likewise.
	* hurd/compat-20.c (_hurd_proc_init_compat_20): Likewise.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/swapcontext.S
	(__swapcontext, __novec_swapcontext): Use END instead of PSEUDO_END.
	(__novec_swapcontext, __swapcontext_stub): Add compat_text_section.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/makecontext.S
	(__makecontext_stub): Likewise.
	(__novec_makecontext): Likewise.  Fix name in END () to match
	function name.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/setcontext.S
	(__setcontext): Use END instead of PSEUDO_END.
	(__novec_setcontext): Add compat_text_section.  Use END instead of
	PSEUDO_END, fix the name in END () to match function name.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/getcontext.S
	(__getcontext, __novec_getcontext): Use END instead of PSEUDO_END.
	(__novec_getcontext, __getcontext_stub): Add compat_text_section.

2004-03-10  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* sysdeps/sh/dl-machine.h: Don't use GL macro if not appropriate.
	(COPY_UNALIGNED_WORD): Remove cast used as lvalue.

2004-03-10  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/i386/dl-procinfo.h (HWCAP_IMPORTANT): Remove mmx, add sse2.

2004-03-10  Richard Henderson  <rth@redhat.com>

	* sysdeps/generic/errno.c: Disable versioning for rtld.

	* sysdeps/generic/Makefile (elf/shared): Add unwind-pe.
	* sysdeps/generic/unwind-pe.c: New file.
	* sysdeps/generic/unwind-pe.h: Only prototypes for _LIBC without
	_LIBC_DEFINITIONS.

2004-03-10  Ulrich Drepper  <drepper@redhat.com>

	* include/libc-symbols.h: Define attribute_compat_text_section and
	attribute_compat_data_section.
	* io/ftw.c: Mark compat code with attribute_compat_text_section.
	* libio/iofopncook.c: Likewise.
	* libio/oldfileops.c: Likewise.
	* libio/oldiofclose.c: Likewise.
	* libio/oldiofdopen.c: Likewise.
	* libio/oldiofgetpos.c: Likewise.
	* libio/oldiofgetpos64.c: Likewise.
	* libio/oldiofopen.c: Likewise.
	* libio/oldiofsetpos.c: Likewise.
	* libio/oldiofsetpos64.c: Likewise.
	* libio/oldiopopen.c: Likewise.
	* libio/oldpclose.c: Likewise.
	* libio/oldtmpfile.c: Likewise.
	* nptl/forward.c: Likewise.
	* nss/getXXbyYY_r.c: Likewise.
	* nss/getXXent_r.c: Likewise.
	* posix/tst-vfork1.c: Likewise.
	* stdlib/canonicalize.c: Likewise.
	* stdlib/old_atexit.c: Likewise.
	* sysdeps/generic/glob.c: Likewise.
	* sysdeps/posix/posix_fallocate64.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/alphasort64.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/chown.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/glob64.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/msgctl.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/oldgetrlimit64.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/posix_fadvise64.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/readdir64.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/readdir64_r.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/scandir64.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/semctl.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/shmctl.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/versionsort64.c: Likewise.
	* posix/regexec.c: Likewise.

	* sysdeps/unix/sysv/linux/i386/syscalls.list: vm86@@GLIBC_2.3.4
	should be the default symbol. Having none misses the point.

2004-03-09  Ulrich Drepper  <drepper@redhat.com>

	* stdlib/qsort.c (_quicksort): Initialize first stack element [BZ #16].

2004-03-05  Jakub Jelinek  <jakub@redhat.com>

	* posix/regexec.c (regexec): Return with error on unknown eflags.
	Replace weak_alias with versioned_symbol.
	(__compat_regexec): New.
	* posix/Versions (libc): Add regexec@GLIBC_2.3.4.

2004-03-09  Richard Henderson  <rth@redhat.com>

	* math/math.h (isgreater, isgreaterequal, isless, islessequal,
	islessgreater, isunordered): Use builtins if available.
	* sysdeps/i386/fpu/bits/mathinline.h: Don't define via builtins.
	* sysdeps/m68k/fpu/bits/mathinline.h: Likewise.
	* sysdeps/powerpc/fpu/bits/mathinline.h: Likewise.
	* sysdeps/sparc/fpu/bits/mathinline.h: Likewise.
	* sysdeps/x86_64/fpu/bits/mathinline.h: Likewise.
	* sysdeps/alpha/fpu/bits/mathinline.h (isgreater, isgreaterequal,
	isless, islessequal, islessgreater): Remove; use default.
	(isunordered): Convert inputs to double.

2004-02-09  Jakub Jelinek  <jakub@redhat.com>

	* posix/Makefile (tests): Add tst-vfork2.
	* posix/tst-vfork1.c (do_test): Fix comment.
	* posix/tst-vfork2.c: New test.

2004-03-09  Ulrich Drepper  <drepper@redhat.com>

	* elf/dl-lookup.c (_dl_lookup_symbol_x): Fix possible NULL pointer
	derefernce in error message.  Pretty printing.

	* po/nl.po: Update from translation team.

2004-03-08  Andreas Schwab  <schwab@suse.de>

	* sysdeps/generic/dl-sysdep.c (_dl_sysdep_start): Don't truncate
	sysinfo pointer value.

2004-03-08  Paul Eggert  <eggert@cs.ucla.edu>

	Merge from gnulib.  We now assume C89 or better.
	* posix/getopt1.c (const): Remove.
	* posix/getopt.c (const): Likewise.
	* posix/getopt1.c (getopt_long, _getopt_long_r, getopt_long_only,
	_getopt_long_only_r, main): Use prototypes, not old-style definitions.
	* posix/getopt.c (exchange, _getopt_initialize, _getopt_internal_r,
	_getopt_internal, getopt, main): Likewise.
	* posix/getopt.h (getopt, getopt_long, getopt_long_only): Likewise.
	* posix/getopt.c [!defined VMS || !HAVE_STRING_H]:
	Include <string.h> regardless.  No need for <strings.h>.
	[!defined _LIBC]: Include "gettext.h" rather than rolling it ourselves.
	(_): Define to gettext always.
	(my_index): Remove: all uses changed to strchr.
	(strlen): Remove declaration.
	* posix/getopt.h (struct option.name): Always const char *.

2004-03-08  Marcus Brinkmann  <marcus@gnu.org>

	* posix/getopt.h (_getopt_internal): Move to ...
	* posix/getopt_int.h: ... here.  New file.
	* include/getopt_int.h: New file.
	* include/getopt.h: Remove libc_hidden_proto for getopt_long
	and getopt_long_only.
	* posix/getopt1.c: Include "getopt_int.h".  Remove
	libc_hidden_def for getopt_long and getopt_long_only.
	(_getopt_long_r, _getopt_long_only_r): New functions.
	* posix/getopt.c: Include "getopt_int.h".
	(__getopt_initialized): Variable removed.
	(nextchar, ordering, posixly_correct, first_nonopt, last_nonopt):
	Static variables removed.
	(nonoption_flags_max_len, nonoption_flags_len) [_LIBC &&
	USE_NONOPTION_FLAGS]: Static variables removed.
	(getopt_data): New static variable.
	(SWAP_FLAGS): Use d->__nonoption_flags_len instead
	nonoption_flags_len.
	(exchange): Add new argument D of type struct getopt_data *.
	Replace optind with d->optind, optarg with d->optarg, opterr with
	d->opterr, optopt with d->optopt, nextchar with d->__nextchar,
	first_nonopt with d->__first_nonopt, last_nonopt with
	d->__last_nonopt, d->ordering with d->__ordering,
	d->posixly_correct with d->__posixly_correct (which is now an
	int instead a string, so fix users), nonoption_flags_len
	with d->__nonoption_flags_len, nonoption_flags_max_len with
	d->__nonoption_flags_max_len.
	(_getopt_initialize): Likewise.
	(_getopt_internal): Rename to ...
	(_getopt_internal_r): ... this.  Also add new argument D of type
	struct getopt_data * and use of members of D rather than global or
	static variables as described for exchange() above.  Add new argument
	to invocations of _getopt_initialize and exchange.
	(_getopt_internal): Reimplement in terms of _getopt_internal_r.
	* argp/argp-parse.c: Include <getopt_int.h>.
	[_LIBC]: Do not include <bits/libc-lock.h>.
	[!_LIBC && HAVE_CTHREADS_H]: Do not include <cthreads.h>.
	[!_LIBC] (_argp_hang): Make static.
	(getopt_lock, LOCK_GETOPT, UNLOCK_GETOPT): Remove.
	(_argp_unlock_xxx): Remove.
	(parser_init): Do not use LOCK_GETOPT.
	(parser_finalize): Do not use UNLOCK_GETOPT.
	(struct parser): New member OPT_DATA.
	(parser_init): Initialize parser->opt_data.  Use
	parser->opt_data.opterr instead of opterr.
	(parser_parse_opt): Use parser->opt_data.optarg instead optarg.
	(parser_parse_next): Likewise.  Use parser->opt_data.optind
	instead optind.  Use parser->opt_data.optopt instead of optopt.
	Call _getopt_long_only_r and _getopt_long_r instead of
	getopt_long_only and getopt_long, and pass the extra argument.

2004-03-09  Ulrich Drepper  <drepper@redhat.com>

	* iconv/gconv_db.c: Don't define lock as static.  Rename to
	__gconv_lock and export from the file.
	* iconv/gconv_int.h: Declare __gconv_lock.
	* libio/iofclose.c [_LIBC] (_IO_new_fclose): Lock gconv lock
	before __gconv_release_step calls.
	Patch by Shunichi Sagawa <s-sagawa@jp.fujitsu.com>.

	* iconv/gconv_simple.c (internal_ucs4_loop): Fix typo in last change.

	* posix/Makefile (tests): Add tst-vfork1.
	* posix/tst-vfork1.c: New file.

2004-03-08  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/i386/dl-machine.h: Define ARCH_FIXUP_ATTRIBUTE and use
	it in the fixup function declarations.
	* elf/dl-runtime.c: If ARCH_FIXUP_ATTRIBUTE is not defined,
	provide dummy definition.  Use macro in fixup function
	definitions.

	* sysdeps/unix/sysv/linux/i386/vfork.S: If SAVE_PID and
	RESTORE_PID are defined, use it.
	* sysdeps/unix/sysv/linux/x86_64/vfork.S: Likewise.

	* sysdeps/posix/gai_strerror.c: Add error string for EAI_IDN_ENCODE.

	* Makerules: Use extra-modules.mk if modules-names is defined.
	* extra-modules.mk: New file.
	* dlfcn/Makefile (CPPFLAGS-modcxaatexit.c): Removed.
	* elf/Makefile (CFLAGS-interp.c): Add -DNOT_IN_libc=1.
	* csu/Makefile ($(objpfx)version-info.h): Pass -DNOT_IN_libc=1 to
	compiler.
	* Makefile (distribute): Add symbol-hacks.h and extra-modules.mk.
	* sysdeps/generic/symbol-hacks.h: New file.
	* sysdeps/wordsize-32/symbol-hacks.h: New file.
	* sysdeps/wordsize-32/divdi3.c: Define *_internal aliases for __divdi3,
	__moddi3, __udivdi3, and __umoddi3.
	* include/libc-symbols.h: Include <symbol-hacks.h>.

2004-03-08  Jeroen Dekkers  <jeroen@dekkers.cx>

	* elf/rtld.c (_rtld_global_ro) [MAP_COPY]: Don't set _dl_unload_cache.

	* sysdeps/mach/hurd/dl-sysdep.c (_dl_important_hwcaps):
	Don't use INTUSE with _dl_signal_error.

2004-03-08  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/powerpc/powerpc64/dl-machine.c (_dl_reloc_overflow):
	Don't use INTUSE with _dl_signal_error.

2004-03-08  Richard Henderson  <rth@redhat.com>

	* sysdeps/alpha/soft-fp/ots_cvtxt.c (_OtsConvertFloatXT): Fix typo
	in name.

2004-03-07  Ulrich Drepper  <drepper@redhat.com>

	* config.h.in: Add entry for HAVE_LIBIDN.
	* configure.in: If libidn add-on present define HAVE_LIBIDN.
	* Versions.def: Add entry for libcidn.

2004-03-07  Simon Josefsson  <jas@extundo.com>

	* resolv/netdb.h [__USE_GNU]: Add new AI_IDN ai_flags for addrinfo.
	[__USE_GNU]: Add new error code EAI_IDN_ENCODE for getaddrinfo.
	* sysdeps/posix/getaddrinfo.c: Add prototype for __idna_to_ascii_lz
	and define IDNA_SUCCESS.
	(gaih_inet): If ai_flags have AI_IDN, invoke __idna_to_ascii_lz.
	(getaddrinfo): Fix EAI_BADFLAGS test to include AI_IDN.
	All changes only applicable when glibc is compiled with the libidn
	add-on.

2004-03-07  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/ia64/dl-static.c (_dl_static_init): Call
	_dl_lookup_symbol_x not _dl_lookup_symbol.

	* sysdeps/powerpc/elf/rtld-global-offsets.sym: Adjust for moving
	_dl_hwcap into _rtld_global_ro.
	* sysdeps/powerpc/powerpc32/fpu/__longjmp-common.S: Likewise.
	* sysdeps/powerpc/powerpc32/fpu/setjmp-common.S: Likewise.
	* sysdeps/powerpc/powerpc64/__longjmp-common.S: Likewise.
	* sysdeps/powerpc/powerpc64/setjmp-common.S: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/getcontext.S: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/setcontext.S: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/swapcontext.S: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/getcontext.S: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/setcontext.S: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/swapcontext.S: Likewise.

2004-03-07  Andreas Schwab  <schwab@suse.de>

	* elf/dl-sym.c: Include <dl-tls.h> only when USE_TLS.

2004-03-07  Andreas Jaeger  <aj@suse.de>

	* iconvdata/iso-2022-cn-ext.c (BODY): Remove cast used as lvalue.
	* iconvdata/tcvn5712-1.c (EMIT_SHIFT_TO_INIT): Likewise.
	* iconvdata/euc-jisx0213.c (EMIT_SHIFT_TO_INIT): Likewise.
	* iconvdata/shift_jisx0213.c (EMIT_SHIFT_TO_INIT): Likewise.
	* iconvdata/tscii.c (EMIT_SHIFT_TO_INIT): Likewise.

2004-03-07  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/generic/ldsodefs.h: Move _dl_initial_searclist,
	_dl_hp_timing_overhead, _dl_init_all_dirs, and the content of
	dl-procinfo.c from _rtld_global to _rtld_global_ro.
	* elf/rtld.c: Adjust initializer for _rtld_global_ro.
	* elf/dl-close.c: Use GLRO instead of GL where appropriate.
	* elf/dl-libc.c: Likewise.
	* elf/dl-load.c: Likewise.
	* sysdeps/i386/dl-procinfo.h: Likewise.
	* sysdeps/i386/i686/hp-timing.h: Likewise.
	* sysdeps/ia64/hp-timing.h: Likewise.
	* sysdeps/sparc/sparc32/sparcv9/hp-timing.h: Likewise.
	* sysdeps/sparc/sparc64/hp-timing.h: Likewise.
	* sysdeps/unix/sysv/linux/arm/dl-procinfo.h: Likewise.
	* sysdeps/unix/sysv/linux/i386/dl-procinfo.h: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc32/dl-procinfo.h: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc64/dl-procinfo.h: Likewise.
	* string/test-string.h: Define GLRO.

2004-03-06  Ulrich Drepper  <drepper@redhat.com>

	* elf/dl-lookup.c: We don't need for specialized lookup functions.
	Combining the functionality does not slow down relocation processing,
	it might even speed it up a little.
	* sysdeps/generic/ldsodefs.h: Adjust prototypes for lookup function.
	Add only one function pointer to rtlf_global_ro.
	* elf/do-lookup.h: Replace #ifs with ifs.
	* elf/dl-libc.c: Adjust _dl_lookup_* callers.
	* elf/dl-reloc.c: Likewise.
	* elf/dl-runtime.c: Likewise.
	* elf/dl-sym.c: Likewise.
	* elf/rtld.c: Likewise.  Adjust _rtld_global_ro initialization.

2004-03-06  Richard Henderson  <rth@redhat.com>

	* sysdeps/generic/ldsodefs.h (__rtld_local_attribute__,
	__rtld_global_attribute__): Undef after use.
	(_rtld_local_ro): Define __rtld_local_attribute__ with just hidden
	if available.

	* soft-fp/quad.h (union _FP_UNION_Q): Add longs structure.
	* sysdeps/alpha/Implies: Add alpha/soft-fp.
	* sysdeps/alpha/soft-fp/sfp-machine.h: Rewrite for GEM interface.
	* sysdeps/alpha/Subdirs: New file.
	* sysdeps/alpha/soft-fp/Makefile: New file.
	* sysdeps/alpha/soft-fp/Versions: New file.
	* sysdeps/alpha/soft-fp/local-soft-fp.h: New file.
	* sysdeps/alpha/soft-fp/ots_add.c: New file.
	* sysdeps/alpha/soft-fp/ots_cmp.c: new file.
	* sysdeps/alpha/soft-fp/ots_cmpe.c: New file.
	* sysdeps/alpha/soft-fp/ots_cvtqux.c: New file.
	* sysdeps/alpha/soft-fp/ots_cvtqx.c: New file.
	* sysdeps/alpha/soft-fp/ots_cvttx.c: New file.
	* sysdeps/alpha/soft-fp/ots_cvtxq.c: New file.
	* sysdeps/alpha/soft-fp/ots_cvtxt.c: New file.
	* sysdeps/alpha/soft-fp/ots_div.c: New file.
	* sysdeps/alpha/soft-fp/ots_mul.c: New file.
	* sysdeps/alpha/soft-fp/ots_nintxq.c: New file.
	* sysdeps/alpha/soft-fp/ots_sub.c: New file.

2004-03-06  Ulrich Drepper  <drepper@redhat.com>

	* configure.in: Recognize --enable-bind-now.
	* elf/dynamic-link.h (elf_get_dynamic_info): Allow bind-now flags
	in ld.so.
	* Makerules (LDFLAGS-c.so): Add -z now if so configured.
	* elf/Makefile ($(objpfx)ld.so): Likewise.
	* config.make.in (bind-now): New definition.

	* elf/dl-fini.c (_dl_fini): Combine _dl_debug_printf calls.
	* elf/rtld.c (print_statistics): Likewise.

	* elf/dl-open.c: No need to pass any parameter to _dl_start_profile.
	They are the same in both places.
	* elf/dl-profile.c: Likewise.
	* elf/rtld.c: Likewise.
	* sysdeps/generic/ldsodefs.h: Likewise.
	* elf/dl-support.c: Define _dl_profile_output variable.  Initialize it.

2004-03-05  Ulrich Drepper  <drepper@redhat.com>

	* elf/Versions: Remove functions which are not exported anymore.
	* dlfcn/dlerror.c: Call ld.so functions through GLSO.
	* dlfcn/dlinfo.c: Likewise.
	* elf/dl-close.c: Likewise.
	* elf/dl-libc.c: Likewise.
	* elf/dl-open.c: Likewise.
	* elf/dl-sym.c: Likewise.
	* sysdeps/generic/libc-start.c: Likewise.
	* elf/dl-debug.c: Remove *_internal definition.  Don't use INTUSE for
	functions which are not exported anymore.
	* elf/dl-deps.c: Likewise.
	* elf/dl-dst.h: Likewise.
	* elf/dl-error.c: Likewise.
	* elf/dl-fini.c: Likewise.
	* elf/dl-init.c: Likewise.
	* elf/dl-load.c: Likewise.
	* elf/dl-lookup.c: Likewise.
	* elf/dl-misc.c: Likewise.
	* elf/dl-profile.c: Likewise.
	* elf/dl-profstub.c: Likewise.
	* elf/dl-reloc.c: Likewise.
	* elf/dl-runtime.c: Likewise.
	* elf/dl-version.c: Likewise.
	* elf/do-lookup.h: Likewise.
	* include/dlfcn.h: Likewise.
	* sysdeps/generic/dl-cache.c: Likewise.
	* sysdeps/generic/dl-fptr.c: Likewise.
	* sysdeps/generic/dl-origin.c: Likewise.
	* sysdeps/generic/dl-sysdep.c: Likewise.
	* sysdeps/generic/dl-tls.c: Likewise.
	* sysdeps/generic/ldsodefs.h: Likewise.
	* sysdeps/i386/dl-tls.h: Likewise.
	* sysdeps/unix/sysv/linux/dl-origin.c: Likewise.
	* elf/rtld.c: Likewise.  Export function though _rtld_global_ro.

	* sysdeps/generic/ldsodefs.h (struct rtld_global): Move
	dl_debug_fd to rtld_global_ro.
	* elf/rtld.c: Use GLRO instead of GL for dl_debug_fd.
	* elf/dl-misc.c: Likewise.

	* malloc/malloc.c: Don't call exported interface in the implementation.

	* include/wctype.h: Add libc_hidden_proto for __towctrans.
	* wctype/towctrans.c: Add libc_hidden_def.

	* libio/memstream.c (open_memstream): Use _IO_init with INTUSE.

	* posix/regexec.c (transit_state): Remove unused variable
	next_state.

	* posix/regcomp.c (init_dfa): Use __btowc instead of btowc.

	* sysdeps/generic/ldsodefs.h: Define new structure rtld_global_ro.
	Declare _rtld_global_ro and _rtld_local_ro.  Move members of
	rtld_global structure into the new one if they are modified only
	at startup time.  Define GLRO to access _rtld_global_ro.
	* elf/Versions: Export _rtld_global_ro.
	* elf/dl-close.c: Use GLRO instead of GL where appropriate.
	* elf/dl-conflict.c: Likewise.
	* elf/dl-deps.c: Likewise.
	* elf/dl-dst.h: Likewise.
	* elf/dl-error.c: Likewise.
	* elf/dl-fini.c: Likewise.
	* elf/dl-init.c: Likewise.
	* elf/dl-load.c: Likewise.
	* elf/dl-lookup.c: Likewise.
	* elf/dl-minimal.c: Likewise.
	* elf/dl-open.c: Likewise.
	* elf/dl-profile.c: Likewise.
	* elf/dl-reloc.c: Likewise.
	* elf/dl-runtime.c: Likewise.
	* elf/dl-support.c: Likewise.
	* elf/dl-version.c: Likewise.
	* elf/do-lookup.h: Likewise.
	* elf/rtld.c: Likewise.
	* sysdeps/generic/dl-cache.c: Likewise.
	* sysdeps/generic/dl-origin.c: Likewise.
	* sysdeps/generic/dl-sysdep.c: Likewise.
	* sysdeps/generic/libc-start.c: Likewise.
	* sysdeps/generic/dl-cache.c: Likewise.
	* sysdeps/i386/dl-machine.h: Likewise.
	* sysdeps/i386/setfpucw.c: Likewise.
	* sysdeps/i386/fpu/fclrexcpt.c: Likewise.
	* sysdeps/i386/fpu/fedisblexcpt.c: Likewise.
	* sysdeps/i386/fpu/feenablxcpt.c: Likewise.
	* sysdeps/i386/fpu/feholdexcpt.c: Likewise.
	* sysdeps/i386/fpu/fesetround.c: Likewise.
	* sysdeps/i386/fpu/fsetexcptflg.c: Likewise.
	* sysdeps/i386/fpu/ftestexcept.c: Likewise.
	* sysdeps/unix/sysv/linux/dl-execstat.c: Likewise.
	* sysdeps/unix/sysv/linux/dl-librecon.h: Likewise.
	* sysdeps/unix/sysv/linux/dl-origin.c: Likewise.
	* sysdeps/unix/sysv/linux/dl-osinfo.h: Likewise.
	* sysdeps/unix/sysv/linux/getclktck.c: Likewise.
	* sysdeps/unix/sysv/linux/getpagesize.c: Likewise.
	* sysdeps/unix/sysv/linux/init-first.c: Likewise.
	* sysdeps/unix/sysv/linux/prof-freq.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/dl-librecon.h: Likewise.
	* sysdeps/unix/sysv/linux/i386/sigaction.h: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/getcontext.S: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/swapcontext.S: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/getcontext.S: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/swapcontext.S: Likewise.
	* sysdeps/x86_64/dl-machine.h: Likewise.
	* sysdeps/sparc/sparc64/dl-machine.h: Likewise.
	* sysdeps/sparc/sparc32/dl-machine.h: Likewise.
	* sysdeps/s390/s390-64/dl-machine.h: Likewise.
	* sysdeps/s390/s390-32/dl-machine.h: Likewise.
	* sysdeps/powerpc/powerpc64/dl-machine.h: Likewise.
	* sysdeps/powerpc/powerpc32/dl-machine.c: Likewise.
	* sysdeps/m68k/dl-machine.h: Likewise.
	* sysdeps/ia64/dl-machine.h: Likewise.
	* sysdeps/arm/dl-machine.h: Likewise.
	* sysdeps/alpha/dl-machine.h: Likewise.
	* generic/dl-fptr.c: Likewise.
	* mach/hurd/dl-sysdep.c: Likewise.
	* unix/sysv/linux/ia64/dl-static.c: Likewise.
	* unix/sysv/linux/ia64/getpagesize.c: Likewise.
	* unix/sysv/linux/m68k/getpagesize.c: Likewise.
	* unix/sysv/linux/sparc/sparc32/getpagesize.c: Likewise.

2004-03-04  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/generic/ldsodefs.h: Don't define _dl_name_match_p as inline.
	* elf/dl-misc.c: Define _dl_name_match_p here.
	* elf/dl-open.c (check_libc_caller): Don't use _dl_name_match_p.

	* elf/dl-open.c (dl_open_worker): Check that _dl_open is called
	from the right place.

2004-01-15  Paolo Bonzini  <bonzini@gnu.org>

	* posix/regex.h (REG_STARTEND): Define.
	* posix/regexec.c (regexec): Check for REG_STARTEND.

2004-02-29  Paolo Bonzini  <bonzini@gnu.org>

	* posix/regexec.c (transit_state): Don't handle state == NULL.
	Move state log and backreference management...
	(merge_state_with_log): ... to this function.
	(find_recover_state): New function.
	(check_matching): Use find_recover_state to get a non-NULL
	state when an invalid state is reached.  Compute the amount
	of initial characters to be skipped less conservatively when
	multi-byte character sets are in use.  Do not check
	dfa->nbackref if the state log is NULL.  Initialize err.
	(acquire_init_state_context): Expect err to be initialized.
	Fix spacing.

2004-03-05  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/sparc/sparc32/elf/start.S: Handle PIEs.
	* sysdeps/sparc/sparc64/elf/start.S: Likewise.

2004-03-04  Jakub Jelinek  <jakub@redhat.com>

	* iconv/iconv_prog.c (process_block): Handle omit_invalid.
	If iconv returns EILSEQ with omit_invalid, continue converting
	and return 1 if no other errors are seen.
	(main): Set status to EXIT_FAILURE whenever process_* returns
	nonzero, but only stop processing further files if iy returns
	negative value.

2004-03-03  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/posix_fadvise.c: New file.
	* sysdeps/unix/sysv/linux/x86_64/posix_fadvise64.c: New file.
	* sysdeps/unix/sysv/linux/x86_64/syscalls.list (posix_fadvise64):
	Remove.
	* sysdeps/unix/sysv/linux/alpha/posix_fadvise.c: New file.
	* sysdeps/unix/sysv/linux/alpha/posix_fadvise64.c: New file.
	* sysdeps/unix/sysv/linux/alpha/syscalls.list (posix_fadvise64):
	Remove.
	* sysdeps/unix/sysv/linux/ia64/posix_fadvise.c: New file.
	* sysdeps/unix/sysv/linux/ia64/posix_fadvise64.c: New file.
	* sysdeps/unix/sysv/linux/ia64/syscalls.list (posix_fadvise64):
	Remove.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/posix_fadvise.c: New file.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/posix_fadvise64.c: New
	file.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/syscalls.list: Removed.
	* sysdeps/unix/sysv/linux/s390/s390-64/posix_fadvise.c: New file.
	* sysdeps/unix/sysv/linux/s390/s390-64/posix_fadvise64.c: New file.
	* sysdeps/unix/sysv/linux/s390/s390-64/syscalls.list
	(posix_fadvise64): Remove.
	* sysdeps/unix/sysv/linux/sparc/sparc64/posix_fadvise.c: New file.
	* sysdeps/unix/sysv/linux/sparc/sparc64/posix_fadvise64.c: New file.
	* sysdeps/unix/sysv/linux/sparc/sparc64/syscalls.list
	(posix_fadvise64): Remove.

2004-03-02  Andreas Schwab  <schwab@suse.de>

	* sysdeps/unix/sysv/linux/powerpc/powerpc32/xstat.c: New file.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/fxstat.c: New file.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/lxstat.c: New file.

2004-03-01  Ulrich Drepper  <drepper@redhat.com>

	* nscd/nscd_getgr_r.c (nscd_getgr_r): Add missing initialization
	of return value.
	* nscd/nscd_gethst_r.c (nscd_gethst_r): Likewise.

	* sysdeps/unix/sysv/linux/kernel-features.h: Add support for
	__ASSUME_GETDENTS32_D_TYPE.
	* sysdeps/unix/sysv/linux/getdents.c: For 2.6.4+ kernels use
	getdents syscall again since it provides d_type information.

2004-02-29  Andreas Jaeger  <aj@suse.de>

	* manual/install.texi (Tools for Compilation): Autoconf 2.53 is
	required.
	(Supported Configurations): Add x86_64-*-linux.

2004-02-28  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/i386/i686/memcmp.S: Move table to .rodata.  Patch by HJ Lu.

2004-02-27  Jakub Jelinek  <jakub@redhat.com>

	* elf/rtld.c (dl_main): Adjust l->l_ld of the vDSO by l->l_addr.
	* sysdeps/generic/dl-sysdep.c (_dl_sysdep_start): Only set
	GL(dl_sysinfo) if non-zero.

	* sysdeps/unix/sysv/linux/sysconf.c: Include stdlib.h.

2004-02-26  Ulrich Drepper  <drepper@redhat.com>

	* nss/getXXbyYY_r.c: Pass result also to the nscd_* function.  Don't
	set *result here.
	* nscd/nscd_proto.h: Add new argument for pointer to result pointer
	to all nscd_* functions.
	* nscd/nscd_getgr_r.c (nscd_getgr_r): Add new parameter.  Store result
	pointer in the address provided by the new parameter if successful.
	Otherwise store NULL.  Return zero if no entry found.
	(__nscd_getgrnam_r, __nscd_getgrgid_r): Add new parameter and pass
	it on.
	* nscd/nscd_gethst_r.c (nscd_gethst_r): Add new parameter.  Store
	result pointer in the address provided by the new parameter if
	successful. Otherwise store NULL.  Return zero if no entry found.
	(__nscd_gethostbyname_r, __nscd_gethostbyname2_r,
	__nscd_gethostbyaddr_r): Add new parameter and pass it on.
	* nscd/nscd_getpw_r.c (nscd_getpw_r): Add new parameter.  Store result
	pointer in the address provided by the new parameter if successful.
	Otherwise store NULL.  Return zero if no entry found.
	(__nscd_getpwnam_r, __nscd_getpwuid_r): Add new parameter and pass
	it on.

2004-02-26  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/clock_settime.c (SYSDEP_SETTIME): Set
	retval to -1 on error.

2004-02-26  Ulrich Drepper  <drepper@redhat.com>

	* stdlib/canonicalize.c (__realpath): Simplify.

	* posix/regcomp.c (parse_expression): Avoid duplication in calls
	to build_charclass_op.

2004-02-26  Jakub Jelinek  <jakub@redhat.com>

	* elf/rtld.c (dl_main): Correctly set up l_map_end and l_addr
	in vDSO's link_map, don't assume l_addr == 0.  Set GL(dl_sysinfo)
	from e_entry only if AT_SYSINFO not present and adjust by l_addr.
	Take vDSO into account when inserting rtld into _dl_loaded chain.

2004-02-26  Ulrich Drepper  <drepper@redhat.com>

	* sunrpc/svcauth_des.c (authdes_getucred): Removed fixed limit on
	number of groups in the cache.  Relax the disconnect between the
	interface of authdes_getucred and netname2user a bit.
	* sunrpc/auth_unix.c (authunix_create_default): Don't allocate
	huge arrays on the stack.

	* sysdeps/unix/sysv/linux/sysconf.c (__sysconf): Use the official
	not cancelable interfaces.

2004-02-24  Arnold D. Robbins  <arnold@skeeve.com>

	* posix/regex_internal.c (build_wcs_upper_buffer): Enclose
	`offsets_needed' label in `#ifdef _LIBC' to silence `unused label'
	compiler warning.

2004-02-24  Nelson H.F. Beebe  <beebe@math.utah.edu>

	* posix/regcomp.c (parse_expression): Add cast to (const unsigned
	char *) in calls to `build_charclass_op'.
	* posix/regex_internal.c (build_wcs_buffer): Add cast to char* in call
	to `wcrtomb'.
	* posix/regex_internal.h (bitset_not, bitset_merge, bitset_not_merge,
	bitset_mask, re_string_char_size_a, re_string_wchar_at,
	re_string_elem_size_at): Change to use prototypes.
	(re_string_char_size_at, re_string_wchar_at,
	re_string_elem_size_at): Declare as `internal_function'.

2004-02-25  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/sysconf.c (__sysconf): Handle
	_SC_NGROUPS_MAX.

2004-02-23  Jakub Jelinek  <jakub@redhat.com>

	* wcsmbs/mbrtowc.c (__mbrtowc): Cap s + n at the end of address space.
	* stdlib/Makefile (tests): Add testmb2.
	(testmb2-ENV): New.
	* stdlib/testmb2.c: New test.

2004-02-23  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/posix/getaddrinfo.c (gaih_inet): If _res has not been
	inited yet, try to init it before saving old _res.options.
	* posix/Makefile (xtests): Add bug-ga2.
	(generated): Add bug-ga2.mtrace and bug-ga2-mem.
	(xtests): Depend on bug-ga2-mem.
	($(objpfx)bug-ga2-mem, bug-ga2-ENV): New.
	* posix/bug-ga2.c: New test.

2004-02-22  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/i386/posix_fadvise64.S: Pop register
	content also in case of an overflow in the parameter.
	Reported by Momchil Velikov <velco@fadata.bg>.

2004-02-21  Ulrich Drepper  <drepper@redhat.com>

	* elf/dynamic-link.h (elf_get_dynamic_info): Recognize DF_1_NOW.
	In ld.so, neither DT_FLAGS nor DT_FLAGS_1 must be used.

2004-02-21  Andreas Jaeger  <aj@suse.de>

	* posix/bug-ga1.c: Include <string.h> for memset prototype.

	* elf/dl-load.c (_dl_map_object_from_fd): Fix casts used as lvalue.

	* iconv/gconv_simple.c (internal_ucs4le_loop): Remove cast used as
	lvalue.

2004-02-19  Carlos O'Donell  <carlos@baldric.uwo.ca>

	* sysdeps/generic/framestate.c [__USING_SJLJ_EXCEPTIONS__]
	(__frame_state_for): Set frame_State_for to abort if the compiler
	is using sjlj.
	* sysdeps/generic/unwind-dw2.c: Allow sjlj enabled compilers to
	build the code by removing __USING_SJLJ_EXCEPTIONS__ wrapper.

2004-02-20  Alexandre Oliva  <aoliva@redhat.com>

	* resolv/Versions: Remove semicolon from the end of libresolv's
	GLIBC_2.3.2 version block.
	* Versions.def (libresolv): Add GLIBC_2.3.2.

2004-02-19  Carlos O'Donell  <carlos@baldric.uwo.ca>

	* sysdeps/hppa/fpu/feholdexcpt.c (feholdexcept): Fix order of fp
	status register loads.

2004-02-20  Thorsten Kukuk  <kukuk@suse.de>

	* nscd/nscd.c (termination_handler): Use _exit instead of exit

2004-02-20  Ulrich Drepper  <drepper@redhat.com>

	* nscd/nscd.c (main): Report fork errors.

	* dlfcn/dlsym.c: Get ld.so loading lock before the call into ld.so.
	* dlfcn/dlvsym.c: Likewise.
	* elf/dl-addr.c: Get loading lock while using _dl_loaded data.
	* elf/dl-fini.c: Likewise.
	Patch by Shunichi Sagawa <s-sagawa@jp.fujitsu.com>.

2004-02-20  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/sparc/sparc32/fpu/libm-test-ulps: Add ulps for the
	2003-11-27 atan2 test.

	* sysdeps/powerpc/fpu/bits/mathinline.h (lrint, lrintf): Protect
	with #ifndef __powerpc64__.

	* sysdeps/generic/ldsodefs.h (_dl_argv, _dl_argv_internal): If
	DL_ARGV_NOT_RELRO defined, don't use attribute_relro.
	* sysdeps/alpha/dl-machine.h (DL_ARGV_NOT_RELRO): Remove.
	* sysdeps/ia64/dl-machine.h (DL_ARGV_NOT_RELRO): Remove.
	* sysdeps/sparc/sparc32/dl-machine.h (DL_ARGV_NOT_RELRO): Remove.
	* sysdeps/sparc/sparc64/dl-machine.h (DL_ARGV_NOT_RELRO): Remove.
	* sysdeps/alpha/dl-sysdep.h: New file.
	* sysdeps/ia64/dl-sysdep.h: New file.
	* sysdeps/sparc/dl-sysdep.h: New file.

2004-02-19  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/sparc/sparc32/bits/atomic.h: Add __make_section_unallocated
	for .gnu.linkonce.b.__sparc32_atomic_locks section.
	(__sparc32_atomic_locks): Add __sec_comment at the end of section name.

2004-02-19  Steven Munroe  <sjmunroe@us.ibm.com>

	* sysdeps/generic/libc-start.c [LIBC_START_DISABLE_INLINE] (STATIC):
	Define as static.
	* sysdeps/powerpc/elf/libc-start.c: Define LIBC_START_DISABLE_INLINE
	because gcc does not allow inline of functions that call setjmp.

2004-02-19  Steven Munroe  <sjmunroe@us.ibm.com>

	* sysdeps/powerpc/powerpc64/Makefile: Use -finline-limit.

2004-02-19  Jakub Jelinek  <jakub@redhat.com>

	* elf/rtld.c (_dl_argv): If DL_ARGV_NOT_RELRO defined, don't
	use attribute_relro for _dl_argv.
	* sysdeps/alpha/dl-machine.h (DL_ARGV_NOT_RELRO): Define.
	* sysdeps/ia64/dl-machine.h (DL_ARGV_NOT_RELRO): Define.
	* sysdeps/sparc/sparc32/dl-machine.h (DL_ARGV_NOT_RELRO): Define.
	* sysdeps/sparc/sparc64/dl-machine.h (DL_ARGV_NOT_RELRO): Define.

2004-02-19  Ulrich Drepper  <drepper@redhat.com>

	* libio/iopopen.c (_IO_new_proc_open): It's not kosher to use
	vfork instead of fork.
	* libio/oldiopopen.c (_IO_old_proc_open): Likewise.

	* sysdeps/unix/clock_settime.c (clock_settime): Fix typo which
	prevented system-dependent handling from being used.

2004-02-18  Carlos O'Donell  <carlos@baldric.uwo.ca>

	* test-skeleton.c (main): If set, use environment variable
	TIMEOUTFACTOR to scale test TIMEOUT.

2004-02-18  Ulrich Drepper  <drepper@redhat.com>

	* nscd/nscd_conf.c: Include <stdio_ext.h>.

2004-02-16  Ulrich Drepper  <drepper@redhat.com>

	* stdlib/test-canon.c (do_test): Test realpath(,NULL) in the loop
	as well.

	* stdlib/canonicalize.c (__realpath): Remove unnecessary copy
	operations.

	* nscd/nscd_conf.c (nscd_parse_file): Little optimization.

2004-02-14  Thorsten Kukuk  <kukuk@suse.de>

	* nscd/dbg_log.c (set_logfile): Only save name of logfile,
	don't open it.
	(init_logfile): New function, open logfile if requested.
	* nscd/dbg_log.h: Adjust protoype for set_logfile, add init_logfile.
	* nscd/nscd.c (main): Call init_logfile after forking in background.
	* nscd/nscd_conf.c (nscd_parse_file): Adjust for new set_logfile.

2004-02-16  Ulrich Drepper  <drepper@redhat.com>

	* elf/rtld.c (dl_main): Don't fail execution if file named in
	ld.so.preload is not present [BZ #18].

	* sysdeps/posix/getaddrinfo.c (getaddrinfo): Undo unintended
	changes in last patch.

	* posix/regexec.c (transit_state): Fix typo in commented-out code
	[BZ #6].

	* sysdeps/posix/getaddrinfo.c (match_prefix): Correctly match
	partial bytes [BZ #24].
	* posix/Makefile (tests): Add bug-ga1.
	* posix/bug-ga1.c: New file.

2004-02-13  Steven Munroe  <sjmunroe@us.ibm.com>

	* sysdeps/powerpc/powerpc64/__longjmp-common.S: New file.
	* sysdeps/powerpc/powerpc64/__longjmp.S [NOT_IN_libc](__longjmp):
	Non-versioned __longjmp for rtld-__longjmp.
	[!NOT_IN_libc](__vmx__longjmp): Add VMX reg support and define as
	default version of __longjmp.
	[SHARED && SHLIB_COMPAT (libc, GLIBC_2_3, GLIBC_2_3_4)]
	(__novmx__longjmp): Original version of __longjmp.
	* sysdeps/powerpc/powerpc64/bsd-_setjmp.S [NOT_IN_libc](_setjmp):
	Non-versioned _setjmp for rtld-_setjmp.
	[!NOT_IN_libc](__vmx_setjmp): Branch to __vmx__sigsetjmp and define
	as default version of _setjmp.
	[SHARED && SHLIB_COMPAT (libc, GLIBC_2_3, GLIBC_2_3_4)]
	(__novmx_setjmp): Original version of _setjmp.
	* sysdeps/powerpc/powerpc64/bsd-setjmp.S (__vmxsetjmp): Branch to
	__vmx__sigsetjmp and define as default version of setjmp.
	[SHARED && SHLIB_COMPAT (libc, GLIBC_2_3, GLIBC_2_3_4)]
	(__novmxsetjmp): Original version of setjmp.
	* sysdeps/powerpc/powerpc64/setjmp-common.S: New file.
	* sysdeps/powerpc/powerpc64/setjmp.S [NOT_IN_libc](__setjmp):
	Non-versioned __sigsetjmp for rtld-setjmp.
	[!NOT_IN_libc](__vmx__sigsetjmp): Add VMX reg support and define
	as default version of __sigsetjmp.
	[SHARED && SHLIB_COMPAT (libc, GLIBC_2_3, GLIBC_2_3_4)]
	(__novmx__sigsetjmp): Original version of __sigsetjmp.

	* sysdeps/powerpc/powerpc32/__longjmp-common.S: New File
	* sysdeps/powerpc/powerpc32/__longjmp.S [NOT_IN_libc](__longjmp):
	Non-versioned __longjmp for rtld-__longjmp.
	[!NOT_IN_libc](__vmx__longjmp): Add VMX reg support and define as
	default version of __longjmp.
	[SHARED && SHLIB_COMPAT (libc, GLIBC_2_0, GLIBC_2_3_4)]
	(__novmx__longjmp): Original version of __longjmp.
	* sysdeps/powerpc/powerpc32/bsd-_setjmp.S [NOT_IN_libc](_setjmp):
	Non-versioned _setjmp for rtld-_setjmp.
	[!NOT_IN_libc](__vmx_setjmp): Branch to __vmx__sigsetjmp and define
	as default version of _setjmp.
	[SHARED && SHLIB_COMPAT (libc, GLIBC_2_0, GLIBC_2_3_4)]
	(__novmx_setjmp): Original version of _setjmp.
	* sysdeps/powerpc/powerpc32/bsd-setjmp.S (__vmxsetjmp): Branch to
	__vmx__sigsetjmp and define as default version of setjmp.
	[SHARED && SHLIB_COMPAT (libc, GLIBC_2_0, GLIBC_2_3_4)]
	(__novmxsetjmp): Original version of setjmp.
	* sysdeps/powerpc/powerpc32/fpu/__longjmp-common.S: New file.
	* sysdeps/powerpc/powerpc32/fpu/__longjmp.S [NOT_IN_libc](__longjmp):
	Non-versioned __longjmp for rtld-__longjmp.
	[!NOT_IN_libc](__vmx__longjmp): Add VMX reg support and define as
	default version of __longjmp.
	[SHARED && SHLIB_COMPAT (libc, GLIBC_2_0, GLIBC_2_3_4)]
	(__novmx__longjmp): Original version of __longjmp.
	* sysdeps/powerpc/powerpc32/fpu/setjmp-common.S: New file.
	* sysdeps/powerpc/powerpc32/fpu/setjmp.S [NOT_IN_libc](__setjmp):
	Non-versioned __sigsetjmp for rtld-setjmp.
	[!NOT_IN_libc](__vmx__sigsetjmp): Add VMX reg support and define
	as default version of __sigsetjmp.
	[SHARED && SHLIB_COMPAT (libc, GLIBC_2_0, GLIBC_2_3_4)]
	(__novmx__sigsetjmp): Original version of __sigsetjmp.
	* sysdeps/powerpc/powerpc32/setjmp-common.S: New file.
	* sysdeps/powerpc/powerpc32/setjmp.S [NOT_IN_libc](__setjmp):
	Non-versioned __sigsetjmp for rtld-setjmp.
	[!NOT_IN_libc](__vmx__sigsetjmp): Add VMX reg support and define
	as default version of __sigsetjmp.
	[SHARED && SHLIB_COMPAT (libc, GLIBC_2_0, GLIBC_2_3_4)]
	(__novmx__sigsetjmp): Original version of __sigsetjmp.

	* sysdeps/powerpc/Dist: New File.
	* sysdeps/powerpc/Makefile (sysdep_routines): Add novmx-longjmp.c
	and novmx-sigjmp.c
	* sysdeps/powerpc/Versions (libc): To GLIBC_2.3_4 add _longjmp,
	__sigsetjmp, _setjmp, longjmp, and setjmp. To GLIBC_PRIVATE add
	__novmx__libc_longjmp, __novmx__libc_siglongjmp, __vmx__libc_longjmp,
	and __vmx__libc_siglongjmp.
	* sysdeps/powerpc/bits/setjmp.h: Define JB_VRSAVE, JB_VRS, and adjust
	JB_SIZE to add VMX regs to __jmp_buf.
	* sysdeps/powerpc/longjmp.c: New file.
	* sysdeps/powerpc/novmxsetjmp.h: New file.
	* sysdeps/powerpc/novmx-longjmp.c: New file.
	* sysdeps/powerpc/novmx-sigjmp.c: New file.
	* sysdeps/powerpc/sigjmp.c: New file.

2004-02-13  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/powerpc/powerpc64/fpu/s_llrintf.c (__lrintf, lrintf):
	Define.
	(__lrintl, lrintl): Remove.
	* sysdeps/powerpc/powerpc64/fpu/s_llrint.c (__lrint): Fix a typo in
	strong_alias spelling.
	* sysdeps/powerpc/powerpc64/fpu/s_lrintf.S: Remove.
	* sysdeps/powerpc/powerpc64/fpu/s_lrint.S: New file.

2004-02-12  Ulrich Drepper  <drepper@redhat.com>

	* posix/getopt.h: Add some non-gcc support.  Patch by Aharon Robbins.

2004-02-12  Mark Brown  <bmark@us.ibm.com>

	* sysdeps/ia64/fpu/e_fmodf.S: Added text of Intel license.

2004-02-12  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/powerpc/fpu/s_lrint.c: Move to...
	* sysdeps/powerpc/powerpc32/fpu/s_lrint.c: ... here.
	* sysdeps/powerpc/fpu/s_llrint.c: Move to...
	* sysdeps/powerpc/powerpc32/fpu/s_llrint.c: ... here.
	* sysdeps/powerpc/fpu/s_llrintf.c: Move to...
	* sysdeps/powerpc/powerpc32/fpu/s_llrintf.c: ... here.
	* sysdeps/powerpc/powerpc64/fpu/s_llrint.c: New file.
	* sysdeps/powerpc/powerpc64/fpu/s_lrintf.S: New file.
	* sysdeps/powerpc/powerpc64/fpu/s_llrintf.c: New file.

	* math/libm-test.inc (lrint_test): Add new test.
	(llrint_test, lround_test, llround_test): Likewise.
	* sysdeps/ieee754/ldbl-128/s_lroundl.c (__lroundl): Fix special case
	with result taking up 48 bits.
	* sysdeps/ieee754/ldbl-128/s_lrintl.c (__lrintl): Likewise.
	* sysdeps/ieee754/ldbl-128/s_llroundl.c (__llroundl): Likewise.
	* sysdeps/ieee754/ldbl-96/s_llrintl.c (__llrintl): Fix special case
	with result taking up 31 bits.

2004-02-12  Ulrich Drepper  <drepper@redhat.com>

	* locale/programs/locale.c (show_locale_vars): Don't print a value
	for LANG if it is not set.

2004-02-11  Jakub Jelinek  <jakub@redhat.com>

	* posix/regexec.c (check_node_accept_bytes): Return 0 if char_len is 0.
	(find_collation_sequence_value): Don't look beyond end of
	SYMB_EXTRAMB table.
	* posix/Makefile (tests): Add bug-regex23.
	(bug-regex23-ENV): New.
	* posix/bug-regex23.c: New file.

2004-02-10  Roland McGrath  <roland@frob.com>

	* sysdeps/mach/hurd/times.c (__times): Use union instead of cast.
	* sysdeps/mach/hurd/sendmsg.c (__libc_sendmsg): Likewise.

	* sysdeps/mach/hurd/configure.in: Move `retcode' check to ...
	* sysdeps/mach/configure.in: ... here.
	* sysdeps/mach/hurd/configure: Regenerated.
	* sysdeps/mach/configure.in: Regenerated.

2004-02-10  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/generic/setenv.c (__add_to_environ): Don't let the
	temporary copies of the variables accumulate on the stack.

	* stdio-common/_i18n_number.h: Finish last patch.

2004-02-09  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/i386/i686/memcmp.S: New file.  Patch by HJ Lu.

2003-12-05  Roland McGrath  <roland@redhat.com>

	* sysdeps/unix/sysv/linux/i386/syscalls.list: Turn vm86 into vm86old
	for vm86@GLIBC_2.0 version.  Add new vm86@GLIBC_2.3.4.
	* sysdeps/unix/sysv/linux/i386/Versions (libc: GLIBC_2.3.4): Add vm86.
	* sysdeps/unix/sysv/linux/i386/sys/vm86.h: Update vm86 prototype.

2004-02-09  Ulrich Drepper  <drepper@redhat.com>

	* nis/ypclnt.c: Cleanup last patch.

2004-02-09  Andreas Jaeger  <aj@suse.de>

	* configure.in: Remove glibcbug creation.
	* configure: Regenerated.

	* sysdeps/x86_64/fpu/s_copysignf.S: Only load 4 bytes.

2004-02-03  Thorsten Kukuk  <kukuk@suse.de>

	* nis/ypclnt.c (__yp_bind_client_create): New, small chunk
	of duplicated code from __yp_bind.
	(__yp_bind_file): New, binding dir code from __yp_bind.
	(__yp_bind_client_create): New, ypbind code from __yp_bind.
	(__ypclnt_call): New, make NIS query.
	(do_ypcall): At first use cached data, then try data from
	binding directory, after this ask ypbind for a working ypserv.
	Based on a patch from Jeff Bastian <jmbastia@ti.com> and
	Chris Barrera <cbarrera@ti.com>

2004-01-19  Roland McGrath  <roland@redhat.com>

	* configure.in: Don't set CCVERSION.
	* configure: Regenerated.
	* glibcbug.in: File removed.
	* Makefile (install-bin-script): Remove glibcbug.
	(glibcbug): Target removed.
	(distclean-1): Don't rm glibcbug.
	(distribute): Remove glibcbug.in.

2004-02-09  Roland McGrath  <roland@redhat.com>

	* time/tzset.c (tzset_internal): Cap hour in POSIX $TZ rule format to
	24, not 23.

2004-01-29  Roland McGrath  <roland@redhat.com>

	* io/ftwtest-sh: Use $tmp consistently, not literal /tmp.
	Reported by Kevin P. Fleming <kpfleming@backtobasicsmgmt.com>.

2004-02-09  Ulrich Drepper  <drepper@redhat.com>

	* libio/genops.c (_IO_cleanup): Do not use locking when flushing
	the buffers.  Some thread might be using a stream.

2004-02-09  Andreas Jaeger  <aj@suse.de>

	* sysdeps/x86_64/memcpy.S: Fix alignment [BZ #7].
	Patch by Jan Beulich <jbeulich@novell.com>.

2004-02-09  Andreas Schwab  <schwab@suse.de>

	* include/rpc/rpc.h: Declare thread variables with their correct type.
	* sunrpc/clnt_perr.c: Don't cast thread variables.
	* sunrpc/clnt_raw.c: Likewise.
	* sunrpc/clnt_simp.c: Likewise.
	* sunrpc/key_call.c: Likewise.
	* sunrpc/svcauth_des.c: Likewise.
	* sunrpc/svc.c: Likewise.
	* sunrpc/svc_raw.c: Likewise.
	* sunrpc/svc_simple.c: Likewise.

2004-02-09  Ulrich Drepper  <drepper@redhat.com>

	* stdio-common/_i18n_number.h: Support printing localized decimal
	point and thousand separator.
	* wctype/wctrans.c: Add __wctrans alias.
	* include/wctype.h: Declare __wctrans.
	Based on a patch by Hamed Malek.

	* sysdeps/i386/fpu/fclrexcpt.c (__feclearexcept): Don't touch bits
	other than the status bits [BZ #10].

2004-02-08  Ulrich Drepper  <drepper@redhat.com>

	Make stream locking operations really work.
	* misc/Makefile (CFLAGS-mntent_r.c): Define.
	* shadow/Makefile (CFLAGS-fgetspent_r.c): Define.
	(CFLAGS-putspent.c): Define.
	* grp/Makefile (CFLAGS-fgetgrent_r.c): Define.
	(CFLAGS-putgrent.c): Define.
	* pwd/Makefile (CFLAGS-fgetpwent_r.c): Define.
	Reported by Shunichi Sagawa <s-sagawa@jp.fujitsu.com>.

	* elf/dl-load.c (lose): Use noinline attribute instead of silly
	alloca to prevent inlining.
	* elf/dl-runtime.c (fixup): Likewise.
	(profile_fixup): Likewise.

	* stdio-common/printf_size.c: Undo parts of patch from 2000-2-11.
	Initialize width correctly.

2004-02-07  Andreas Jaeger  <aj@suse.de>

	* iconv/gconv_simple.c (ucs4le_internal_loop): Remove cast used as
	lvalue.
	(internal_ucs4le_loop_single): Likewise.
	(ucs4_internal_loop): Likewise.
	(BODY): Likewise.
	(internal_ucs4_loop_single): Likewise.
	* iconvdata/iso8859-1.c (BODY): Likewise.
	* iconvdata/cp1255.c (EMIT_SHIFT_TO_INIT): Likewise.
	* iconvdata/cp1258.c (EMIT_SHIFT_TO_INIT): Likewise.
	* iconvdata/gb18030.c (BODY): Likewise.
	* iconvdata/armscii-8.c (BODY): Likewise.
	* stdlib/msort.c (msort_with_tmp): Likewise.

	* iconv/gconv_open.c (__gconv_open): Remove conditional expression
	as lvalue.

2004-02-06  Steven Munroe  <sjmunroe@us.ibm.com>

	* sysdeps/powerpc/powerpc32/dl-machine.c: Declare __cache_line_size as
	weak extern.
	(__elf_machine_runtime_setup): Invalidate the instruction cache over
	the whole range of the PLT.

2004-02-06  Andreas Schwab  <schwab@suse.de>

	* posix/regcomp.c (build_range_exp): Fix off-by-one.
	(parse_bracket_exp): Likewise.

2004-02-05  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/powerpc/powerpc32/kernel_stat.h: Define
	_HAVE_STAT_NSEC and _HAVE_STAT64_NSEC.  Patch by Anton Blanchard.

2004-02-02  Paolo Bonzini  <bonzini@gnu.org>

	* posix/regexec.c (check_matching): Add P_MATCH_FIRST parameter.
	(re_search_internal): Pass new parameter to check_matching.
	(check_matching): Unless a parenthesized group is found at the
	beginning of the regexp, advance P_MATCH_FIRST until we entered
	a state different from the initial state.

2004-02-01  Ulrich Drepper  <drepper@redhat.com>

	* math/libm-test.inc (lround_test): Add new test.
	(llround_test): Likewise.
	(lrint_test): Likewise.
	(llrint_test): Likewise.
	* sysdeps/ieee754/dbl-64/s_lround.c (__lround): Fix special case
	with result taking up 20 bits.
	* sysdeps/ieee754/dbl-64/s_lrint.c (__lrint): Likewise.
	* sysdeps/ieee754/dbl-64/s_llrint.c (__llrint): Likewise..
	* sysdeps/ieee754/ldbl-96/s_lroundl.c (__lroundl): Fix special
	case with result taking up 31 bits.
	* sysdeps/ieee754/ldbl-96/s_lrintl.c (__lrintl): Likewise.

	* po/nl.po: Update from translation team.

2004-01-30  Andreas Schwab  <schwab@suse.de>

	* sysdeps/unix/sysv/linux/ia64/bits/siginfo.h (ILL_BREAK,
	FPE_DECOVF, FPE_DECDIV, FPE_DECERR, FPE_INVASC, FPE_INVDEC,
	SEGV_PSTKOVF): Remove underscore prefix from definition.

2004-01-28  Paolo Bonzini  <bonzini@gnu.org>

	Merge regex changes in gawk.
	* posix/regcomp.c (build_range_exp) [!_LIBC]: Check validity
	of collation elements.
	* posix/regex.c: Include limits.h.
	* posix/regex.h: Document REG_ECOLLATE correctly.
	* posix/regex_internal.h [!_LIBC && !ENABLE_NLS]: Disable NLS.

2004-01-24  Andreas Jaeger  <aj@suse.de>

	* malloc/obstack.h: Import gnulib version.
	* malloc/obstack.c: Likewise.

2004-01-26  David Mosberger  <davidm@hpl.hp.com>

	* elf/link.h (struct dl_phdr_info): Fix typo in comment.
	* elf/rtld.c (dl_main): After incrementing dl_nloaded, also
	increment dl_load_adds.
	* elf/dl-iteratephdr.c (__dl_iterate_phdr): Replace GL(dl_load_subs)
	with equivalent GL(dl_load_adds - GL(dl_nloaded).
	(dl_iterate_phdr): Likewise.
	* elf/dl-close.c (_dl_close): Delete increment of GL(dl_load_subs).
	* elf/dl-support.c: Remove global variable _dl_load_subs.
	* sysdeps/generic/ldsodefs.h (struct rtld_global): Remove
	_dl_load_subs member.

2004-01-27  Jakub Jelinek  <jakub@redhat.com>

	* elf/rtld.c (_dl_start_final): Don't set l_relro_* here.
	(_dl_start): And neither here.
	(dl_main): Set GL(dl_loaded)->l_relro_* and
	GL(dl_rtld_map)->l_relro_*.

2004-01-23  David Mosberger  <davidm@hpl.hp.com>

	* sysdeps/generic/ldsodefs.h (struct rtld_global): Add members
	_dl_load_adds and _dl_load_subs.
	* elf/dl-support.c (_dl_load_adds): New variable.
	(_dl_load_subs): Likewise.
	* elf/dl-object.c (_dl_new_object): Increment dl_load_adds.
	* elf/dl-close.c (_dl_close): Increment dl_load_subs.
	* elf/link.h (struct dl_phdr_info): Add members dlpi_adds and
	dlpi_subs.
	* include/link.h: Likewise.
	* elf/dl-iteratephdr.c (__dl_iterate_phdr): Initialize dlpi_adds
	and dlpi_subs members.
	(dl_iterate_phdr): Likewise.
	* elf/tst-dlmodcount.c: New file.
	* elf/Makefile (distribute): Mention tst-dlmodcount.c.
	(tests): If build-shared, mention tst-dlmodcount.
	($(objpfx)tst-dlmodcount): If build-shared, build and
	run tst-dlmodcount.

2004-01-22  Jakub Jelinek  <jakub@redhat.com>

	* elf/dl-reloc.c (_dl_relocate_object): Move PT_GNU_RELRO protection
	into...
	(_dl_protect_relro): New routine.
	* sysdeps/generic/ldsodefs.h (_dl_protect_relro): New prototype.
	* elf/rtld.c (_dl_start_final): Copy l_relro_addr and l_relro_size
	from bootstrap_map.
	(_dl_main): Don't set GL(_dl_loaded)->l_relro_{addr,size} here.
	Call _dl_protect_relro for libraries if prelinking.

2004-01-23  Richard Henderson  <rth@redhat.com>

	* Versions.def (libm): Replace GLIBC_2.3.3 with GLIBC_2.3.4.
	* sysdeps/alpha/fpu/Versions (libm): Likewise.
	* sysdeps/alpha/fpu/cfloat-compat.h (cfloat_versions): Likewise.
	* sysdeps/alpha/fpu/s_clog10f.c (clog10f): Likewise.

2004-01-22  Andreas Jaeger  <aj@suse.de>

	* sysdeps/ieee754/dbl-64/e_pow.c (log2): Rename to my_log2 to
	avoid warnings for builtin function log2.

	* sysdeps/unix/sysv/linux/x86_64/setcontext.S: Add proper unwind
	information.

2004-01-20  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/sys/epoll.h: Add EPOLLONESHOT.
	* sysdeps/unix/sysv/linux/x86_64/sys/epoll.h: Likewise.
	Patch by Davide Libenzi.

	* sysdeps/unix/sysv/linux/kernel-features.h: Define
	__ASSUME_NO_CLONE_DETACHED for 2.6.2+ kernels.

	* catgets/Makefile ($(objpfx)de.msg): Run sed in C locale.

	* sysdeps/unix/sysv/linux/readahead.c (__readahead): Use off64_t
	instead of loff_t.  Include <fcntl.h>.
	* sysdeps/unix/sysv/linux/alpha/bits/fcntl.h: Add readahead prototype.
	* sysdeps/unix/sysv/linux/arm/bits/fcntl.h: Likewise.
	* sysdeps/unix/sysv/linux/cris/bits/fcntl.h: Likewise.
	* sysdeps/unix/sysv/linux/hppa/bits/fcntl.h: Likewise.
	* sysdeps/unix/sysv/linux/i386/bits/fcntl.h: Likewise.
	* sysdeps/unix/sysv/linux/ia64/bits/fcntl.h: Likewise.
	* sysdeps/unix/sysv/linux/m68k/bits/fcntl.h: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/bits/fcntl.h: Likewise.
	* sysdeps/unix/sysv/linux/s390/bits/fcntl.h: Likewise.
	* sysdeps/unix/sysv/linux/sh/bits/fcntl.h: Likewise.
	* sysdeps/unix/sysv/linux/sparc/bits/fcntl.h: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/bits/fcntl.h: Likewise.

	* elf/dl-load.c: Don't add attribute_relro to max_dirnamelen.

	* sysdeps/generic/inttypes.h: Fix PRI*FAST{16,32} macros.

2003-12-31  Bruno Haible  <bruno@clisp.org>

	* iconvdata/iso_6937-2.c (to_ucs4): Map 0x7E to U+007E, not U+203E.
	Map 0xA6 to U+0023. Map 0xA8 to U+00A4.
	(to_ucs4_comb): Map 0xC5 0x20 to U+00AF.
	(from_ucs4): Map U+00ED to 0xC2 0x69, not 0xC2 0xE9.
	(BODY for TO_LOOP): Don't map U+02DC. Map U+02DD to 0xCD 0x20, not
	0x00 0x20. Don't map U+2500..U+25E3.

2004-01-19  Jakub Jelinek  <jakub@redhat.com>

	* posix/regexec.c (get_subexp): Remove bkref_str variable.
	Extend buffers if needed before comparisons.
	(get_subexp_sub): Handle clean_state_log_if_needed failure.

2004-01-17  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/i386/i486/bits/atomic.h (atomic_add): Fix test for using
	atomic_decrement.  Patch by Davin McCall.

2004-01-13  Daniel Jacobowitz  <drow@mvista.com>

	* sysdeps/powerpc/nofpu/sim-full.c (__sim_exceptions)
	(__sim_disabled_exceptions, __sim_round_mode): Declare with
	hidden data and nocommon.
	* sysdeps/powerpc/nofpu/soft-supp.h (__sim_exceptions)
	(__sim_disabled_exceptions, __sim_round_mode): Use
	libc_hidden_proto.
	* sysdeps/powerpc/soft-fp/sfp-machine.h (__sim_exceptions)
	(__sim_disabled_exceptions, __sim_round_mode): Likewise.

2004-01-16  Ulrich Drepper  <drepper@redhat.com>

	* elf/elf.h: Define PT_IA_64_HP_OPT_ANOT, PT_IA_64_HP_HSL_ANOT, and
	PT_IA_64_HP_STACK.

2004-01-16  Richard Henderson  <rth@redhat.com>

	* include/unistd.h (__libc_enable_secure): Mark attribute_relro.
	(__libc_enable_secure_internal): Likewise.

	* elf/dl-load.c: Don't declare __libc_stack_end.
	* sysdeps/generic/libc-start.c: Likewise.
	* sysdeps/unix/sysv/linux/dl-execstack.c: Likewise.
	* sysdeps/generic/segfault.c: Likewise.  Include ldsodefs.h.
	* sysdeps/generic/backtrace.c: Likewise.

2004-01-15  Ulrich Drepper  <drepper@redhat.com>

	* Versions.def: Add GLIBC_2.3.4.

2004-01-15  Richard Henderson  <rth@redhat.com>

	* sysdeps/unix/alpha/sysdep.h: Revert last change.

2004-01-15  Richard Henderson  <rth@redhat.com>

	* sysdeps/alpha/dl-machine.h (RTLD_START): Use _dl_argv_internal.

	* sysdeps/unix/alpha/sysdep.h [PIC] (SYSCALL_ERROR_HANDLER): Use
	!samegp relocation.

2004-01-15  Richard Henderson  <rth@redhat.com>

	* sysdeps/unix/sysv/linux/alpha/Makefile [stdlib]: Process
	ucontext-offsets.sym.
	* sysdeps/unix/sysv/linux/alpha/getcontext.S: New file.
	* sysdeps/unix/sysv/linux/alpha/makecontext.S: New file.
	* sysdeps/unix/sysv/linux/alpha/setcontext.S: New file.
	* sysdeps/unix/sysv/linux/alpha/swapcontext.S: New file.
	* sysdeps/unix/sysv/linux/alpha/ucontext-offsets.sym: New file.

2004-01-15  Richard Henderson  <rth@redhat.com>

	* sysdeps/unix/sysv/linux/alpha/rt_sigaction.S: Prefix stubs with
	__syscall_, move nop inside, adjust users by +4.

2004-01-14  Steven Munroe  <sjmunroe@us.ibm.com>

	* include/libc-symbols.h [HAVE_ASM_GLOBAL_DOT_NAME]
	(_symbol_version): Use C_SYMBOL_DOT_NAME to create '.'ed symbols.
	(_default_symbol_version): Use C_SYMBOL_DOT_NAME to create '.'ed
	symbols.
	* sysdeps/powerpc/Makefile: Add rtld-global-offsets.sym to
	gen-as-const-headers.
	* sysdeps/powerpc/elf/rtld-global-offsets.sym: New file.
	* sysdeps/powerpc/sysdep.h: Define v# symbols for vector registers.
	Define PPC_FEATURE_* masks for Aux Vector AT_HWCAP.
	* sysdeps/unix/sysv/linux/kernel-features.h
	(__ASSUME_SWAPCONTEXT_SYSCALL): Define for PPC and 2.6.0 kernels.
	* sysdeps/unix/sysv/linux/powerpc/sys/ucontext.h [!__WORDSIZE == 32]:
	Declare mcontext_t inline and include altivec state for 64-bit.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/Versions: Add GLIBC_2.3.4
	versions for setcontext, getcontext, and swapcontext.

	* sysdeps/unix/sysv/linux/powerpc/powerpc64/Versions: Add GLIBC_2.3.4
	versions for setcontext, getcontext, swapcontext, and makecontext.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/getcontext.S
	(__getcontext):  Upgrade to save Altivec regs and version GLIBC_2_3_4.
	[SHLIB_COMPAT (libc, GLIBC_2_3, GLIBC_2_3_4)] (__novec_getcontext):
	Compatible with GLIBC_2.3.3 release.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/makecontext.S
	(__makecontext): Use parm save area instead of compiler_dw to hold
	context pointer.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/setcontext.S
	(__setcontext):  Upgrade to restore Altivec regs and version
	GLIBC_2_3_4.
	[SHLIB_COMPAT (libc, GLIBC_2_3, GLIBC_2_3_4)] (__novec_setcontext):
	Compatible with GLIBC_2.3.3 release.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/swapcontext.S
	(__swapcontext): Upgrade to swap Altivec regs and version GLIBC_2_3_4.
	[SHLIB_COMPAT (libc, GLIBC_2_3, GLIBC_2_3_4)] (__novec_swapcontext):
	Compatible with GLIBC_2.3.3 release.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/ucontext_i.h
	(SIGCONTEXT_V_REGS_PTR, SIGCONTEXT_V_RESERVE): Defined.

2004-01-12  Steven Munroe  <sjmunroe@us.ibm.com>

	* sysdeps/unix/sysv/linux/powerpc/powerpc32/Versions: Add GLIBC_2.3.4
	versions for setcontext, getcontext, swapcontext, and makecontext.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/getcontext.S
	(__getcontext):  Upgrade to save Altivec regs and version GLIBC_2_3_4.
	[SHLIB_COMPAT (libc, GLIBC_2_3_3, GLIBC_2_3_4)] (__novec_getcontext):
	Compatible with GLIBC_2.3.3 release.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/makecontext.S
	(__makecontext): Upgrade to align for Altivec regs and version
	GLIBC_2_3_4.
	[SHLIB_COMPAT (libc, GLIBC_2_3_3, GLIBC_2_3_4)] (__novec_makecontext):
	Compatible with GLIBC_2.3.3 release.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/setcontext.S
	(__setcontext):  Upgrade to restore Altivec regs and version
	GLIBC_2_3_4.
	[SHLIB_COMPAT (libc, GLIBC_2_3_3, GLIBC_2_3_4)] (__novec_setcontext):
	Compatible with GLIBC_2.3.3 release.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/swapcontext.S
	(__swapcontext): Upgrade to swap Altivec regs and version GLIBC_2_3_4.
	[SHLIB_COMPAT (libc, GLIBC_2_3_3, GLIBC_2_3_4)]
	(__novec_swapcontext): Compatible with GLIBC_2.3.3 release.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/ucontext_i.h:
	(_UC_VSCR, _UC_VRSAVE): Define.
	(_FRAME_BACKCHAIN, _FRAME_LR_SAVE,_FRAME_PARM_SAVE1,_FRAME_PARM_SAVE2,
	_FRAME_PARM_SAVE3, _FRAME_PARM_SAVE4): Defined.

2004-01-15  Ulrich Drepper  <drepper@redhat.com>

	* elf/rtld.c: Handle platforms with HP_TIMING_NONAVAIL defined.

2004-01-16  Alfred M. Szmidt  <ams@kemisten.nu>

	* sysdeps/generic/dl-execstack.c (_dl_make_stack_executable): Adjust
	parameter type.

2004-01-15  Ulrich Drepper  <drepper@redhat.com>

	* elf/elf.h: Fix typo in comment.

	* sysdeps/generic/dl-sysdep.c: Initialize __libc_stack_end.
	* elf/rtld.c: Initialize _dl_argv to allow aliasing.

	* resolv/resolv.h: Add RES_USEBSTRING.
	* resolv/res_debug.c (p_option): Add handling for RES_USE_INET6,
	RES_ROTATE, RES_NOCHECKNAME, and RES_USEBSTRING.
	* resolv/res_init.c (res_setioptions): Recognize ip6-bytestring.
	* resolv/nss_dns/dns-host.c (_nss_dns_gethostbyaddr_r): Only perform
	bytestring IPv6 lookup with RES_USEBSTRING option is selected.
	Otherwise use the two nibble formats.

2004-01-14  Ulrich Drepper  <drepper@redhat.com>

	* configure.in: Define HAVE_Z_RELRO if the linker supports -z relro.
	* config.h.in: Add entry for HAVE_Z_RELRO.
	* include/libc-symbols.h: Define attribute_relro.
	* elf/dl-load.c: Add attribute_relro to env_path_list, capstr, ncapstr,
	max_capstrlen, and max_dirnamelen definitions.
	* elf/rtld.c: Add attribute_relro to _dl_argc, _dl_argv, _dl_skip_args,
	load_time, start_time, library_path, preloadlist, version_info,
	any_debug.
	Remove rtld_total_time.  Make it a local variable.  Pass pointer to
	it to print_statistics.  Change print_statistics accordingly.
	* sysdeps/generic/dl-sysdep.c: Add attribute_relro to _dl_auxv.  Use
	attribute_relro instead of explicitly assigning variable to the
	.data.rel.ro section for __libc_enable_secure and __libc_stack_end.
	* sysdeps/generic/ldsodefs.h: Declare __libc_stack_end, _dl_argc,
	_dl_argv, _dl_argv_internal with attribute_relro.

2004-01-13  Segher Boessenkool  <boessen@de.ibm.com>

	* Makerules (gen-as-const): Don't silently continue on failure.

2004-01-14  Steven Munroe  <sjmunroe@us.ibm.com>

	* sysdeps/generic/dl-sysdep.c: Define __libc_stack_end with
	rtld_hidden_data_def.

2004-01-14  Ulrich Drepper  <drepper@redhat.com>

	* libio/libio.h: Add const to function tables types.
	* libio/libioP.h: Likewise.
	* login/utmp-private.h: Likewise.
	* libio/fileops.c: Add const to jump table variable definition.
	* libio/genops.c: Likewise.
	* libio/iofopncook.c: Likewise.
	* libio/iopopen.c: Likewise.
	* libio/memstream.c: Likewise.
	* libio/obprintf.c: Likewise.
	* libio/oldfileops.c: Likewise.
	* libio/oldiopopen.c: Likewise.
	* libio/strops.c: Likewise.
	* libio/vsnprintf.c: Likewise.
	* libio/vswprintf.c: Likewise.
	* libio/wfileops.c: Likewise.
	* libio/wstrops.c: Likewise.
	* login/getutent_r.c: Likewise.
	* login/getutid_r.c Likewise.
	* login/getutline_r.c: Likewise.
	* sysdeps/generic/utmp_file.c: Likewise.

2004-01-09  Bruno Haible  <bruno@clisp.org>

	* intl/gmo.h (MO_REVISION_NUMBER_WITH_SYSDEP_I): New definition.
	* intl/loadmsgcat.c (get_sysdep_segment_value): Handle "I".
	(_nl_load_domain): Treat major revision 1 like major revision 0.

2004-01-11  Bruno Haible  <bruno@clisp.org>

	* stdio-common/vfprintf.c (vfprintf): Disallow the 'I' flag after
	width or precision has been seen.

2004-01-08  Bruno Haible  <bruno@clisp.org>

	* intl/loadmsgcat.c (_nl_load_domain): When a string pair uses a system
	dependent segment not known to this version of the library, ignore
	the string pair instead of crashing.

2004-01-13  Ulrich Drepper  <drepper@redhat.com>

	* configure.in: Rewrite test to give gcc to clean up after itself.
	Patch by Greg Schafer.

	* posix/regex.c: Support crappy compilers and platforms which have
	problems with alloca.
	* posix/regex_internal.h: Likewise.
	Patch by Paolo Bonzini.

2004-01-12  Paolo Bonzini  <bonzini@gnu.org>

	* posix/regcomp.c [_LIBC && !RE_ENABLE_I18N]:
	Drop code to support this, it is never true.
	(build_range_exp) [!_LIBC]: Do not create a range
	in MBCSET for a single-byte character set.
	(build_range_exp) [_LIBC]: Do not create a range
	in MBCSET for a single-byte character set without
	collation elements.
	(init_dfa): Do not conditionalize on _LIBC, it
	just makes the code less clear.
	(parse_bracket_exp): Use NON_MATCH variable in
	addition to "mbcset->non_match", not as an
	alternative.
	(build_charclass_op): rename NOT parameter to
	NON_MATCH, use it instead of declaring a variable.
	(parse_bracket_exp) [!_LIBC]: Pass NULL for MBCSET
	if the character set is single-byte.

2004-01-14  Jakub Jelinek  <jakub@redhat.com>

	* posix/regcomp.c (peek_token_bracket): Check remaining
	string length before re_string_peek_byte (x, 1).
	(parse_bracket_symbol): Likewise.
	* posix/regex_internal.h (re_string_is_single_byte_char): Return
	true at last byte in the string.
	* posix/bug-regex22.c (main): Add new test.

2004-01-13  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/generic/dl-sysdep.c: Move __libc_enable_secure into
	.data.rel.ro.

	* sysdeps/x86_64/dl-machine.h: Include <tls.h>.

	* elf/rtld.c (_dl_start_final): Initialze __libc_stack_end here.
	* sysdeps/generic/dl-sysdep.c: Define __libc_stack_end with
	rtld_hidden_def and move into .data.rel.ro section.
	* sysdeps/generic/ldsodefs.h: Declare __libc_stack_end with
	rtld_hidden_proto.
	* sysdeps/generic/libc-start.c: Only initialize __libc_stack_end here
	if !SHARED.

2004-01-13  Richard Henderson  <rth@redhat.com>

	* sysdeps/unix/sysv/linux/alpha/rt_sigaction.S: Fix typo.

2004-01-13  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/dl-execstack.c
	(_dl_make_stack_executable): Move common code in front.  Use
	__builtin_expect.

	* sysdeps/unix/sysv/linux/dl-execstack.c: Change interface.  Add
	challenge for caller.
	* sysdeps/generic/ldsodefs.h: Change declaration and type of hook
	member in rtld_global appropriately.
	* elf/dl-support.c: Likewise.
	* elf/dl-load.c (_dl_map_object_from_fd): Take additional paramter.
	Pass it on to the changed function.
	(_dl_map_object): Pass new parameter to _dl_map_object_from_fd.

2004-01-13  Richard Henderson  <rth@redhat.com>

	* sysdeps/alpha/bits/atomic.h (__arch_compare_and_exchange_xxx_8_int):
	Cast old up to uint64_t before back down to inner width.
	(__arch_compare_and_exchange_xxx_16_int): Likewise.
	(__arch_compare_and_exchange_xxx_32_int): Likewise.
	(__arch_compare_and_exchange_xxx_64_int): Likewise.
	(__arch_compare_and_exchange_val_8_int): Cast result to
	the type of the memory.
	(__arch_compare_and_exchange_val_16_int): Likewise.
	(__arch_compare_and_exchange_val_32_int): Likewise.
	(__arch_compare_and_exchange_val_64_int): Likewise.
	(atomic_compare_and_exchange_bool_acq): Use __atomic_bool_bysize.
	(atomic_compare_and_exchange_bool_rel): Likewise.

	* sysdeps/unix/alpha/sysdep.h: Select inline_syscall_r0_asm
	based on HAVE___THREAD instead of USE_TLS.

	* sysdeps/unix/sysv/linux/alpha/adjtime.c (ADJTIMEX32): New.
	(__adjtimex_tv64): Use it.

	* sysdeps/unix/sysv/linux/alpha/semctl.c (__new_semctl): Cast
	to void* rather than directly to the compatibility structure type.
	* sysdeps/unix/sysv/linux/alpha/shmctl.c (__new_shmctl): Likewise.

	* sysdeps/unix/sysv/linux/alpha/sigaction.c (struct kernel_sigaction):
	Forward declare.

2004-01-13  Richard Henderson  <rth@redhat.com>

	* Versions.def (libm): Add GLIBC_2.3.3.
	* sysdeps/alpha/fpu/Versions: Add __c1_c*f and c*f to GLIBC_2.3.3.
	* sysdeps/alpha/fpu/cabsf.c, sysdeps/alpha/fpu/cargf.c,
	sysdeps/alpha/fpu/cfloat-compat.h, sysdeps/alpha/fpu/cimagf.c,
	sysdeps/alpha/fpu/conjf.c, sysdeps/alpha/fpu/crealf.c,
	sysdeps/alpha/fpu/s_cacosf.c, sysdeps/alpha/fpu/s_cacoshf.c,
	sysdeps/alpha/fpu/s_casinf.c, sysdeps/alpha/fpu/s_casinhf.c,
	sysdeps/alpha/fpu/s_catanf.c, sysdeps/alpha/fpu/s_catanhf.c,
	sysdeps/alpha/fpu/s_ccosf.c, sysdeps/alpha/fpu/s_ccoshf.c,
	sysdeps/alpha/fpu/s_cexpf.c, sysdeps/alpha/fpu/s_clog10f.c,
	sysdeps/alpha/fpu/s_clogf.c, sysdeps/alpha/fpu/s_cpowf.c,
	sysdeps/alpha/fpu/s_cprojf.c, sysdeps/alpha/fpu/s_csinf.c,
	sysdeps/alpha/fpu/s_csinhf.c, sysdeps/alpha/fpu/s_csqrtf.c,
	sysdeps/alpha/fpu/s_ctanf.c, sysdeps/alpha/fpu/s_ctanhf.c: New files.
	* sysdeps/alpha/fpu/bits/mathdef.h: Rename complex float
	functions for gcc 3.3.

	* sysdeps/generic/s_cacosf.c, sysdeps/generic/s_cacoshf.c,
	sysdeps/generic/s_casinf.c, sysdeps/generic/s_casinhf.c,
	sysdeps/generic/s_catanf.c, sysdeps/generic/s_catanhf.c,
	sysdeps/generic/s_ccosf.c, sysdeps/generic/s_ccoshf.c,
	sysdeps/generic/s_cexpf.c, sysdeps/generic/s_clog10f.c,
	sysdeps/generic/s_clogf.c, sysdeps/generic/s_cpowf.c,
	sysdeps/generic/s_cprojf.c, sysdeps/generic/s_csinf.c,
	sysdeps/generic/s_csinhf.c, sysdeps/generic/s_csqrtf.c,
	sysdeps/generic/s_ctanf.c, sysdeps/generic/s_ctanhf.c: Don't
	weak_alias if the function name has been #defined.

	* math/cabsf.c: Move ...
	* sysdeps/generic/cabsf.c: ... here.
	* math/cargf.c: Move ...
	* sysdeps/generic/cargf.c: ... here.
	* math/cimagf.c: Move ...
	* sysdeps/generic/cimagf.c: ... here.
	* math/conjf.c: Move ...
	* sysdeps/generic/conjf.c: ... here.
	* math/crealf.c: Move ...
	* sysdeps/generic/crealf.c: ... here.

2004-01-13  Ulrich Drepper  <drepper@redhat.com>

	* Makeconfig: Define relro-LDFLAGS if have-z-relro==yes.  Add it to
	LDFLAGS.so and LDFLAGS-rtld.
	(+link): Add relro-LDFLAGS.
	* Makeconfig (shlib.lds): Place __libc_subfreeres, __libc_atexit, and
	__libc_thread_subfreeres sections after .jcr section.
	* config.make.in: Add have-z-relro.
	* configure.in: Add check for -z relro option.
	* include/link.h (struct link_map): Add relro_addr and relro_size
	members.
	* elf/dl-load.c (_dl_map_object_from_fd): Recognize PT_GNU_RELRO.
	* elf/dl-reloc.c (_dl_relocate_object): At the end, make relro
	part of loaded segments read-only.
	* elf/elf.h: Define PT_GNU_RELRO.
	* elf/rtld.c (_dl_start): Recognize PT_GNU_RELRO of ld.so.
	(dl_main): Recognize PT_GNU_RELRO of the application.  Call
	_dl_debug_initialize and initialize l_info[DT_DEBUG] before
	relocations.

2004-01-12  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/x86_64/strcspn.S: Fix typo in last patch.

2004-01-11  Andreas Jaeger  <aj@suse.de>

	* sysdeps/x86_64/__longjmp.S: Add cfi directives.

2004-01-10  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/x86_64/__start_context.S: Add cfi directives.
	* sysdeps/unix/x86_64/sysdep.S (__syscall_error): Likewise.
	* sysdeps/unix/sysv/linux/x86_64/vfork.S: Likewise.
	* sysdeps/x86_64/strcspn.S: Likewise.
	* sysdeps/x86_64/strspn.S: Likewise.

2004-01-08  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/clone.S (__clone): Add cfi_endproc
	right before syscall and cfi_startproc before PSEUDO_END.
	Clear %rbp in thread_start.

2004-01-05  Jakub Jelinek  <jakub@redhat.com>

	* posix/regcomp.c (regcomp): Fix comment typo.
	(regfree): Free preg->translate, clear buffer, allocated, fastmap
	and translate fields.

	* posix/regcomp.c (build_charclass, buld_charclass_op): Change first
	argument to unsigned RE_TRANSLATE_TYPE.
	* posix/regex_internal.h (re_string_t): Change trans type to
	unsigned RE_TRANSLATE_TYPE.
	* posix/regex_internal.c (re_string_construct_common): Cast
	trans to unsigned RE_TRANSLATE_TYPE.
	(re_string_peek_byte_case, re_string_fetch_byte_case): Avoid fast
	path if pstr->trans.  Never translate the character through
	pstr->trans.
	* posix/Makefile (tests): Add bug-regex22.
	(bug-regex22-ENV): Set.
	* posix/bug-regex22.c: New test.

2004-01-02  Paolo Bonzini  <bonzini@gnu.org>

	* posix/regex_internal.c (re_node_set_add_intersect,
	re_node_set_merge): Rewritten.
	(re_node_set_insert, re_node_set_remove_at):
	Avoid memmove, we know what direction we should copy and that we
	are copying 32-bit words.
	(re_node_set_compare): Iterate backwards.

2003-12-30  Paul Eggert  <eggert@twinsun.com>

	* time/mktime.c (verify): New macro.
	(time_t_is_integer, twos_complement_arithmetic,
	right_shift_propagates_sign, base_year_is_a_multiple_of_100,
	C99_integer_division): Document these longstanding assumptions in the
	code, and verify them at compile-time.

2004-01-02  Jakub Jelinek  <jakub@redhat.com>

	* posix/regex_internal.h (re_match_context_t): Add dfa member.
	* posix/regexec.c (match_ctx_free_subtops, search_cur_bkref_entry,
	match_ctx_add_sublast, sift_ctx_init, acquire_init_state_context,
	prune_impossible_nodes, check_halt_state_context, proceed_next_node,
	sift_states_backward, update_cur_sifted_state, check_dst_limits,
	check_dst_limits_calc_pos, sift_states_bkref, transit_state,
	check_subexp_matching_top, transit_state_sb, transit_state_mb,
	transit_state_bkref, get_subexp, get_subexp_sub, check_arrival,
	check_arrival_add_next_nodes, expand_bkref_cache, check_node_accept):
	Remove dfa parameter.  Get dfa from mctx.  Adjust callers.
	(re_search_internal): Initialize mctx.dfa.

	* posix/regex_internal.c (re_node_set_insert): Remove unused variables.

	* posix/regex_internal.h (re_dfa_t): Add syntax field.
	* posix/regcomp.c (parse): Initialize dfa->syntax.
	* posix/regexec.c (acquire_init_state_context,
	prune_impossible_nodes, check_matching, check_halt_state_context,
	proceed_next_node, sift_states_iter_mb, sift_states_backward,
	update_cur_sifted_state, sift_states_bkref, transit_state,
	transit_state_sb, transit_state_mb, transit_state_bkref,
	get_subexp, get_subexp_sub, check_arrival, expand_bkref_cache,
	build_trtable): Remove preg argument, add dfa argument instead
	and remove dfa = preg->buffer initialization in the body.
	Adjust all callers.
	(check_node_accept_bytes, group_nodes_into_DFAstates,
	check_node_accept): Likewise.  Use dfa->syntax instead of
	preg->syntax.
	(check_arrival_add_next_nodes): Remove preg argument.

	* posix/regex_internal.h (re_match_context_t): Make input
	re_string_t instead of a pointer to it.
	* posix/regex_internal.c (re_string_construct_common): Don't clear
	pstr here...
	(re_string_construct): ... but only here.
	* posix/regexec.c (match_ctx_init): Remove input argument.  Don't
	initialize fields to zero.
	(re_search_internal): Move input into mctx.input.
	(acquire_init_state_context, check_matching,
	check_halt_state_context, proceed_next_node,
	clean_state_log_if_needed, sift_states_bkref, sift_states_iter_mb,
	transit_state, transit_state_sb, transit_state_mb,
	transit_state_bkref, get_subexp, check_arrival,
	check_arrival_add_next_nodes, check_node_accept, extend_buffers):
	Change mctx->input into &mctx->input and mctx->input->field into
	mctx->input.field.

2004-01-02  Jakub Jelinek  <jakub@redhat.com>
	    Paolo Bonzini  <bonzini@gnu.org>

	* posix/regex_internal.h (re_const_bitset_ptr_t): New type.
	(re_string_t): Add newline_anchor, word_char and word_ops_used fields.
	(re_dfa_t): Change word_char type to bitset.  Add word_ops_used field.
	(re_string_context_at, re_string_reconstruct): Remove last argument.
	* posix/regex_internal.c (re_string_allocate): Initialize
	pstr->word_char and pstr->word_ops_used.
	(re_string_context_at): Remove newline_anchor argument.
	Use input->newline_anchor instead, swap && conditions.
	Only use IS_WIDE_WORD_CHAR if input->word_ops_used != 0.
	Use input->word_char bitmap instead of IS_WORD_CHAR.
	(re_string_reconstruct): Likewise.
	Adjust re_string_context_at caller.
	* posix/regexec.c (acquire_init_state_context,
	check_halt_state_context, transit_state, transit_state_sb,
	transit_state_mb, transit_state_bkref, check_arrival,
	check_node_accept): Adjust re_string_context_at and
	re_string_reconstruct callers.
	(re_search_internal): Likewise.  Set input.newline_anchor.
	(build_trtable): Use dfa->word_char bitmap instead of IS_WORD_CHAR.
	* posix/regcomp.c (init_word_char): Change return type to void.
	Set dfa->word_ops_used.
	(free_dfa_content): Don't free dfa->word_char.
	(parse_expression): Remove error handling for init_word_char.

2004-01-01  Paolo Bonzini  <bonzini@gnu.org>

	* posix/regex_internal.h (re_dfastate_t): Fix size of the CONTEXT
	bitfield.

	* posix/regex_internal.c (re_node_set_insert):  Rewrite.

2004-01-01  Ulrich Drepper  <drepper@redhat.com>

	* posix/getconf.c: Update copyright year.
	* nss/getent.c: Likewise.
	* nscd/nscd_nischeck.c: Likewise.
	* iconv/iconvconfig.c: Likewise.
	* iconv/iconv_prog.c: Likewise.
	* elf/ldconfig.c: Likewise.
	* catgets/gencat.c: Likewise.
	* csu/version.c: Likewise.
	* elf/ldd.bash.in: Likewise.
	* elf/sprof.c (print_version): Likewise.
	* locale/programs/locale.c: Likewise.
	* locale/programs/localedef.c: Likewise.
	* nscd/nscd.c (print_version): Likewise.
	* debug/xtrace.sh: Likewise.
	* malloc/memusage.sh: Likewise.
	* malloc/mtrace.pl: Likewise.

2004-01-01  Petter Reinholdtsen  <pere@hungry.com>

	* stdlib/strfmon.c: Make formatting of left-justified currency
	values match the the POSIX standard.  When using format string
	"[%-14#5.4n]" to print -123.45, the result should be
	"[-$   123.4500 ]", not "[-$123.4500    ]".

2004-01-01  Andreas Jaeger  <aj@suse.de>

	* resolv/Makefile (generated): New.

2003-12-31  Joseph S. Myers  <jsm@polyomino.org.uk>

	* CONFORMANCE: Update.

2003-12-30  Paul Eggert  <eggert@twinsun.com>

	* time/mktime.c: (my_mktime_localtime_r):
	Remove.  All uses changed to __localtime_r.
	(__localtime_r) [!defined _LIBC]: New macro.  Include "time_r.h" to
	get its implementation.
	Fix compile-command to allow for TIME_R_POSIX.

	* time/strftime.c (my_strftime_gmtime_r, my_strftime_localtime_r):
	Remove.  All uses changed to __localtime_r and __gmtime_r.
	(__gmtime_r, __localtime_r) [!HAVE_TM_GMTOFF]: New macros.
	Include "time_r.h" to get their implementations.

	* time/timegm.c: Allow use in GNU applications outside glibc.
	[defined HAVE_CONFIG_H]: Include <config.h>.
	[!defined _LIBC]: Include "timegm.h", <time_r.h>.
	Define __gmtime_r, and declare __mktime_internal.
	(timegm): Define via a prototype, since we can safely assume C89 now.

	* time/mktime.c (check_result): Use less-confusing report format.
	"long" -> "long int", as per usual GNU style.
	(main): Likewise.
	Don't loop if the iteration overflows time_t.
	Allow a negative step in the iteration.

	* time/mktime.c: Assume freestanding C89 or better.
	(HAVE_LIMITS_H, STDC_HEADERS) [defined _LIBC]: Remove;
	assume they're 1.
	(__P): Remove; not used.
	(CHAR_BIT, INT_MIN, INT_MAX): Remove; <limits.h> defines them.
	(mktime, not_equal_tm, print_tm, check_result, main): Use prototypes.
	Prototypes use const * where appropriate.
	(main) [DEBUG]: Fix typo in testing code uncovered by above changes,
	which caused the testing code to dump core on some hosts.

2003-12-31  Ulrich Drepper  <drepper@redhat.com>

	* locale/setlocale.c (setlocale): Avoid duplicating locale names
	if we can reuse old strings.

	* inet/rcmd.c: Provide better error message in case of unknown
	host.  Remove USE_IN_LIBIO.

	* nscd/nscd.init: Updated version, more conforming with current
	init file standards.

	* nscd/nscd-client.h (_PATH_NSCDPID): Move the file into
	/var/run/nscd directory.
	(_PATH_NSCDSOCKET): Likewise.

	* test-skeleton.c (timeout_handler): Fix error message.

	* elf/dl-dst.h (DL_DST_REQUIRED): Avoid the complex operations if
	CNT == 0.

2003-12-30  Jakub Jelinek  <jakub@redhat.com>

	* posix/regexec.c (get_subexp): Only set bkref_str after the first
	loop, use buf + bkref_str_off in the loop instead.
	* posix/bug-regex11.c (tests): Add 3 new tests.

	* posix/regexec.c (clean_state_log_if_need): Rename to...
	(clean_state_log_if_needed): ...this.
	(transit_state_mb, get_subexp_sub): Adjust callers.

	* sunrpc/pmap_clnt.c (pmap_set): Do CLNT_DESTROY even if CLNT_CALL
	failed.  Reported by Steve Grubb.

2003-12-29  Ulrich Drepper  <drepper@redhat.com>

	* elf/elf.h: Add a few definitions from Solaris 9.

2003-12-29  Andreas Schwab  <schwab@suse.de>

	* stdio-common/Makefile (CFLAGS-errlist.c, CFLAGS-siglist.c): Add
	$(fno_unit_at_a_time) to avoid reordering assembler output.

2003-12-29  Jakub Jelinek  <jakub@redhat.com>

	* posix/regexec.c (re_copy_regs): Revert comment change.
	Avoid memory leak if realloc fails.
	(proceed_next_node): Return -2 if re_node_set_insert fails.
	Return -2 if push_fail_stack fails.
	(push_fail_stack): Change fs->alloc only after successful realloc.
	(pop_fail_stack): Formatting.
	(set_regs): If proceed_next_node returns -2, free eps_via_nodes and fs.
	(check_arrival_add_next_nodes): Merge identical statements
	from if branches.

	* signal/Makefile (tests): Add tst-raise.
	* signal/tst-raise.c: New test.

2003-12-28  Ulrich Drepper  <drepper@redhat.com>

	* posix/regcomp.c (mark_opt_subexp_iter): Declare IDX as int.

	* posix/regexec.c (re_copy_regs): Fix testing for failed allocation.
	(push_fail_stack): Add missing check for failed memory allocation.

	* libio/libio.h: Use __builtin_expect in _IO_getc_unlocked,
	_IO_peekc_unlocked, _IO_putc_unlocked, _IO_getwc_unlocked, and
	_IO_putwc_unlocked.

2003-12-28  Andreas Jaeger  <aj@suse.de>

	* sysdeps/ieee754/dbl-64/e_j0.c (__ieee754_y0): Raise only
	overflow for 0 as argument. Raise Invalid exception for negative args.
	* sysdeps/ieee754/dbl-64/e_jn.c (__ieee754_yn): Likewise.
	* sysdeps/ieee754/dbl-64/e_j1.c (__ieee754_y0): Likewise.
	* sysdeps/ieee754/ldb-128/e_jnl.c (__ieee754_ynl): Likewise.
	* sysdeps/ieee754/ldb-128/e_j0l.c (__ieee754_y0l): Likewise.
	* sysdeps/ieee754/ldb-128/e_j1l.c (__ieee754_y1l): Likewise.
	* sysdeps/ieee754/ldb-96/e_jnl.c (__ieee754_ynl): Likewise.
	* sysdeps/ieee754/ldb-96/e_j0l.c (__ieee754_y0l): Likewise.
	* sysdeps/ieee754/ldb-96/e_j1l.c (__ieee754_y1l): Likewise.
	* sysdeps/ieee754/flt-32/e_jnf.c (__ieee754_ynf): Likewise.
	* sysdeps/ieee754/flt-32/e_j0f.c (__ieee754_y0f): Likewise.
	* sysdeps/ieee754/flt-32/e_j1f.c (__ieee754_y1f): Likewise.

	* math/libm-test.inc (yn_test): Expect invalid exception for
	negative arguments.
	(y0_test): Likewise.
	(y1_test): Likewise.

	* sysdeps/ieee754/dbl-64/e_exp.c (__ieee754_exp): Do not raise
	execptions for exp(NaN).

2003-12-23  Paolo Bonzini  <bonzini@gnu.org>

	* posix/regex_internal.c (re_dfa_add_node): Initialize opt_subexp.
	* posix/regex_internal.h (re_token_type_t): Put OP_DUP_PLUS
	among the tokens, rather than among the epsilon-transiting nodes.
	(re_token_t): Add the opt_subexp flag.
	* posix/regcomp.c (optimize_utf8, calc_first,
	calc_next, calc_epsdest): Don't consider OP_DUP_PLUS.
	(mark_opt_subexp, mark_opt_subexp_iter): New functions.
	(parse_dup_op): Mostly rewritten, lowering OP_DUP_PLUS to
	OP_DUP_ASTERISK and marking optional subexpressions
	as such using mark_opt_subexp.
	* posix/regexec.c (set_regs): Initialize PREV_INDEX_MATCH
	and pass it to update_regs.
	(update_regs): Use the PREV_INDEX_MATCH parameter, together
	with the opt_subexp flag, in order to discard a final empty
	match of a repeated subexpression.
	* posix/BOOST.tests: Adjust test vectors.
	* posix/PCRE.tests: Likewise.
	* posix/rxspencer/tests: Likewise.

2000-05-22  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/i386/fpu/bits/mathinline.h (__expm1_code): Avoid using ?:
	with omitted middle operand.

2003-12-22  Jakub Jelinek  <jakub@redhat.com>

	* posix/regcomp.c: Remove C99-ism.
	* posix/tst-rxspencer.c: Likewise.
	Based on a patch by Alex Davis <alex14641@yahoo.com>.

2003-12-17  Paolo Bonzini  <bonzini@gnu.org>

	* posix/regex_internal.h [!_LIBC] (internal_function): Define.
	(re_string_allocate, re_string_construct, re_string_reconstruct,
	re_string_realloc_buffers, build_wcs_buffer,
	build_wcs_upper_buffer, build_upper_buffer,
	re_string_translate_buffer, re_string_destruct,
	re_string_elem_size_at, re_string_char_size_at,
	re_string_wchar_at, re_string_context_at,
	re_node_set_alloc, re_node_set_init_1
	re_node_set_init_2, re_node_set_init_copy,
	re_node_set_add_intersect, re_node_set_init_union,
	re_node_set_merge, re_node_set_insert
	re_node_set_compare, re_node_set_contains
	re_node_set_remove_at, re_dfa_add_node,
	re_acquire_state, re_acquire_state_context,
	free_state): Add internal_function to declaration.

	* posix/regexec.c (match_ctx_init, match_ctx_clean,
	match_ctx_free, match_ctx_free_subtops,
	match_ctx_add_entry, search_cur_bkref_entry,
	match_ctx_clear_flag, match_ctx_add_subtop,
	match_ctx_add_sublast, sift_ctx_init,
	re_search_internal, re_search_2_stub, re_search_stub,
	re_copy_regs, acquire_init_state_context,
	prune_impossible_nodes, check_matching,
	check_halt_node_context, check_halt_state_context
	update_regs, proceed_next_node, push_fail_stack,
	pop_fail_stack, set_regs, free_fail_stack_return,
	sift_states_iter_mb, sift_states_backward
	update_cur_sifted_state, add_epsilon_src_nodes,
	sub_epsilon_src_nodes, check_dst_limits,
	check_dst_limits_calc_pos, check_subexp_limits,
	sift_states_bkref, clean_state_log_if_need,
	merge_state_array, transit_state,
	check_subexp_matching_top, transit_state_sb,
	transit_state_mb, transit_state_bkref,
	get_subexp, get_subexp_sub, find_subexp_node,
	check_arrival, check_arrival_add_next_nodes,
	find_collation_sequence_value, check_arrival_expand_ecl,
	check_arrival_expand_ecl_sub, expand_bkref_cache,
	build_trtable, check_node_accept_bytes, extend_buffers,
	group_nodes_into_DFAstates, check_node_accept): Likewise.

	* posix/regex_internal.c (re_string_construct_common,
	re_string_skip_chars, create_newstate_common,
	register_state, create_ci_newstate, create_cd_newstate,
	calc_state_hash): Likewise.
	(re_string_peek_byte_case, re_fetch_byte_case): Change
	declaration from ANSI to K&R.

2003-12-16  Paolo Bonzini  <bonzini@gnu.org>

	* posix/regexec.c (build_trtable): Don't allocate the trtable
	until state->word_trtable is known.  Don't hardcode UINT_BITS
	iterations on each bitset item.

2003-12-22  Maciej W. Rozycki  <macro@ds2.pg.gda.pl>

	* sysdeps/unix/sysv/linux/ia64/dl-static.c (_dl_static_init):
	Initialize REF before passing it to _dl_lookup_symbol.

2003-12-21  Roland McGrath  <roland@frob.com>

	* sysdeps/mach/hurd/dl-sysdep.c (_exit): Define with attribute_hidden.

2003-12-21  Jakub Jelinek  <jakub@redhat.com>

	* posix/regcomp.c (duplicate_node, duplicate_node_closure): Revert
	2003-11-24 changes.
	* posix/regexec.c (group_nodes_into_DFAstates): For CHARACTER with
	NEXT_{,NOT}WORD_CONSTRAINT check word_char bit.
	* posix/bug-regex19.c (tests): Add new tests.

	* posix/regexec.c (check_dst_limits_calc_pos): Fix formatting.

	* posix/regcomp.c (parse_dup_op): Return NULL if dup_elem is NULL,
	after checking syntax.  Optimize.
	(calc_first): Fix comment.
	* posix/bug-regex13.c (tests): Add new tests.

2003-12-21  Roland McGrath  <roland@redhat.com>

	* manual/arith.texi (Parsing of Integers): Typo fix.

2003-12-20  Roland McGrath  <roland@frob.com>

	* sysdeps/generic/ifreq.c (__ifreq) [_HAVE_SA_LEN]: Fix typo:
	add missing dereference of IFREQS before counting loop.

2003-12-21  Andreas Schwab  <schwab@suse.de>

	* sysdeps/m68k/m68020/bits/atomic.h: Avoid matching memory
	constraints.

2003-12-20  Ulrich Drepper  <drepper@redhat.com>

	* elf/rtld.c (dl_main): Optimize order of subexpressions in if().

2003-12-18  Ulrich Drepper  <drepper@redhat.com>

	* stdio-common/printf_fp.c: Add support to use alternative decimal
	digits.
	* stdio-common/vfprintf.c (vfprintf): Pass use_outdigits flags to
	__printf_fp.  Patch by Hamed Malek <hamed@bamdad.org>.

2003-12-18  Carlos O'Donell  <carlos@baldric.uwo.ca>

	* sysdeps/unix/sysv/linux/hppa/clone.S (__clone) [PIC]: Save PIC,
	reload PIC if we need to call __syscall_error, cleanup asm.

2003-12-17  Carlos O'Donell  <carlos@baldric.uwo.ca>

	* sysdeps/hppa/fpu/fclrexcpt.c (feclearexcept): Right shift
	FE_ALL_EXCEPT before complimenting.
	* sysdeps/hppa/fpu/fegetenv.c (fegetenv): Use asm 'ma,' completer,
	and gcc '+r' constraint.
	* sysdeps/hppa/fpu/feholdexcpt.c (feholdexcept): Likewise.
	* sysdeps/hppa/fpu/fesetenv.c (fesetenv): Likewise.
	* sysdeps/hppa/fpu/feupdateenv.c (feupdateenv): Read raised
	exception bits, OR with envp, pass to fesetenv.
	* sysdeps/hppa/fpu/fraiseexcpt.c (feraiseexcept): Add delayed
	exception flushing, FE_UNDERFLOW is DBL_MIN/3.0, FE_INEXACT is
	triggered by M_PI/69.69 converted to single precision.
	* sysdeps/hppa/fpu/fsetexcptflg.c (fesetexceptflag): Set enable
	bits not raised exception bits.

	* sysdeps/hppa/Makefile: Add dl-symaddr and dl-fptr to the
	correct build strings.
	* sysdeps/hppa/dl-fptr.h: New file.
	* sysdeps/hppa/dl-fptr.c: Removed.
	* sysdeps/hppa/dl-symaddr.c (_dl_symbol_address): Use _dl_make_ftpr,
	remove const qualifier for map.
	(_dl_function_address): Removed.
	* sysdeps/hppa/dl-lookupcfg.h: DL_LOOKUP_ADDRESS must clear
	PLABEL32 bits, define DL_AUTO_FUNCTION_ADDRESS and
	DL_STATIC_FUNCTION_ADDRESS, DL_DT_INIT_ADDRESS and
	DL_DT_FINI_ADDRESS use the previous two macros.

2003-12-17  Jakub Jelinek  <jakub@redhat.com>

	* malloc/mtrace.c (tr_old_memalign_hook): New variable.
	(tr_memalignhook): New function.
	(mtrace): Register tr_memalignhook.
	(muntrace): Deregister tr_memalignhook.
	* malloc/malloc.c (__posix_memalign): If __memalign_hook != NULL,
	call it directly instead of memalign_internal.

2003-12-17  Ulrich Drepper  <drepper@redhat.com>

	* misc/mntent_r.c: Change encoding to match recently changed decoder.
	Patch by Alexander Achenbach <xela@slit.de>.

2003-12-16  Steven Munroe  <sjmunroe@us.ibm.com>

	* sysdeps/unix/sysv/linux/powerpc/sys/ucontext.h: Correct definition of
	vrregset_t.

2003-12-16  Steven Munroe  <sjmunroe@us.ibm.com>

	* sysdeps/unix/sysv/linux/powerpc/sys/procfs.h [!__PPC64_ELF_H]: Extend
	conditional to include typedef elf_vrreg_t.

2003-12-17  Paolo Bonzini  <bonzini@gnu.org>

	* posix/regexec.c (re_search_internal): Limit search to the
	beginning of the buffer if the initial states are empty for
	contexts that do not include CONTEXT_BEGBUF or, if
	!preg->newline_anchor, that do not include any one of
	CONTEXT_BEGBUF and CONTEXT_NEWLINE.

2003-12-17  Andreas Jaeger  <aj@suse.de>

	* sysdeps/generic/system.c (__libc_system): Fix typo, reported by
	Kevin Pedretti <pedretti@ieee.org>.

2003-12-17  Ulrich Drepper  <drepper@redhat.com>

	* elf/rtld.c: Don't use strong_alias to define _rtld_local.  This
	removes the visibility attributes which might be defined earlier
	for some gcc versions.  Instead spell out what strong_alias does
	plus the visibility.

2003-12-16  Petter Reinholdtsen  <pere@hungry.com>

	* posix/regex_internal.h: Make sure the regex code compile
	with non-GCC compilers by hiding attributes.

2003-12-16  Jakub Jelinek  <jakub@redhat.com>
	    Paolo Bonzini  <bonzini@gnu.org>

	* posix/regexec.c (group_nodes_into_DFAstates): Never produce
	dests_ch items that are empty.

2003-12-14  Paolo Bonzini  <bonzini@gnu.org>

	* posix/regexec.c (check_arrival): Remove duplicate test.

2003-12-15  Ulrich Drepper  <drepper@redhat.com>

	* posix/regcomp.c: Make !RE_ENABLE_I18N work again.
	* posix/regex_internal.c: Likewise.
	* posix/regexec.c: Likewise.
	Patch by Paolo Bonzini.

2003-12-14  Paolo Bonzini  <bonzini@gnu.org>

	* posix/regex_internal.c (re_acquire_state_context):
	Compare the node sets after all the other comparisons.

2003-12-13  Paolo Bonzini  <bonzini@gnu.org>

	* posix/regexec.c (find_subexp_node, check_arrival,
	check_arrival_add_next_nodes, check_arrival_expand_ecl,
	check_arrival_expand_ecl_sub, expand_bkref_cache):
	Rename the FL_OPEN parameter to TYPE, which is either
	OP_OPEN_SUBEXP or OP_CLOSE_SUBEXP.  Callers adjusted.

2003-12-12  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/x86_64/syscall.S: Pass also 6th argument
	to syscall.

2003-12-11  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/kernel-features.h: Remove __ASSUME_VSYSCALL.
	There might always be processes which have no vDSO.
	* sysdeps/generic/dl-sysdep.c: Remove __ASSUME_VSYSCALL uses.
	* sysdeps/unix/sysv/linux/i386/sigaction.c: Likewise.

2003-12-11  Carlos O'Donell  <carlos@baldric.uwo.ca>

	* sysdeps/generic/dl-fptr.c (COMPARE_AND_SWAP): Pass new and old
	in the right order.

2003-12-01  Jes Sorensen  <jes@wildopensource.com>

	* rt/tst-clock.c (do_test): Print message when skipping
	CLOCK_PROCESS_CPUTIME_ID test.

	* sysdeps/unix/sysv/linux/ia64/clock_getcpuclockid.c: New file.
	Provide CLOCK_PROCESS_CPUTIME_ID only if /proc/sal/itc_drift is 0.

2003-12-02  David Mosberger  <davidm@hpl.hp.com>

	* sysdeps/ia64/elf/initfini.c: Add unwind info.

	* sysdeps/ia64/dl-machine.h (elf_machine_matches_host): Mark with
	attribute "unused".
	(elf_machine_dynamic): Mark with attributes "unused" and "const".
	(elf_machine_runtime_setup): Likewise.

	* sysdeps/generic/dl-fptr.c (make_fptr_table): Mark with
	attribute "always_inline".
	* sysdeps/ia64/dl-machine.h (__ia64_init_bootstrap_fdesc_table):
	Likewise.

	* configure.in: Check whether compiler has libunwind support.
	* config.make.in (have-cc-with-libunwind): New variable.
	* config.h.in (HAVE_CC_WITH_LIBUNWIND): New macro.
	* Makeconfig (gnulib): If have-cc-with-libunwind is "yes", also
	mention -lunwind.

2003-11-12  David Mosberger  <davidm@hpl.hp.com>

	* sysdeps/unix/sysv/linux/ia64/sysdep.h: Define DO_CALL_VIA_BREAK.
	Redefine DO_CALL to use vdso if supported, otherwise DO_CALL_VIA_BREAK.
	Likewise for DO_INLINE_SYSCALL.  Make INTERNAL_SYSCALL use
	DO_INLINE_SYSCALL.

	* sysdeps/unix/sysv/linux/ia64/vfork.S: Use DO_CALL_VIA_BREAK()
	instead of DO_CALL().

	* sysdeps/unix/sysv/linux/ia64/clone2.S: Use break directly instead
	of DO_CALL().

	* sysdeps/unix/sysv/linux/ia64/brk.S (__curbrk): Restructure it
	to take advantage of DO_CALL() macro.
	* sysdeps/unix/sysv/linux/ia64/setcontext.S: Likewise.
	* sysdeps/unix/sysv/linux/ia64/getcontext.S: Likewise.

	* elf/rtld.c (dl_main): Restrict dl_sysinfo_dso check to first
	program header.  On ia64, the check failed previously because
	there are two program headers.

2003-12-10  Andreas Jaeger  <aj@suse.de>
	    Ruediger Oertel  <ro@suse.de>

	* sysdeps/alpha/fpu/e_sqrt.c: Mark sqrt_data as used.

2003-12-07  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/i386/fpu/s_nexttowardf.c: Construct overflow value correctly.
	* sysdeps/i386/fpu/s_nexttoward.c: Likewise.
	* sysdeps/ieee754/ldbl-128/s_nexttoward.c: Likewise.
	* sysdeps/ieee754/ldbl-96/s_nexttoward.c: Likewise.
	* sysdeps/generic/s_nexttowardf.c: Likewise.
	* math/Makefile (tests): Add bug-nexttoward.
	* math/bug-nexttoward.c: New file.

	* sysdeps/generic/s_nextafter.c: Make sure overflow exception is set.
	* sysdeps/ieee754/flt-32/s_nextafterf.c: Likewise.
	* math/bug-nextafter.c (main): Add tests for overflow and negative
	values.

2003-12-06  Ulrich Drepper  <drepper@redhat.com>

	* math/Makefile (tests): Add bug-nextafter.
	* math/bug-nextafter.c: New file.
	* sysdeps/generic/s_nextafter.c: Construct overflow value correctly.
	* sysdeps/ieee754/flt-32/s_nextafterf.c: Likewise.
	* math/libm-test.inc (nextafter_test): Add test for overflow after
	+/-FLT_MAX etc.

2003-12-04  Steven Munroe  <sjmunroe@us.ibm.com>

	* sysdeps/powerpc/fpu/fgetexcptflg.c (__fegetexceptflag): Add masking
	of fenv.
	* sysdeps/powerpc/nofpu/fgetexcptflg.c (__fegetexceptflag): Likewise.

2003-12-05  Martin Schwidefsky  <schwidefsky@de.ibm.com>

	* sysdeps/s390/s390-32/elf/setjmp.S (setjmp, __setjmp): Add END
	statements.
	* sysdeps/s390/s390-64/elf/setjmp.S (setjmp, __setjmp): Likewise.
	* sysdeps/s390/s390-32/sysdep.h (ENTRY): Add cfi_startproc directive.
	(END): Add cfi_endproc directive.
	* sysdeps/s390/s390-64/sysdep.h (ENTRY, END): Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-32/socket.S (__socket): Remove
	cfi_startproc and cfi_endproc directive.
	* sysdeps/unix/sysv/linux/s390/s390-64/socket.S (__socket): Likewise.
	* sysdeps/s390/s390-32/addmul_1.S (__mpn_addmul_1): Add CFI directives.
	* sysdeps/s390/s390-32/add_n.S (__mpn_add_n): Likewise.
	* sysdeps/s390/s390-64/add_n.S (__mpn_add_n): Likewise.
	* sysdeps/s390/s390-32/dl-machine.h (ELF_MACHINE_RUNTIME_TRAMPOLINE):
	Likewise.
	* sysdeps/s390/s390-64/dl-machine.h (ELF_MACHINE_RUNTIME_TRAMPOLINE):
	Likewise.
	* sysdeps/s390/s390-32/mul_1.S (__mpn_mul_1): Likewise.
	* sysdeps/s390/s390-32/sub_n.S (__mpn_sub_n): Likewise.
	* sysdeps/s390/s390-64/sub_n.S (__mpn_sub_n): Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-32/mmap64.S (__mmap64): Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-32/mmap.S (__mmap): Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-64/mmap.S (__mmap): Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-32/syscall.S (syscall): Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-64/syscall.S (syscall): Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-32/sysdep.S (__syscall_error):
	Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-64/sysdep.S (__syscall_error):
	Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-32/clone.S (__clone): Add CFI
	directives. Move thread_start out of ENTRY/PSEUDO_END block to
	make backchain terminate.
	* sysdeps/unix/sysv/linux/s390/s390-64/clone.S (__clone): Likewise.

	* sysdeps/s390/s390-32/backtrace.c (trace_arg): New structure.
	(unwind_backtrace, unwind_getip): New variables.
	(init, __backchain_backtrace, backtrace_helper): New functions.
	(__backtrace): Use unwind info for backtrace instead of backchain
	walking if the unwind functions can be found.
	* sysdeps/s390/s390-64/backtrace.c: Likewise.

	* sysdeps/unix/sysv/linux/s390/s390-32/posix_fadvise64.c: New file.

	* sysdeps/unix/sysv/linux/s390/sys/procfs.h (ELF_NGREG32): New #define.
	(elf_greg_t32, elf_gregset_t32, elf_fpregset_t32): New types.
	(elf_prstatus32, elf_prpsinfo32): New structures.
	(prgregset32_t, prfpregset32_t, prstatus32_t, prpsinfo32_t): New types.

	* scripts/data/c++-types-s390-linux-gnu.data: New file.
	* scripts/data/c++-types-s390x-linux-gnu.data: New file.

2003-11-30  Petter Reinholdtsen  <pere@hungry.com>

	* stdlib/strfmon.c: Correct formatting of international currency
	values.  The international currency formatting should prefer the
	int_* values if they are set for a locale, and use the domestic
	values if the int_* values are unset.

2003-12-03  Jakub Jelinek  <jakub@redhat.com>

	* posix/Makefile (distribute): Add BOOST.tests.
	(tests): Add tst-boost, depend on tst-boost-mem.
	(generated): Add tst-boost-mem and tst-boost.mtrace.
	(tst-boost-ARGS, tst-boost-ENV): Set.
	($(objpfx)tst-boost-mem): New.
	* posix/tst-boost.c: New test.
	* posix/BOOST.tests: New file.

	* posix/Makefile (distribute): Add PCRE.tests.
	(tests): Add tst-pcre, depend on tst-pcre-mem.
	(generated): Add tst-pcre-mem and tst-pcre.mtrace.
	(tst-pcre-ARGS, tst-pcre-ENV): Set.
	($(objpfx)tst-pcre-mem): New.
	* posix/tst-pcre.c: New test.
	* posix/PCRE.tests: New file.

2003-12-02  Jakub Jelinek  <jakub@redhat.com>

	* intl/locale.alias: Use nb_NO instead of no_NO for bokm.l.

	* sysdeps/powerpc/fpu/libm-test-ulps: Regenerated.
	* sysdeps/s390/fpu/libm-test-ulps: Regenerated.

2003-12-03  Ulrich Drepper  <drepper@redhat.com>

	* locale/programs/locarchive.c (enlarge_archive): Print size info
	only in verbose mode.

	* locale/iso-3166.def: Three letter code of Romania changed.

2003-12-02  Roland McGrath  <roland@redhat.com>

	* scripts/config.sub: Update from master, timestamp='2003-10-20'.
	* scripts/config.guess: Update from master, timestamp='2003-10-20'.

2003-11-30  Andreas Jaeger  <aj@suse.de>

	* config.make.in (fno-unit-at-a-time): Define.

	* configure.in: Add test for -fno-unit-at-a-time.
	Fix text for -fpie.

	* csu/Makefile (CFLAGS-initfini.s): Add $(fno_unit_at_a_time).
	* locale/Makefile (CFLAGS-loadlocale.c): Likewise.

2003-12-01  Automatic

	* version.h (VERSION): Bump to 2.3.3.

2003-11-30  Andreas Jaeger  <aj@suse.de>

	* stdio-common/vfprintf.c: Do not inline buffered_vfprintf to
	decrease stack usage.

2003-11-30  Andreas Schwab  <schwab@suse.de>

	* sysdeps/unix/sysv/linux/m68k/sysdep.h (PSEUDO_ERRVAL)
	(PSEUDO_END_ERRVAL, ret_ERRVAL): Define.

2003-11-29  Ulrich Drepper  <drepper@redhat.com>

	* misc/mntent_r.c (decode_name): Be compatible with util-linux and
	recognize \134 as well.

2003-10-09  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/ia64/fpu/fraiseexcpt.c: Don't include <asm/fpu.h>.

2003-10-08  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/unix/sysv/linux/ia64/bits/sigcontext.h: Don't include
	<asm/fpu.h>.
	(struct ia64_fpreg): New definition.

	* sysdeps/unix/sysv/linux/ia64/sys/procfs.h: Don't include
	<asm/elf.h>.
	(ELF_NGREG): New #define.
	(ELF_NFPREG): Likewise.
	(elf_greg_t): New type.
	(elf_gregset_t): Likewise.
	(elf_fpreg_t): Likewise.
	(elf_fpregset_t): Likewise.

2003-10-08  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/unix/sysv/linux/ia64/sys/ptrace.h: Include
	<sys/ucontext.h>.
	(__ptrace_request): Add PTRACE_GETREGS and PTRACE_SETREGS.
	(pt_all_user_regs): New type.

2003-10-10  Simon Josefsson  <jas@extundo.com>

	* argp/argp-namefrob.h [!_LIBC]: Include mempcpy.h, strcase.h,
	strchrnul.h, strndup.h (from gnulib).
	* argp/argp-parse.c: Add alloca.h include snippet verbatim from
	Autoconf manual.
	* argp/argp-help.c: Replace alloca.h include snipper with verbatim
	Autoconf manual version.
	* argp/argp.h: Map __restrict to restrict or empty string when
	necessary, copied verbatim from posix/regex.h.

2003-10-09  Steven Munroe  <sjmunroe@us.ibm.com>

	* Makefile: Allow for c++-types-$(config-machine)-$(config-os).data in
	addition to c++-types-$(base-machine)-$(config-os).data.
	* scripts/data/c++-types-powerpc-linux-gnu.data: New file.
	* scripts/data/c++-types-powerpc64-linux-gnu.data: New file.

2003-11-28  Ulrich Drepper  <drepper@redhat.com>

	* misc/mntent_r.c (decode_name): Fix decoding of tab, add decoding
	of newline.
	* manual/sysinfo.texi (mtab): Adjust description accordingly.
	Reported by Andries.Brouwer@cwi.nl.

	* sysdeps/x86_64/fpu/libm-test-ulps: Add some more minor changes
	to compensate other setup.

2003-11-27  Andreas Jaeger  <aj@suse.de>

	* sysdeps/x86_64/fpu/libm-test-ulps: Add ulps for new atan2 test.

	* math/libm-test.inc (atan2_test): Add test that run infinitly.
	Reported by "Willus" <etc231etc231@willus.com>.

2003-11-27  Michael Matz  <matz@suse.de>

	* sysdeps/ieee754/dbl-64/mpsqrt.c (fastiroot): Fix 64-bit problem
	with wrong types.

2003-11-28  Jakub Jelinek  <jakub@redhat.com>

	* posix/regexec.c (acquire_init_state_context): Make inline.
	Add always_inline attribute.
	(check_matching): Add BE macro.  Move if (cur_state->has_backref)
	into if (dfa->nbackref).
	(sift_states_backward): Fix comment.
	(transit_state): Add BE macro.  Move if (next_state->has_backref)
	into if (dfa->nbackref && next_state).  Don't check for next_state
	!= NULL twice.
	* posix/regcomp.c (peek_token): Use opr.ctx_type instead of opr.idx
	for ANCHOR.
	(parse_expression): Only call init_word_char if word context will be
	needed.

	* posix/bug-regex11.c (tests): Add new tests.

	* posix/tst-regex.c: Include getopt.h.
	(timing): New variable.
	(main): Set timing to 1 if --timing argument is present.
	Add 2 new tests.
	(run_test, run_test_backwards): Handle timing.

2003-11-27  Jakub Jelinek  <jakub@redhat.com>

	* posix/regex_internal.h (re_string_t): Remove mbs_case field.
	Add offsets, valid_raw_len, raw_len, raw_stop, mbs_allocated and
	offsets_needed fields.  Change icase, is_utf8 and map_notascii
	type from int bitfield to unsigned char.
	(MBS_ALLOCATED, MBS_CASE_ALLOCATED): Remove.
	(build_wcs_upper_buffer): Change prototype to return int.
	(re_string_peek_byte_case, re_string_fetch_byte_case): Remove
	defines, add prototypes.
	* posix/regex_internal.c (re_string_allocate): Don't initialize
	stop here.  Don't initialize mbs_case.  Set valid_raw_len.
	Use mbs_allocated instead of MBS_* macros.
	(re_string_construct): Don't initialize stop and valid_len here.
	Don't initialize mbs_case.  Use mbs_allocated instead of MBS_*
	macros.  Reallocate buffers if build_wcs_upper_buffer converted
	too few bytes.  Set valid_len to bufs_len only for single byte
	no translation and set in that case valid_raw_len as well.
	(re_string_realloc_buffers): Reallocate offsets if not NULL.
	Use mbs_allocated instead of MBS_ALLOCATED.  Don't reallocate
	mbs_case.
	(re_string_construct_common): Initialize raw_len, mbs_allocated,
	stop and raw_stop.
	(build_wcs_buffer): Apply pstr->trans before mbrtowc instead of
	after it.  Set valid_raw_len.  Don't set mbs_case.
	(build_wcs_upper_buffer): Return REG_NOERROR or REG_ESPACE.
	Only use the fast path if !pstr->offsets_needed.  Apply pstr->trans
	before mbrtowc instead of after it.  If upper case character
	uses different number of bytes than lower case, goto to the
	slow path.  Don't call towupper unnecessarily twice.  Set
	valid_raw_len as well.  Handle in the slow path the case if
	lower and upper case use different number of characters.
	Don't set mbs_case.
	(re_string_skip_chars): Use valid_raw_len instead of valid_len.
	(build_upper_buffer): Don't set mbs_case.  Add BE macro.  Set
	valid_raw_len.
	(re_string_translate_buffer): Set mbs instead of mbs_case.  Set
	valid_raw_len.
	(re_string_reconstruct): Use raw_len/raw_stop to initialize
	len/stop.  Clear valid_raw_len and offsets_needed when clearing
	valid_len.  Use mbs_allocated instead of MBS_* macros.
	Check original offset against valid_raw_len instead of valid_len.
	Remove mbs_case handling.  Adjust valid_raw_len together with
	valid_len.  If is_utf8 and looking for tip context, apply
	pstr->trans first.  If buffers start with partial multi-byte
	character, initialize mbs array as well if mbs_allocated.
	Check return value of build_wcs_upper_buffer.
	(re_string_peek_byte_case): New function.
	(re_string_fetch_byte_case): New function.
	(re_string_destruct): Use mbs_allocated instead of MBS_ALLOCATED.
	Don't free mbs_case.  Free offsets.
	* posix/regcomp.c (init_dfa): Only check if charset name is UTF-8
	if mb_cur_max == 6.
	* posix/regexec.c (re_search_internal): Initialize input.raw_stop
	as well.  Use valid_raw_len instead of valid_len when looking
	through fastmap.  Adjust registers through input.offsets.
	(extend_buffers): Allow build_wcs_upper_buffer to fail.
	* posix/bug-regex18.c (tests): Enable #ifdefed out tests.  Add new
	tests.

2003-11-26  Jakub Jelinek  <jakub@redhat.com>

	* posix/regexec.c (check_subexp_limits): Only check close
	subexpression limitation if one is found.  Formatting.
	(sift_states_backward, check_arrival, check_arrival_add_next_nodes):
	Formatting.
	* posix/bug-regex11.c (tests): Enable most #ifdefed out tests.
	Add new test.

2003-11-26  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/kernel-features.h
	(__ASSUME_PROT_GROWSUPDOWN): Define for 2.6.1 and up.
	* sysdeps/unix/sysv/linux/dl-execstack.c: Omit compatibility code
	if __ASSUME_PROT_GROWSUPDOWN is defined.

2003-11-26  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/dl-execstack.c
	(_dl_make_stack_executable): Set dl_stack_flags always for
	success.

2003-06-22  Petter Reinholdtsen  <pere@hungry.com>

	* locale/program/ld-monetary.c: Only check the first three
	characters in int_curr_symbol against ISO-4217, to make the
	separator character used by a locale independent of the content
	in iso-4217.def.
	* locale/iso-4217.def: Remove the space character from all
	currency values to get the new test code in ld-monetary.c working.

2003-11-21  David Mosberger  <davidm@hpl.hp.com>

	* elf/soinit.c (_fini): Put _fini() in .init_array section if
	HAVE_INITFINI_ARRAY is defined.

2003-11-25  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/i386/fpu/bits/mathinline.h: Introduce __libc_sqrtl symbol.
	Define it appropriately after last change.  Use it where __sqrtl
	was used.

2003-11-25  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/i386/fpu/bits/mathinline.h (sqrt): Don't inline
	sqrt for gcc 3.3 and above.

2003-11-25  Ulrich Drepper  <drepper@redhat.com>

	* posix/runptests.c (main): Make errors fatal.
	* posix/PTESTS: One test in GA135 and GA136 check functionality
	which seems not guaranteed.

2003-11-25  Jakub Jelinek  <jakub@redhat.com>

	* posix/regexec.c (re_search_internal): If prune_impossible_nodes
	returned REG_NOMATCH, set match_last to -1.  Don't initialize
	pmatch[0] needlessly.  Fix comment.
	(prune_impossible_nodes): Don't segfault on NULL state_log entry.
	(set_regs): Fix comment.
	* posix/regcomp.c (parse_bracket_exp): Only set has_plural_match
	if adding both SIMPLE_BRACKET and COMPLEX_BRACKET.
	(build_charclass_op): Set has_plural_match if adding both
	SIMPLE_BRACKET and COMPLEX_BRACKET.
	* posix/bug-regex11.c (tests): Fix register values for one commented
	out test.  Add new tests.

	* posix/regex_internal.c (re_string_allocate): Make sure init_len
	is at least dfa->mb_cur_max.
	(re_string_reconstruct): If is_utf8, don't fall back into
	re_string_skip_chars just because idx points into a middle of
	valid UTF-8 character.  Instead, set the wcs bytes which correspond
	to the partial character bytes to WEOF.
	* posix/regexec.c (re_search_internal): Allocate input.bufs_len + 1
	instead of dfa->nodes_len + 1 state_log entries initially.
	* posix/bug-regex20.c (main): Uncomment backwards case insensitive
	tests.

2003-11-24  Jakub Jelinek  <jakub@redhat.com>

	* posix/regex_internal.h (re_token_t): Add word_char bit.  Add
	comment.
	(re_dfa_t): Add sb_char field.
	(bitset_mask): New function.
	* posix/regcomp.c (free_dfa_content): Free sb_char.
	(init_dfa): Don't initialize word_char unnecessarily.
	Initialize sb_char.
	(duplicate_node): Don't duplicate !word_char CHARACTERs with
	NEXT_WORD_CONSTRAINT constraint or word_char CHARACTERs with
	NEXT_NOTWORD_CONSTRAINT.  Return -1 in *new_idx instead.
	(duplicate_node_closure): Handle clone_dest == -1 from
	duplicate_node.
	(peek_token): Initialize word_char bit.
	(parse_expression, parse_dup_op): Add comments.
	(parse_bracket_exp): Don't set bitmask bits for multi-byte char
	starting bytes here at the beginning.  Mask off the bits right
	before creating SIMPLE_BRACKET.
	(build_charclass_op): Likewise.
	* posix/regexec.c (group_nodes_into_DFAstates) <case OP_PERIOD>: Only
	set accept bits for single-byte characters.
	(group_nodes_into_DFAstates): Don't rely on characters 0 .. 127
	being single byte encoded and the rest multi-byte.
	* posix/bug-regex19.c (tests): Add new tests.
	(do_mb_tests): Initialize t to *test.
	(main): Fail even on do_mb_tests errors.

2003-11-23  Ulrich Drepper  <drepper@redhat.com>

	* posix/regexec.c: Correct several memory allocation problems.
	Add more BE.
	* posix/regex_internal.c: Likewise.
	* posix/regcomp.c: Likewise.

	* posix/regexec.c: Add const in a number of places.
	* posix/regex_internal.h: Make EPSILON_BIT a macro to help
	debugging.  Its value isn't important.

2003-11-22  Ulrich Drepper  <drepper@redhat.com>

	* posix/PTESTS: Fix first test of GA143.

2003-11-21  Ulrich Drepper  <drepper@redhat.com>

	* posix/regex_internal.c (re_dfa_add_node): Add BE, reallocation
	isn't likely.

	* locale/programs/charmap.c (charmap_read): If encoding is found
	not ASCII compatible, set enc_not_ascii_compatible.
	* locale/programs/charmap.h: Declare enc_not_ascii_compatible.
	* locale/programs/ld-ctype.c (ctype_startup): If
	enc_not_ascii_compatible is set, initialize to_nonascii to 1.

2003-11-22  Jakub Jelinek  <jakub@redhat.com>

	* elf/rtld.c (process_envvars): Only honor LD_USE_LOAD_BIAS
	if !__libc_enable_secure.

	* sysdeps/generic/ldsodefs.h (_dl_use_load_bias): New _rtld_global
	field.
	* elf/rtld.c (_rtld_global): Initialize _dl_use_load_bias field.
	(dl_main): Set GL(dl_use_load_bias) default.
	(process_envvars): Set GL(dl_use_load_bias) from LD_USE_LOAD_BIAS.
	Add EXTRA_LD_ENVVARS_13.
	* elf/dl-support.c (_dl_use_load_bias): New variable.
	* elf/dl-load.c (_dl_map_object_from_fd): Mask c->mapstart
	with GL(dl_use_load_bias).
	* sysdeps/generic/unsecvars.h (UNSECURE_ENVVARS): Add
	LD_USE_LOAD_BIAS.
	* sysdeps/unix/sysv/linux/dl-librecon.h (EXTRA_LD_ENVVARS): Remove.
	(EXTRA_LD_ENVVARS_LINUX): Renamed to...
	(EXTRA_LD_ENVVARS_13): ... this.  Remove case at the beginning.
	* sysdeps/unix/sysv/linux/i386/dl-librecon.h (EXTRA_LD_ENVVARS):
	Don't undefine first.  Remove EXTRA_LD_ENVVARS_LINUX.

2003-11-21  Ulrich Drepper  <drepper@redhat.com>

	* posix/regcomp.c (duplicate_node): Remove unnecessary local variable.

	* posix/regcomp.c (re_dfa_add_tree_node): Make fourth parameter a
	pointer.  Adjust callers.

	* posix/regcomp.c (fetch_token): Change interface to match
	peek_token.  This avoids some copying and reduces code size.

2003-11-21  Jakub Jelinek  <jakub@redhat.com>

	* posix/bug-regex19.c (tests): Add more tests.

	* posix/bug-regex11.c: And one more commented out test.

	* posix/tst-rxspencer.c (mb_tests): Don't run identical multi-byte
	tests multiple times unnecessarily.

	* posix/bug-regex19.c (BRE, ERE): Define.
	(tests): Add many new tests, remove UTF-8 ones.
	(do_one_test, do_mb_tests): New functions.
	(main): Rewritten using do_one_test and do_mb_tests.

2003-11-20  Ulrich Drepper  <drepper@redhat.com>

	* posix/PTESTS: Fix first test in GA143.

2003-11-20  Jakub Jelinek  <jakub@redhat.com>

	* posix/regex_internal.h (re_dfastate_t): Remove trtable_search.
	Add word_trtable.
	* posix/regex_internal.c (create_newstate_common, free_state):
	Don't free trtable_search.
	* posix/regexec.c (check_matching): Remove fl_search argument.
	(transit_state_sb): Likewise.  #ifdef out as unused.
	(build_trtable): Remove fl_search argument.  Set state->word_trtable
	and state->trtable.  Build separate word and non-word tables if
	multi-byte and they differ for some character.
	(transit_state): Remove fl_search argument.  Don't update
	state->trtable here.  Handle state->word_trtable.
	#ifdef out unused call to transit_state_sb.
	(re_search_internal): Update check_matching caller.
	(group_nodes_into_DFAstates): Don't clear non-ascii chars in accepts
	bitmask for multi-byte locales.
	* posix/bug-regex19.c (tests): Enable some commented out tests, add
	2 new tests.
	* posix/tst-rxspencer.c (mb_tests): Don't test [[=b=]] for now as
	multi-byte.  Don't run identical multi-byte tests multiple times
	unnecessarily.
	(main): Check setlocale return value.
	* posix/Makefile (tst-rxspencer-ARGS): Add --utf8 argument.
	(tst-rxspencer-ENV): Remove MALLOC_TRACE, add LOCPATH.
	($(objpfx)tst-rxspencer-mem): Run another tst-rxspencer test
	here, without --utf8 argument but with MALLOC_TRACE.

2003-11-19  Jakub Jelinek  <jakub@redhat.com>

	* posix/regexec.c (extend_buffers): Don't allocate
	twice as big state_log as needed.  Don't modify pstr->valid_len
	for mb_cur_max == 1 !icase !trans.

	* posix/regcomp.c (free_bin_tree): Removed.
	(create_tree): Add dfa argument.  Don't call re_malloc for
	each tree, instead allocate from str_tree_storage.
	(re_dfa_add_tree_node): New function.
	(free_dfa_content): Handle freeing if dfa->nodes == NULL
	or dfa->state_table == NULL.
	(re_compile_internal): Call free_dfa_content if init_dfa
	fails.  Call free_workarea_compile, re_string_destruct
	and free_dfa_content for most of the other failure paths.
	(init_dfa): Initialize str_tree_storage_idx.
	Don't clear any fields on allocation failure.
	(free_workarea_compile): Free str_tree_storage chunks
	instead of free_bin_tree (dfa->str_tree).
	(parse): Call re_dfa_add_tree_node instead of re_dfa_add_node
	followed by create_tree.  Add dfa argument to remaining
	create_tree calls.  Remove new_idx variable.  Remove calls
	to free_bin_tree.
	(parse_reg_exp, parse_branch, parse_expression, parse_sub_exp,
	parse_dup_op, parse_bracket_exp, build_charclass_op): Likewise.
	(duplicate_tree): Remove calls to free_bin_tree, add dfa
	argument to create_tree.
	* posix/regex_internal.h (BIN_TREE_STORAGE_SIZE): Define.
	(bin_tree_storage_t): New type.
	(re_dfa_t): Add str_tree_storage and str_tree_storage_idx
	fields.
	* posix/Makefile (tests): Add bug-regex21.
	(generated): Add bug-regex21-mem, bug-regex21.mtrace,
	tst-rxspencer-mem and tst-rxspencer.mtrace.
	(tests): Depend on $(objpfx)bug-regex21-mem
	and $(objpfx)tst-rxspencer-mem.
	(bug-regex21-ENV, tst-rxspencer-ENV): Set.
	($(objpfx)bug-regex21-mem, $(objpfx)tst-rxspencer-mem): New.
	* posix/tst-rxspencer.c (main): Add call to mtrace.
	Free line at the end.
	* posix/bug-regex21.c: New test.

2003-11-19  Ulrich Drepper  <drepper@redhat.com>

	* posix/bug-regex20.c: Correct invalid UTF-8 sequences.

	* posix/regex_internal.c (build_wcs_upper_buffer): If mbrtowc
	fails, just use the byte, do no fancy conversions.

	* posix/regex_internal.h (re_string_first_byte): Use ->valid_len
	not ->len.
	(re_string_is_single_byte_char): Likewise.

2003-11-18  Ulrich Drepper  <drepper@redhat.com>

	* posix/regexec.c (get_subexp): After calling get_subexp_sub
	reload buf and bkref_str.  Little optimization by avoiding memcmp.

2003-11-14  David Mosberger   <davidm@hpl.hp.com>

	* sysdeps/unix/sysv/linux/ia64/sysdep.h
	(GAS_ALIGN_BREAKS_UNWIND_INFO): Define this macro to indicate
	that all existing GAS versions have a problem with .align inside
	a function.
	* sysdeps/ia64/memccpy.S: Work around GAS_ALIGN_BREAKS_UNWIND_INFO bug.
	* sysdeps/ia64/memcpy.S: Likewise.
	* sysdeps/ia64/memset.S: Likewise.
	* sysdeps/ia64/memmove.S: Likewise.  Also move the jump-table to
	out of .text into .rodata, where it belongs.

	* sysdeps/unix/sysv/linux/ia64/pipe.S: There is no need to
	save/restore input-arguments, because they're necessarily
	preserved by the kernel to support syscall-restart.

2003-11-18  Jakub Jelinek  <jakub@redhat.com>

	* posix/regex_internal.h (re_token_type_t): Remove unused ALT,
	END_OF_RE_TOKEN_T and SUBEXP.  Reorder values.  Add OP_UTF8_PERIOD
	and EPSILON_BIT.
	(IS_EPSILON_NODE): Just test if EPSILON_BIT is set.
	(ACCEPT_MB_NODE): Return 1 for OP_UTF8_PERIOD as well.
	* posix/regex_internal.c (create_ci_newstate, create_cd_newstate):
	Handle OP_UTF8_PERIOD.
	(re_string_reconstruct): Set valid_len for single byte char searching
	with no translation and case sensitivity.
	* posix/regcomp.c (re_compile_fastmap_iter, calc_first): Handle
	OP_UTF8_PERIOD.
	(re_compile_internal): Don't call optimize_utf8 if preg->translate
	!= NULL.
	(optimize_utf8): Remove BACK_SLASH case.
	Transform OP_PERIOD into OP_UTF8_PERIOD if the searching can be
	optimized.
	(parse_bracket_exp): Don't create SIMPLE_BRACKET if it doesn't have
	any bits set and COMPLEX_BRACKET is used.
	* posix/regexec.c (transit_state_mb): Fix comment typo.
	(group_nodes_into_DFAstates, check_node_accept): Handle
	OP_UTF8_PERIOD.
	(check_node_accept_bytes): Likewise.  Reorder slightly so that
	re_string_char_size_at and re_string_elem_size_at are called
	only when needed.
	* posix/bug-regex20.c (BRE, ERE): Define.
	(tests): Use them to make lines shorter.  Expect . to be
	optimized.  Add lots of new tests.
	(main): Run (ATM just case sensitive) test with backwards searching
	as well.

2003-11-18  Jakub Jelinek  <jakub@redhat.com>

	* io/bug-ftw4.c: Include string.h.
	* posix/fnmatch.c (mbsinit): Remove define.

2003-11-17  Jakub Jelinek  <jakub@redhat.com>

	* posix/regcomp.c (optimize_utf8): Optimize multi-byte chars as
	well.
	* posix/bug-regex20.c (tests): Add new tests.  Multi-byte char
	followed by dup operator is expected to be optimized.

	* posix/regexec.c (check_node_accept_bytes): Move nrules and j
	variables to the block where they are only used, initialize
	nrules only immediately before using it.

2003-11-15  Andreas Jaeger  <aj@suse.de>

	* sysdeps/x86_64/fpu/s_scalbnl.S: New file.
	* sysdeps/x86_64/fpu/s_truncl.S: New file.
	* sysdeps/x86_64/fpu/s_nearbyintl.S: New file.
	* sysdeps/x86_64/fpu/s_floorl.S: New file.
	* sysdeps/x86_64/fpu/s_ilogbl.S: New file.
	* sysdeps/x86_64/fpu/e_remainderl.S: New file.

	* math/libm-test.inc (floor_test): Test also ±0.25.
	(ceil_test): Test -0.25.

2003-11-17  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/posix/getaddrinfo.c: Add support for destination address
	selection according to RFC 3484.

2003-11-15  Ulrich Drepper  <drepper@redhat.com>

	* posix/regex_internal.h: Add forward declaration of re_dfa_t.
	Replace last two parameters of re_string_allocate and
	re_string_construct with pointer to DFA.
	(re_dfa_t): Add map_notascii field.
	* posix/regcomp.c (re_compile_internal): Add call of
	re_string_construct.
	(init_dfa): Initialize map_notascii.
	* posix/regex_internal.c: Adjust definitions of re_string_allocate
	and re_string_construct.
	Pass DFA to re_string_construct.  Adjust definition.  Initialize
	map_notascii field.
	(build_wcs_upper_buffer): If map_notascii is zero use simplified
	method to map ASCII values to upper case.
	* posix/regex.c: Include localeinfo.h.
	* posix/regexec.c: Adjust call of re_string_allocate.

	* locale/langinfo.h: Add _NL_CTYPE_MAP_TO_NONASCII.
	* locale/localeinfo.h (LIMAGIC): Change value.
	* locale/categories.def. Add entry for _NL_CTYPE_MAP_TO_NONASCII.
	* locale/C-ctype.h: Likewise.
	* locale/programs/ld-ctype.c: Compute whether any mapping maps from
	ASCII to non-ASCII value.  Write out that value.

	* wcsmbs/mbsinit.c: Undef mbsinit and __mbsinit.
	* include/wchar.h: Provide inline versions of mbsinit and __mbsinit.

2003-11-14  Jakub Jelinek  <jakub@redhat.com>

	* posix/tst-rxspencer.c (check_match): @ without any following
	characters must match only end of string.
	(main): Fix filename in error message.

2003-11-12  David Mosberger  <davidm@hpl.hp.com>

	* sysdeps/ia64/dl-machine.h: Force inlining of
	elf_machine_runtime_setup().

2003-11-13  Andreas Jaeger  <aj@suse.de>

	* math/Makefile (CFLAGS-test-float.c): Add -fno-builtin.
	(CFLAGS-test-double.c): Likewise.
	(CFLAGS-test-ldouble.c): Likewise.
	(CPPFLAGS-test-ifloat.c): Likewise.
	(CPPFLAGS-test-idouble.c): Likewise.
	(CPPFLAGS-test-ildoubl.c): Likewise.

	* math/libm-test.inc (ceil_test): Test ceil (0.25).

2003-11-04  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/ifaddrs.c: Make sure it's the kernel who
	sends the netlink data.
	* sysdeps/unix/sysv/linux/check_pf.c: Likewise.

2003-11-13  Jakub Jelinek  <jakub@redhat.com>

	* posix/regcomp.c (optimize_utf8): Optimize even if SIMPLE_BRACKET
	with no bits set for >= 0x80 chars is seen.
	* posix/bug-regex20.c (tests): Add new tests.  Expect [ABC] to be
	optimized.
	(main): Run all tests with RE_ICASE as well.

2003-11-13  Ulrich Drepper  <drepper@redhat.com>

	* posix/Makefile: Add rules to build and run tst-rxspencer.
	(distribute): Add rxspencer/tests and rxspencer/COPYRIGHT.
	* posix/tst-rxspencer.c: New file.
	* posix/rxspencer/tests: New file.
	* posix/rxspencer/COPYRIGHT: New file.
	Patch mostly by Jakub Jelinek.

	* posix/regcomp.c (parse_bracket_exp): Don't check for range if
	this is no option given the first token.

	* posix/regcomp.c (parse_bracket_exp): Fix test for EOS after
	hyphen in range expression.  Return EBRACK in this case.

	* posix/regcomp.c (parse_bracket_element): Reject hyphens unless
	we expect them or it's the last element in the bracket expression.
	Indicated by new parameter.  Adjust all callers.

	* posix/runtests.c (run_a_test): If regcomp failed, reset last_pattern.
	Prettier error messages.

	* posix/regcomp.c (parse_dup_op): Fail with REG_BADBR is first
	number in {,} expression is larger.

2003-11-13  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/kernel-features.h (__ASSUME_TGKILL):
	Define appropriately for x86_64.
	(__ASSUME_UTIMES): Likewise.
	(__ASSUME_CLONE_THREAD_FLAGS): Likewise.

	* sysdeps/x86_64/fpu/s_ceill.S: New file.

2003-11-13  Ulrich Drepper  <drepper@redhat.com>

	* posix/regcomp.c (parse_expression): In BRE consecutive
	duplications are not allowed.

2003-11-12  Ulrich Drepper  <drepper@redhat.com>

	* posix/regcomp.c (parse_bracket_exp): If end of expression is
	seen, return EBRACK error, not BADPAT.

	* posix/regcomp.c (parse_expression): If token is OP_OPEN_DUP_NUM
	and RE_CONTEXT_INVALID_DUP syntax flag is set, fail.
	* posix/regex.h (RE_CONTEXT_INVALUD_OPS): New macro.
	(RE_SYNTAX_POSIX_BASIC): Use RE_CONTEXT_INVALUD_OPS.

	* posix/regcomp.c (parse_sub_exp): In case of not-matching ( )
	return REG_EPAREN.

	* posix/PTESTS: Cleanup.  Fix typoes.  Correct bugs in 2003.2.
	* posix/runptests.c (main): Handle comments.
	* posix/PTESTS2C.sed: Handle comments.

2003-11-12  Jakub Jelinek  <jakub@redhat.com>

	* posix/regcomp.c (optimize_utf8): New function.
	(re_compile_fastmap_iter): Use dfa->mb_cur_max > 1 instead
	of !icase.
	(re_compile_internal): Call optimize_utf8 if not case insensitive
	and in UTF-8 locale.
	* posix/regex_internal.h: Ifdef out some prototypes if
	RE_NO_INTERNAL_PROTOTYPES is defined to shut up warnings.
	* posix/Makefile (tests): Add bug-regex20.
	(bug-regex20-ENV): Add LOCPATH.
	* posix/bug-regex20.c: New test.

2003-11-12  Jakub Jelinek  <jakub@redhat.com>

	* io/ftw.c (NFTW_NEW_NAME, NFTW_OLD_NAME): Add prototypes.

2003-11-12  Jakub Jelinek  <jakub@redhat.com>

	* posix/tst-regex.c (umemlen): New variable.
	(test_expr): Add expectedicase argument.  Test case insensitive
	searches as well as backwards searches (case sensitive and
	insensitive) too.
	(run_test): Add icase argument.  Use it to compute regcomp flags.
	(run_test_backwards): New function.
	(main): Cast read to size_t to avoid warning.  Set umemlen.
	Add expectedicase arguments to test_expr.
	* posix/regex_internal.c (re_string_reconstruct): If is_utf8,
	find previous character by walking back instead of converting
	all chars from beginning.

2003-11-12  Jakub Jelinek  <jakub@redhat.com>

	* posix/regex_internal.h (struct re_string_t): Add is_utf8
	and mb_cur_max fields.
	(struct re_dfa_t): Likewise.  Reorder fields to make structure
	smaller on 64-bit arches.
	(re_string_allocate, re_string_construct): Add mb_cur_max and
	is_utf8 arguments.
	(re_string_char_size_at, re_string_wchar_at): Use pstr->mb_cur_max
	instead of MB_CUR_MAX.
	* posix/regcomp.c (re_compile_fastmap_iter): Use dfa->mb_cur_max
	instead of MB_CUR_MAX.
	(re_compile_internal): Pass new arguments to re_string_construct.
	(init_dfa): Initialize mb_cur_max and is_utf8 fields.
	(peek_token, peek_token_bracket): Use input->mb_cur_max instead
	of MB_CUR_MAX.
	(parse_expression, parse_bracket_exp, parse_charclass_op): Use
	dfa->mb_cur_max instead of MB_CUR_MAX.
	* posix/regex_internal.c (re_string_construct_common): Add
	mb_cur_max and is_utf8 arguments.  Initialize fields with them.
	(re_string_allocate, re_string_construct): Add mb_cur_max and
	is_utf8 arguments, pass them to re_string_construct_common.
	Use mb_cur_max instead of MB_CUR_MAX.
	(re_string_realloc_buffers): Use pstr->mb_cur_max instead of
	MB_CUR_MAX.
	(re_string_reconstruct): Likewise.
	(re_string_context_at): Use input->mb_cur_max instead of
	MB_CUR_MAX.
	(create_ci_newstate, create_cd_newstate): Use dfa->mb_cur_max
	instead of MB_CUR_MAX.
	* posix/regexec.c (re_search_internal): Likewise.
	Pass new arguments to re_string_allocate.
	(check_matching, transit_state_sb): Use dfa->mb_cur_max instead of
	MB_CUR_MAX.
	(extend_buffers): Use pstr->mb_cur_max instead of MB_CUR_MAX.

2003-11-12  Jakub Jelinek  <jakub@redhat.com>

	* posix/Makefile (tests): Add bug-regex19.
	(bug-regex19-ENV): Add LOCPATH.
	* posix/bug-regex19.c: New test.

2003-11-11  Jakub Jelinek  <jakub@redhat.com>

	* posix/regcomp.c (re_compile_fastmap_iter): Handle RE_ICASE
	with MB_CUR_MAX > 1 locales in the fastmap.

2003-11-11  Jakub Jelinek  <jakub@redhat.com>

	* posix/regex_internal.c (build_wcs_buffer): Fix comment typo.
	(build_wcs_upper_buffer): Likewise.  Use towupper for wchar_t instead
	of toupper.
	* posix/Makefile (tests): Add bug-regex17 and bug-regex18.
	(bug-regex17-ENV, bug-regex18-ENV): Add LOCPATH.
	* posix/bug-regex17.c: New file
	* posix/bug-regex18.c: New file.

2003-10-08  Thorsten Kukuk  <kukuk@suse.de>

	* sysdeps/unix/sysv/linux/sparc/sparc64/sysdep.h (pread, pwrite):
	Define __NR_pread/__NR_pwrite if not done in kernel headers

2003-11-11  Roland McGrath  <roland@redhat.com>

	* manual/xtract-typefun.awk: Swallow [(){}*] from function names.

	* manual/Makefile (info): Don't depend on dir-add.info.
	(libc.dvi libc.pdf libc.info): Depend on dir-add.texi.
	(dir-add.info): Target removed, replaced with ...
	(dir-add.texi): New target.
	(distribute): Add it.
	(install): Remove variant with --section arguments.
	Let the @dircategory directives do their work.
	(mostlyclean): Don't remove dir-add.info here.
	(realclean): Remove dir-add.texi here.
	* manual/libc.texinfo: @include dir-add.texi
	* configure.in: Remove check for old Debian install-info.
	* configure: Regenerated.
	* config.make.in (OLD_DEBIAN_INSTALL_INFO): Variable removed.

2003-11-08  Andreas Schwab  <schwab@suse.de>

	* scripts/data/c++-types-ia64-linux-gnu.data: New file.

2003-11-10  Carlos O'Donell  <carlos@baldric.uwo.ca>

	* io/ftwtest-sh: Fix nested sed commands.

2003-11-10  Jakub Jelinek  <jakub@redhat.com>

	* posix/regex_internal.h (re_string_char_size_at): Don't look beyond
	valid_len wide chars.

2003-11-09  Roland McGrath  <roland@redhat.com>

	* manual/examples/dir2.c (one): Add const to argument type.
	Reported by J de Haan <j.de.haan@home.nl>.

2003-11-07  Ulrich Drepper  <drepper@redhat.com>

	* po/pl.po: Update from translation team.

2003-11-07  Jakub Jelinek  <jakub@redhat.com>

	* io/ftw.c (NFTW_OLD_NAME, NFTW_NEW_NAME): Define.
	(ftw_dir, ftw_startup): Add __attribute ((noinline)).
	(NFTW_OLD_NAME, NFTW_NEW_NAME): New functions.
	(NFTW_NAME): Only define if !_LIBC, add versioned_symbol
	and compat_symbol.
	* io/ftw64.c (NFTW_OLD_NAME, NFTW_NEW_NAME): Define.
	* io/Versions (libc): Export nftw@@GLIBC_2.3.3
	and nftw64@@GLIBC_2.3.3.

	* io/ftw.h (FTW_ACTIONRETVAL): New flag.
	(FTW_CONTINUE, FTW_STOP, FTW_SKIP_SUBTREE, FTW_SKIP_SIBLINGS): New.
	* io/ftw.c (ftw_dir): Add old_dir argument.
	Clear result if it was FTW_SKIP_SIBLINGS after processing all
	dir entries.  Change cwd back if old_dir != NULL.
	(process_entry): Adjust caller.  Don't change cwd back here.
	Change FTW_SKIP_SUBTREE result to 0.
	(ftw_startup): Adjust ftw_dir caller.
	Clear result if it was FTW_SKIP_SUBTREE or FTW_SKIP_SIBLINGS.
	* io/ftwtest.c (skip_subtree, skip_siblings): New variables.
	(options, main): Add --skip-subtree and --skip-siblings options.
	(cb): Use return FTW_CONTINUE instead of return 0.
	Handle --skip-subtree and --skip-siblings.
	* io/ftwtest-sh: Add tests for FTW_ACTIONRETVAL.
	* manual/filesys.texi: Document FTW_ACTIONRETVAL.

2003-11-04  Jakub Jelinek  <jakub@redhat.com>

	* io/ftw.c (ftw_dir): Close dir if callback with FTW_D type returns
	non-zero.
	* io/Makefile (tests): Add bug-ftw4.
	* io/bug-ftw4.c: New test.

2003-10-27  Daniel Jacobowitz  <drow@mvista.com>

	* libio/libioP.h [_IO_USE_OLD_IO_FILE]
	(struct _IO_FILE_complete_plus): New type.
	* libio/oldiofopen.c (_IO_old_fopen): Use _IO_FILE_complete_plus.
	* libio/oldiofdopen.c (_IO_old_fdopen): Likewise.
	* libio/oldiopopen.c (struct _IO_proc_file, _IO_old_popen): Likewise.
	Call _IO_old_init instead of _IO_init.

2003-11-03  Ulrich Drepper  <drepper@redhat.com>

	* intl/locale.alias: nb_NO is now the correct name, not no_NO.

	* locale/iso-639.def: Add Blin.
	Patch by Daniel Yacob <locales@geez.org>.

2003-10-31  Steven Munroe  <sjmunroe@us.ibm.com>

	* sysdeps/powerpc/powerpc32/strncmp.S: New File.
	* sysdeps/powerpc/powerpc64/strncmp.S: New File.

2003-11-01  Randolph Chung  <tausq@debian.org>

	* sysdeps/unix/sysv/linux/hppa/sysdep.h (LOAD_ARGS_0, LOAD_ARGS_1,
	LOAD_ARGS_2, LOAD_ARGS_3, LOAD_ARGS_4, LOAD_ARGS_5, LOAD_ARGS_6):
	Add missing parentheses.

2003-11-01  Roland McGrath  <roland@redhat.com>

	* libio/bug-ftell.c (do_test): Add a cast.

2003-09-26  Daniel Jacobowitz  <drow@mvista.com>

	* Makerules (shlib.lds): Make sure that ld doesn't try to link
	anything while generating the linker script.

2003-10-31  Roland McGrath  <roland@redhat.com>

	* locale/lc-ctype.c (_nl_postload_ctype): Update _nl_global_locale's
	special members.

2003-10-29  Ulrich Drepper  <drepper@redhat.com>

	* po/be.po: Update from translation team.

2003-10-27  Ulrich Drepper  <drepper@redhat.com>

	* elf/rtld.c (map_doit): Pass __RTLD_OPENEXEC in last parameter to
	_dl_map_object.

	* elf/sprof.c (load_shobj): Use l_map_start not l_addr to locate
	ELF header.

	* inet/rcmd.c (__validuser2_sa): Remove unnecessary code to skip
	rest of line.  We use getline which means this cannot happen.

2003-10-26  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/internal_statvfs.c (__internal_statvfs):
	Avoid infinite loops in case the mounts file is hosed.
	* io/Makefile: Add rules to build and run tst-statvfs.
	* io/tst-statvfs.c: New file.

	* include/dlfcn.h (__RTLD_OPENEXEC): Define.
	* elf/dl-load.c (_dl_map_object_from_fd): Don't allow loading
	executables unless __RTLD_OPENEXEC flag is present.
	* elf/rtld.c (dl_main): Pass __RTLD_OPENEXEC flag to
	_dl_map_object when loading the executable.

	* sysdeps/generic/glob.c (glob): Handle GLOB_BRACE and escaping
	correctly.
	* posix/globtest.sh: Add tests for GLOB_BRACE and escaping.

	* resolv/nss_dns/dns-host.c (_nss_dns_gethostbyaddr_r): Default
	reverse lookup format for IPv6 addresses is using bitstring and
	.ip6.arpa suffix.
	* resolv/ns_name.c: Implement encoding and decoding bitstring in
	hex format.

2003-10-23  Jakub Jelinek  <jakub@redhat.com>

	* locale/programs/locale.c (show_info): Fix printing word values on
	64-bit big-endian architectures.

2003-10-19  Bruno Haible  <bruno@clisp.org>

	* intl/hash-string.c (hash_string): Zero-extend each char from the
	string; the old code did a sign-extend on some platforms.

2003-10-22  Steven Munroe  <sjmunroe@us.ibm.com>

	* sysdeps/powerpc/powerpc32/Makefile (+cflags, asm-CPPFLAGS): Don't
	append options to these.
	* sysdeps/powerpc/powerpc64/Makefile (+cflags, asm-CPPFLAGS): Likewise.

2003-10-18  Carlos O'Donell  <carlos@baldric.uwo.ca>

	* sysdeps/unix/sysv/linux/hppa/sysdep.h: Fix merge error.

2003-10-15  Roland McGrath  <roland@redhat.com>

	* elf/dl-iteratephdr.c [! SHARED] (dl_iterate_phdr): New function.
	Fake an entry for the main executable and then call __dl_iterate_phdr.
	* elf/Makefile (routines): Remove dl-iteratephdr-static.
	(elide-routines.os): Likewise.
	(CFLAGS-dl-iterate-phdr-static.c): Variable removed.
	* sysdeps/generic/dl-iteratephdr-static.c: File removed.
	* sysdeps/unix/sysv/linux/ia64/dl-iteratephdr-static.c: File removed.

2003-10-15  Jakub Jelinek  <jakub@redhat.com>

	* elf/rtld.c (print_statistics): Print also number of relative
	relocations.

2003-10-12  Carlos O'Donell  <carlos@baldric.uwo.ca>

	* sysdeps/hppa/sysdep.h: Undef JUMPTARGET before use.
	* sysdeps/unix/sysv/linux/hppa/sysdep.h: Define PSEUDO_ERRVAL,
	SYSCALL_ERROR_LABEL under all conditions, INTERNAL_SYSCALL_DECL,
	INTERNAL_SYSCALL_ERROR_P, INTERNAL_SYSCALL_ERRNO, INTERNAL_SYSCALL,
	and undef JUMPTARGET before use.
	[PIC]: Save pic register around syscall.
	* sysdeps/unix/sysv/linux/hppa/sysdep.c (syscall):
	Cleanup asm statment.

2003-10-13  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* sysdeps/unix/sysv/linux/sh/sysdep.h (DO_CALL): Add SYSCALL_INST_PAD
	after trapa instruction.

2003-10-09  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* sysdeps/unix/sysv/linux/sh/syscalls.list: Add waitpid.

2003-10-10  Carlos O'Donell  <carlos@baldric.uwo.ca>

	* sysdeps/hppa/Makefile (CFLAGS-malloc.c): Variable removed.

2003-10-09  Roland McGrath  <roland@redhat.com>

	* elf/rtld.c (dl_main): Don't set l_name for sysinfo DSO, since there
	is no file to name.

2003-10-08  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/generic/dl-sysdep.c (_dl_important_hwcaps): Don't generate
	two identical copies of strings.

2003-10-06  Ulrich Drepper  <drepper@redhat.com>

	* posix/bug-regex11.c: Add some more tests which fail so far.
	Disable them.  Patch by Paolo Bonzini <bonzini@gnu.org>.

2003-10-05  Paolo Bonzini  <bonzini@gnu.org>

	* posix/bug-regex11.c: Add more backreference-related test cases.
	(main): Show the failing regex in the error messages.
	* posix/regexec.c (check_dst_limits_calc_pos):
	Simplify some nested conditionals.  Replace if's with a switch
	statement.
	(check_dst_limits_calc_pos <TYPE_BKREF>): Rename parameter NODE to
	FROM_NODE, it shadows a local variable; don't recurse if FROM_NODE
	does not change in the recursive invocation, fixing an infinite loop
	in the ()\1*\1* regex.
	(sift_states_backward): Fix function comment.
	* posix/regcomp.c (calc_epsdest): Add an assertion.

2003-10-06  Ulrich Drepper  <drepper@redhat.com>

	* manual/examples/testopt.c: Fix warnings.  Better error message
	for missing -c argument.
	Patch mostly by Gitonga Marete <bgmarete@comcast.net>.

	* timezone/asia: Update from tzdata2003d.
	* timezone/australasia: Likewise.
	* timezone/backward: Likewise.
	* timezone/europe: Likewise.
	* timezone/iso3166.tab: Likewise.
	* timezone/northamerica: Likewise.
	* timezone/southamerica: Likewise.
	* timezone/zone.tab: Likewise.

2003-10-05  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/ia64/backtrace.c: New file.
	* sysdeps/x86_64/backtrace.c: New file.
	* sysdeps/generic/unwind.h (_Unwind_Trace_Fn): New type.
	(_Unwind_Backtrace): New prototype.

2003-10-03  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/i386/elf/bsd-setjmp.S: Use linkonce section for PIC stub.
	* sysdeps/i386/elf/setjmp.S: Likewise.

2003-10-02  Roland McGrath  <roland@redhat.com>

	* argp/argp-help.c (__argp_short_program_name): Move inside [! _LIBC].
	* argp/argp-namefrob.h
	[_LIBC || HAVE_DECL_PROGRAM_INVOCATION_SHORT_NAME]
	(__argp_short_program_name): Don't declare fn, define it as a macro.

2003-08-22  Simon Josefsson  <jas@extundo.com>

	* argp/argp-fmtstream.h [!__attribute__]: Define to nothing.

	* argp/argp-help.c: Don't include malloc.h, some platforms
	complain and it doesn't appear to be used.
	[!_LIBC && HAVE_STRERROR_R && !HAVE_DECL_STRERROR_R]: Declare
	strerror_r.
	[!_LIBC && !HAVE_STRERROR_R && !HAVE_DECL_STRERROR]: Declare
	strerror.
	(hol_entry_long_iterate): Change __attribute to __attribute__.
	(_help, __argp_error, __argp_failure) [!_LIBC && (HAVE_FLOCKFILE
	&& HAVE_FUNLOCKFILE)]: Protect call to flockfile and funlockfile.
	(__argp_basename) [!_LIBC]: New. Taken from LSH, by Niels Möller,
	modified after comments from Ulrich Drepper.
	(__argp_short_program_name): Ditto.
	(__argp_state_help, __argp_error, __argp_failure): Use it.
	(__argp_failure): Use strerror when necessary.

	* argp/argp-namefrob.h (__flockfile, __funlockfile, __mempcpy)
	(__strchrnul, __strerror_r, __strndup) [!_LIBC]: Remove __-prefix.
	(clearerr_unlocked, feof_unlocked, ferror_unlocked)
	(fflush_unlocked, fgets_unlocked, fputc_unlocked, fputs_unlocked)
	(fread_unlocked, fwrite_unlocked, getc_unlocked, getchar_unlocked)
	(putc_unlocked, putchar_unlocked) [!_LIBC && !HAVE_DECL_*]: Map to
	non-unlocked functions.
	[!_LIBC]: Add prototypes for __argp_basename and
	__argp_short_program_name.

	* argp/argp-parse.c (argp_default_parser): Only use
	program_invocation{_short,}_name if declared.
	(parser_init): Use __argp_short_program_name.

	* argp/argp-xinl.c [_LIBC || HAVE_FEATURES_H]: Add CPP check for
	'#include features.h'.

	* argp/argp.h [!__attribute__]: Define to nothing.

2003-09-26  Paolo Bonzini  <bonzini@gnu.org>

	* posix/regcomp.c (parse_sub_exp): Pass RE_CARET_ANCHORS_HERE
	for the first token in a subexpression as well.

2003-10-02  Jakub Jelinek  <jakub@redhat.com>

	* posix/regcomp.c (peek_token): Add 2003-09-20 changes for anchor
	handling again.
	(parse_reg_exp): Likewise.
	* posix/regex.h (RE_CARET_ANCHORS_HERE): Define.

	* posix/bug-regex11.c (tests): Add new tests.
	* posix/bug-regex12.c (tests): Add new test.

2003-10-01  Thorsten Kukuk  <kukuk@suse.de>

	* elf/dl-reloc.c (_dl_allocate_static_tls): Move definition of
	variables only used if TLS_DTV_AT_TP is defined into the #if branch.

2003-10-02  Jeroen Dekkers  <jeroen@dekkers.cx>

	* sysdeps/mach/hurd/malloc-machine.h: Copy the tsd code from
	the old thread-m.h header too.

2003-10-02  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/ia64/bits/sigstack.h (MINSIGSTKSZ): Go
	back to 131027 since this is what the kernel enforces.

	* inet/getnameinfo.c: Move domain out of nrl_domainname scope and
	define it with libc_freeres_ptr.

2003-10-01  Roland McGrath  <roland@redhat.com>

	* elf/rtld.c (dl_main): Add cast in last change.

2003-09-10  Chris Demetriou  <cgd@broadcom.com>

	* sysdeps/unix/sysv/linux/mips/mips64/n32/sysdep.h: Remove
	"#if 0" surrounding most of contents.
	(SYSCALL_ERROR_LABEL): Define.
	(__SYSCALL_CLOBBERS): Add $10.
	(internal_syscall7): Remove.
	* sysdeps/unix/sysv/linux/mips/mips64/n64/sysdep.h: Likewise.

2003-09-30  Ulrich Drepper  <drepper@redhat.com>

	* elf/rtld.c (dl_main): Also set l_map_start.

2003-09-30  Daniel Jacobowitz  <drow@mvista.com>

	* elf/rtld.c (dl_main): Set l_libname and l_name for the sysinfo DSO
	to work around kernel problem.

2003-09-27  Wolfram Gloger  <wg@malloc.de>

	* malloc/malloc.c: Include <malloc-machine.h> earlier instead of
	"thread-m.h", so that default parameters can be overridden in a
	system-specific malloc-machine.h.  Remove extra ; from extern "C"
	closing brace.
	* sysdeps/generic/malloc-machine.h: New file.
	* sysdeps/mach/hurd/malloc-machine.h: New file.
	* malloc/thread-m.h: Removed.
	* malloc/Makefile: Remove CFLAGS-malloc.c parameter addition, it
	is in sysdeps/generic/malloc-machine.h now.

2003-09-29  Ulrich Drepper  <drepper@redhat.com>

	* elf/dl-reloc.c (_dl_allocate_static_tls): Move definition of
	variables only used if TLS_TCB_AT_TP is defined into the #if
	branch.

	* sysdeps/unix/sysv/linux/sys/sysmacros.h: Add __extension__ as
	well to cover using long long in C90.

2003-09-28  Alfred M. Szmidt  <ams@kemisten.nu>

	* sysdeps/mach/hurd/bits/libc-lock.h (__libc_cleanup_pop):
	Redefine and use __libc_cleanup_region_end instead.

2003-09-29  Thorsten Kukuk  <kukuk@suse.de>

	* sysdeps/unix/sysv/linux/sys/sysmacros.h: Use __inline and
	fix prototypes for picky C++ compilers.

2003-09-27  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/ustat.c (ustat): Set errno to EINVAL if
	the device ID is invalid and return -1.
	* sysdeps/unix/sysv/linux/xmknod.c (__xmknod): Likewise.

2003-09-26  Andreas Schwab  <schwab@suse.de>

	* sysdeps/unix/sysv/linux/ia64/getcontext.S: Pass fourth argument to
	rt_sigprocmask system call.

2003-09-25  Roland McGrath  <roland@redhat.com>

	* sysdeps/unix/sysv/linux/dl-execstack.c (_dl_make_stack_executable):
	Don't check for zero __libc_stack_end, it should be initialized.
	[_STACK_GROWS_DOWN] [PROT_GROWSDOWN]: Try using PROT_GROWSDOWN flag
	and fall back if it fails with EINVAL.
	[_STACK_GROWS_UP] [PROT_GROWSUP]: Likewise for PROT_GROWSUP.

2003-09-25  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/dl-procinfo.c: Include
	sysdeps/i386/dl-procinfo.c instead of
	sysdeps/unix/sysv/linux/i386/dl-procinfo.c.
	* sysdeps/unix/sysv/linux/i386/dl-procinfo.h: Avoid using
	#include_next.

2003-09-25  Ulrich Drepper  <drepper@redhat.com>

	* posix/regcomp.c (peek_token): Remove recent changes for anchor
	handling again.
	(parse_reg_exp): Likewise.
	* posix/regex.h: Remove RE_CARET_ANCHORS_HERE.

	* csu/Makefile ($(objpfx)version-info.h): Fix sed script to handle
	banners.

	* nis/nis_table.c (nis_list): Always strdup string used with
	ibreq->ibr_name.  Add several NULL pointer checks.

	* nis/nss_nisplus/nisplus-alias.c: Add check for NULL return value
	of nis_list.
	* nis/nss_nisplus/nisplus-ethers.c: Likewise.
	* nis/nss_nisplus/nisplus-grp.c: Likewise.
	* nis/nss_nisplus/nisplus-hosts.c: Likewise.
	* nis/nss_nisplus/nisplus-netgrp.c: Likewise.
	* nis/nss_nisplus/nisplus-network.c: Likewise.
	* nis/nss_nisplus/nisplus-proto.c: Likewise.
	* nis/nss_nisplus/nisplus-publickey.c: Likewise.
	* nis/nss_nisplus/nisplus-pwd.c: Likewise.
	* nis/nss_nisplus/nisplus-rpc.c: Likewise.
	* nis/nss_nisplus/nisplus-service.c: Likewise.
	* nis/nss_nisplus/nisplus-spwd.c: Likewise.

	* sysdeps/unix/sysv/linux/alpha/bits/mman.h: Define PROT_GROWSDOWN
	and PROT_GROWSUP.
	* sysdeps/unix/sysv/linux/arm/bits/mman.h: Likewise.
	* sysdeps/unix/sysv/linux/cris/bits/mman.h: Likewise.
	* sysdeps/unix/sysv/linux/hppa/bits/mman.h: Likewise.
	* sysdeps/unix/sysv/linux/i386/bits/mman.h: Likewise.
	* sysdeps/unix/sysv/linux/ia64/bits/mman.h: Likewise.
	* sysdeps/unix/sysv/linux/m68k/bits/mman.h: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/bits/mman.h: Likewise.
	* sysdeps/unix/sysv/linux/s390/bits/mman.h: Likewise.
	* sysdeps/unix/sysv/linux/sh/bits/mman.h: Likewise.
	* sysdeps/unix/sysv/linux/sparc/bits/mman.h: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/bits/mman.h: Likewise.

2003-09-25  Jakub Jelinek  <jakub@redhat.com>

	* misc/syslog.c: Include locale.h.
	(vsyslog): Add date always in C locale %h %e %T format.

2003-09-24  Paul Eggert  <eggert@twinsun.com>

	* argp/argp-fmtstream.c (__argp_fmtstream_ensure): Check for
	size_t overflow when reallocating storage.
	* argp/argp-help.c (make_hol, hol_append): Likewise.
	(SIZE_MAX): New macro.

2003-08-07  Alfred M. Szmidt  <ams@kemisten.nu>

	* sysdeps/mach/hurd/bits/libc-lock.h
	(__libc_cleanup_push, __libc_cleanup_pop): New macros.

2003-08-01  Alfred M. Szmidt  <ams@kemisten.nu>

	* sysdeps/i386/dl-procinfo.h: New file, contents taken from ...
	* sysdeps/unix/sysv/linux/i386/dl-procinfo.h: ... here.
	#include_next dl-procinfo.h to get them.
	(_DL_HWCAP_COUNT): Moved to sysdeps/i386/dl-procinfo.h.
	(_DL_PLATFORMS_COUNT): Likewise.
	(_DL_FIRST_PLATFORM): Likewise.
	(_DL_HWCAP_PLATFORM): Likewise.
	(HWCAP_I386_FPU, HWCAP_I386_VME, HWCAP_I386_DE, HWCAP_I386_PSE,
	HWCAP_I386_TSC, HWCAP_I386_MSR, HWCAP_I386_PAE, HWCAP_I386_MCE,
	HWCAP_I386_CX8, HWCAP_I386_APIC, HWCAP_I386_SEP, HWCAP_I386_MTRR,
	HWCAP_I386_PGE, HWCAP_I386_MCA, HWCAP_I386_CMOV,
	HWCAP_I386_FCMOV, HWCAP_I386_MMX, HWCAP_I386_OSFXSR,
	HWCAP_I386_XMM, HWCAP_I386_XMM2, HWCAP_I386_AMD3D,
	HWCAP_IMPORTANT): Likewise.
	(_DL_PROCINFO_H_): Likewise.
	(_dl_hwcap_string, _dl_platform_string, _dl_string_hwcap): Likewise.
	(_dl_string_platform): Likewise.
	* sysdeps/unix/sysv/linux/i386/dl-procinfo.c: Moved to ...
	* sysdeps/i386/dl-procinfo.c: ... here, new file.

2003-09-24  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/dl-execstack.c
	(_dl_make_stack_executable): Remember that we changed the permission.

	* sysdeps/ia64/dl-machine.h (RTLD_START): Remove setting of
	__libc_stack_end.  Patch by David Mosberger.

2003-09-24  Jakub Jelinek  <jakub@redhat.com>

	* elf/Versions (ld): Export __libc_stack_end@GLIBC_2.1 instead of
	__libc_stack_end@GLIBC_PRIVATE.

	* sysdeps/generic/dl-sysdep.c (DL_STACK_END): Define if not defined.
	(_dl_sysdep_start): Set __libc_stack_end here.
	* sysdeps/alpha/dl-machine.h (RTLD_START): Remove setting of
	__libc_stack_end.
	* sysdeps/arm/dl-machine.h (RTLD_START): Likewise.
	* sysdeps/cris/dl-machine.h (RTLD_START): Likewise.
	* sysdeps/i386/dl-machine.h (RTLD_START): Likewise.
	* sysdeps/m68k/dl-machine.h (RTLD_START): Likewise.
	* sysdeps/s390/s390-32/dl-machine.h (RTLD_START): Likewise.
	* sysdeps/s390/s390-64/dl-machine.h (RTLD_START): Likewise.
	* sysdeps/sh/dl-machine.h (RTLD_START): Likewise.
	* sysdeps/x86_64/dl-machine.h (RTLD_START): Likewise.
	* sysdeps/ia64/dl-machine.h (DL_STACK_END): Define.
	* sysdeps/sparc/sparc32/dl-machine.h (DL_STACK_END): Define.
	(RTLD_START): Remove setting of __libc_stack_end.
	* sysdeps/sparc/sparc64/dl-machine.h (DL_STACK_END): Define.
	(RTLD_START): Remove setting of __libc_stack_end.

2003-09-24  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/sys/sysmacros.h: Add gnu_dev_ prefix to
	function definitions.  Adjust macro expansions accordingly.
	* sysdeps/unix/sysv/linux/Versions: Add gnu_dev_ prefix to major,
	minor, makedev name.
	* sysdeps/unix/sysv/linux/makedev.c: Likewise.

2003-09-24  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/sys/sysmacros.h (major, minor, makedev):
	Add __THROW.

2003-09-24  Jakub Jelinek  <jakub@redhat.com>

	* nscd/Makefile (others): Add nscd before including ../Rules.

2003-09-24  Ulrich Drepper  <drepper@redhat.com>

	* nscd/Makefile: Add rules to build nscd as a PIE.
	* configure.in: Check for -fpie and -pie compiler options.
	* config.make.in (have-fpie): Define.

2003-09-23  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/sys/sysmacros.h: Adjust for larger
	kernel dev_t size.
	* sysdeps/unix/sysv/linux/alpha/sys/sysmacros.h: Removed.
	* sysdeps/unix/sysv/linux/sparc/sys/sysmacros.h: Removed.
	* sysdeps/unix/sysv/linux/makedev.c: New file.
	* sysdeps/unix/sysv/linux/Dist: Add makedev.c.
	* sysdeps/unix/sysv/linux/Makefile [subdir=misc]
	(sysdep_routines): Add makedev.
	* sysdeps/unix/sysv/linux/Versions [libc] (GLIBC_2.3.3): Add
	major, minor, makedev.
	* sysdeps/unix/sysv/linux/ustat.c (ustat): Adjust for 32-bit
	kernel dev_t.
	* sysdeps/unix/sysv/linux/alpha/ustat.c: Removed.
	* sysdeps/unix/sysv/linux/xmknod.c (__xmknod): Likewise.
	* sysdeps/unix/sysv/linux/alpha/xmknod.c: Removed.
	Code by Alexander Viro <aviro@redhat.com>.

2003-09-23  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/powerpc/powerpc32/Versions [libc]
	(GLIBC_2.3.3): Add setcontext, getcontext, swapcontext, and
	makecontext.
	* sysdeps/unix/sysv/linux/powerpc/sys/ucontext.h: Correct change
	for include Altivec support for PPC32.  It was not compatible.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/ucontext_i.h: Adjust
	offsets for ucontext_t change.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/getcontext.S: Adjust
	for ucontext_t change.  Add compatibility code.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/makecontext.S: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/setcontext.S: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/swapcontext.S: Likewise.
	Patch by Paul Mackerras <paulus@samba.org>.

2003-02-25  Randolph Chung  <tausq@debian.org>

	* sysdeps/hppa/Makefile: Include compat code in build.
	* sysdeps/hppa/libgcc-compat.c: New file.
	* sysdeps/hppa/Dist: Add libgcc-compat.c.
	* sysdeps/hppa/Versions [GLIBC_2.2]: Add __clz_tab.

2003-09-23  Roland McGrath  <roland@redhat.com>

	* elf/rtld.c (dl_main): In rtld_is_main case, reinitialize
	GL(dl_stack_flags) according to rtld's own PT_GNU_STACK.
	Move GL(dl_make_stack_executable_hook) initialization up.
	* elf/tst-execstack-prog.c: New file.
	* elf/Makefile (tests-execstack-yes): Add it.
	(LDFLAGS-tst-execstack-prog): New variable.

2003-09-23  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/x86_64/dl-machine.h (RTLD_START): Set __libc_stack_end
	before calling _dl_start, using %rip relative access.
	Use %rip relative access to _dl_skip_args, _rtld_local._dl_loaded
	and _dl_fini.

2003-09-23  Roland McGrath  <roland@redhat.com>

	* sysdeps/i386/dl-machine.h (RTLD_START): Set __libc_stack_end before
	calling _dl_start, using GOTOFF access.

	* configure.in (libc_cv_z_execstack): New check.
	* configure: Regenerated.
	* config.make.in (have-z-execstack): New variable set by it.
	* elf/tst-execstack.c: New file.
	* elf/tst-execstack-mod.c: New file.
	* elf/tst-execstack-needed.c: New file.
	* elf/Makefile (tests-execstack-yes, modules-execstack-yes): New
	variables.
	(tests, modules-names): Conditionally include them.
	(distribute): Add tst-execstack-mod.c here.
	($(objpfx)tst-execstack, $(objpfx)tst-execstack.out): New targets.
	(LDFLAGS-tst-execstack, LDFLAGS-tst-execstack-mod): New variables.
	($(objpfx)tst-execstack-needed): New target.
	(LDFLAGS-tst-execstack-needed): New variable.

	* sysdeps/generic/ldsodefs.h (struct rtld_global): Add _dl_stack_flags
	and _dl_make_stack_executable_hook.  Declare _dl_make_stack_executable.
	* elf/rtld.c (_rtld_global): Add initializer for _dl_stack_flags.
	(dl_main): Reset _dl_stack_flags according to PT_GNU_STACK phdr.
	Initialize _dl_make_stack_executable_hook.
	* elf/dl-support.c: Define those new variables.
	(_dl_non_dynamic_init): Scan phdrs for PT_GNU_STACK.
	(_dl_phdr): Fix type.
	* elf/dl-load.c (_dl_map_object_from_fd): Grok PT_GNU_STACK phdr and
	enable execute permission for the stack if necessary.
	* sysdeps/generic/dl-execstack.c: New file.
	* elf/Makefile (dl-routines): Add it.
	* elf/Versions (ld: GLIBC_PRIVATE): Add _dl_make_stack_executable.
	* sysdeps/unix/sysv/linux/dl-execstack.c: New file.

2003-09-23  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/posix/sprofil.c (pc_to_index): Remove inline marker.

2003-09-20  Alfred M. Szmidt  <ams@kemisten.nu>

	* sysdeps/generic/utmp_file.c (setutent_file, LOCK_FILE,
	UNLOCK_FILE, setutent_file): Use fcntl_not_cancel instead of
	__fcntl_nocancel.

2003-09-22  Ulrich Drepper  <drepper@redhat.com>

	* malloc/malloc.c: Include <stdint.h>.

2003-09-20  Paolo Bonzini  <bonzini@gnu.org>

	* posix/regcomp.c (build_word_op): Rename like...
	(build_charclass_op): ...this.  Accept two extra parameters,
	CLASS_NAME and EXTRA.  Add EXTRA to the result, not only _.
	(peek_token): Accept \s and \S as OP_SPACE and OP_NOTSPACE.
	(parse_expression): Replace build_word_op with
	build_charclass_op, add new arguments, accept OP_SPACE
	and OP_NOTSPACE.
	* posix/regex_internal.h (re_token_type_t): Add OP_SPACE
	and OP_NOTSPACE.

	* posix/regcomp.c (peek_token): Don't look back for ( or |
	to check whether to treat a caret as special.  It fails
	for the (extended) regex \(^.
	(parse, parse_reg_exp): Pass RE_CARET_ANCHORS_HERE to fetch_token.
	* posix/regex.h: Define RE_CARET_ANCHORS_HERE.

	* posix/regexec.c: Check out of bounds value before shifting.

	* posix/regex_internal.h: Define __attribute for non-gcc.

2003-09-22  Jakub Jelinek  <jakub@redhat.com>

	* include/atomic.h (atomic_compare_and_exchange_val_rel,
	atomic_compare_and_exchange_bool_rel): Swap oldval/newval arguments
	to avoid confusion.

	* sysdeps/unix/opendir.c: Include string.h.

2003-09-22  Ulrich Drepper  <drepper@redhat.com>

	* timezone/zdump.c: Update from tzcode2003c.
	* timezone/zic.c: Likewise.
	* timezone/leapseconds: Update from tzdata2003c.

2003-09-19  Ulrich Drepper  <drepper@redhat.com>

	* elf/Makefile ($(objpfx)librtld.os): Create link map also for
	final build to ease quality control.

	* sysdeps/unix/sysv/linux/getcwd.c (__getcwd): If compiled for
	ld.so, don't include NULL buffer pointer handling.

2003-09-19  Jakub Jelinek  <jakub@redhat.com>

	* dlfcn/dlopen.c (dlopen): Add static_link_warning.

2003-09-18  Jakub Jelinek  <jakub@redhat.com>

	* libio/memstream.c (open_memstream): Use _IO_init instead of
	_IO_old_init.

2003-09-17  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/generic/wordexp.c (eval_expr_val): Use strtol since we
	have to recognize octal and hexadecimal numbers as well.  Simplify
	function, signs are handled in strtol.
	* posix/wordexp-test.c: Add tests for octal and hexadecimal
	numbers in arithmetic expressions.

2003-09-17  Jakub Jelinek  <jakub@redhat.com>

	* elf/Makefile (distribute): Add tst-alignmod.c.
	(tests): Add tst-align.
	(modules-names): Add tst-alignmod.
	(CFLAGS-tst-align.c, CFLAGS-tst-alignmod.c): Add
	$(stack-align-test-flags).
	($(objpfx)tst-align): Depend on libdl.
	($(objpfx)tst-align.out): Depend on tst-alignmod.so.
	* elf/tst-align.c: New file.
	* elf/tst-alignmod.c: New file.
	* misc/Makefile (CFLAGS-tst-tsearch.c): Add $(stack-align-test-flags).
	* misc/tst-tsearch.c: Include tst-stack-align.h.
	(stack_align_check): New array.
	(cmp_fn, walk_action): Use TEST_STACK_ALIGN ().
	(main): Report error if stack was not enough aligned
	in cmp_fn or walk_action.
	* stdlib/Makefile (CFLAGS-tst-qsort.c): Add $(stack-align-test-flags).
	* stdlib/tst-qsort.c: Include tst-stack-align.h.
	(align_check): New var.
	(compare): Use TEST_STACK_ALIGN () macro.
	(main): Report error if stack was not enough aligned in compare.
	* sysdeps/i386/i686/Makefile (stack-align-test-flags): Remove
	unneeded -mpreferred-stack-boundary=4.
	* sysdeps/x86_64/tst-stack-align.h: New file.

	* libio/memstream.c (_IO_wmem_jumps): Remove unused structure.
	(_IO_wmem_sync, _IO_wmem_finish): Remove unused functions.

2003-09-17  Philip Blundell  <philb@gnu.org>

	* sysdeps/arm/dl-machine.h (CALL_ROUTINE): Deleted.
	(BX): Define.
	(ELF_MACHINE_RUNTIME_TRAMPOLINE): Optimise a little.

	* sysdeps/arm/sysdep.h (DO_RET): New.

	* sysdeps/unix/sysv/linux/arm/vfork.S: Add #error if __NR_vfork
	required but not defined.  Improve test of error code.

2003-09-17  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/i386/Makefile (stack-align-test-flags): Add
	-malign-double -mpreferred-stack-boundary=4.

2003-09-17  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/posix/utimes.c (__utimes): Truncate instead of round.
	* sysdeps/unix/sysv/linux/utimes.c (__utimes): Likewise.

2003-09-15  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/i386/Makefile (sysdep-CFLAGS): If not in math or csu
	subdir, add -mpreferred-stack-boundary=4, with few exceptions.

2003-09-17  Jakub Jelinek  <jakub@redhat.com>

	* Makeconfig (stack-align-test-flags): Set.
	* stdlib/Makefile (CFLAGS-tst-bsearch.c): Add
	$(stack-align-test-flags).
	* stdlib/tst-bsearch.c: Include tst-stack-align.h.
	(align_check): New var.
	(comp): Use TEST_STACK_ALIGN macro.
	(do_test): Fail if align_check != 1.
	* sysdeps/generic/tst-stack-align.h: New file.
	* sysdeps/i386/i686/Makefile (stack-align-test-flags): Add -msse.
	* sysdeps/i386/i686/tst-stack-align.h: New file.

2003-09-17  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/i386/clone.S: Make sure child gets a
	stack which is aligned (mod 16).

2003-09-17  Uwe Reimann  <Uwe_Reimann@gmx.net>
	    Hans-Peter Nilsson  <hp@axis.com>

	* sysdeps/cris/dl-machine.h (elf_machine_type_class): Classify
	R_CRIS_GLOB_DAT as ELF_RTYPE_CLASS_PLT.  Clarify comment.

2003-09-17  Jakub Jelinek  <jakub@redhat.com>

	* dirent/scandir.c: Include bits/libc-lock.h.
	(struct scandir_cancel_struct): New type.
	(cancel_handler): New function.
	(SCANDIR): Add __libc_cleanup_{push,pop}, save state into
	scandir_cancel_struct.

2003-09-16  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/Dist: Remove internal_statvfs.c.
	* sysdeps/unix/sysv/linux/Makefile [subdir=io] (sysdep_routines):
	Add internal_statvfs.
	* sysdeps/unix/sysv/linux/fstatvfs.c: Call __internal_statvfs
	instead of including "internal_statvfs.c".
	* sysdeps/unix/sysv/linux/statvfs.c: Likewise.
	* sysdeps/unix/sysv/linux/internal_statvfs.c: Make it a real function.
	Add code to avoid the stat calls on all the reported mount points
	when we can determine mismatch in advance.
	* sysdeps/unix/sysv/linux/linux_fsinfo.h: Add AUTOFS_SUPER_MAGIC and
	USBDEVFS_SUPER_MAGIC.

2003-09-16  Jakub Jelinek  <jakub@redhat.com>

	* posix/Versions (sched_getaffinity, sched_setaffinity): Change
	from GLIBC_2.3.2 to GLIBC_2.3.3 symbol version.

2003-09-16  Bruno Haible  <bruno@clisp.org>

	* intl/tst-gettext2.sh: Set GCONV_PATH and LOCPATH only after
	invoking msgfmt, not before.

2003-09-15  Jakub Jelinek  <jakub@redhat.com>

	* argp/argp.h (argp_parse, __argp_parse): Remove __THROW.
	* argp/Makefile (CFLAGS-argp-help.c, CFLAGS-argp-parse.c): Add
	$(uses-callbacks).
	* dirent/Makefile (CFLAGS-scandir.c, CFLAGS-scandir64.c): Likewise.
	* elf/Makefile (CFLAGS-dl-iterate-phdr.c,
	CFLAGS-dl-iterate-phdr-static.c): Add $(uses-callbacks).
	* elf/dl-iteratephdr.c (cancel_handler): New function.
	(__dl_iterate_phdr): Add __libc_cleanup_{push,pop}.
	* elf/link.h (dl_iterate_phdr): Remove __THROW.
	* io/Makefile (CFLAGS-fts.c): Merge into one assignment.
	Add $(uses-callbacks).
	(CFLAGS-ftw.c, CFLAGS-ftw64.c): Add $(uses-callbacks).
	* misc/Makefile (CFLAGS-tsearch.c, CFLAGS-lsearch.c): Change
	$(exceptions) to $(uses-callbacks).
	* Makeconfig (uses-callbacks): Set to $(exceptions).
	* posix/Makefile (CFLAGS-glob.c, CFLAGS-glob64.c): Add
	$(uses-callbacks).
	* stdlib/Makefile (CFLAGS-bsearch.c, CFLAGS-msort.c, CFLAGS-qsort.c):
	Likewise.

2003-09-15  Andreas Schwab  <schwab@suse.de>

	* sysdeps/m68k/setjmp.c: Add hidden_def.

2003-09-14  Ulrich Drepper  <drepper@redhat.com>

	* libio/memstream.c (open_memstream): Don't allow wide char operations.

	* dirent/dirent.h: Remove __THROW from scandir.

2003-09-14  Philip Blundell  <philb@gnu.org>

	* sysdeps/unix/sysv/linux/arm/mmap.S: Use sys_mmap2 if it's known
	to be available.

	* sysdeps/unix/sysv/linux/arm/mmap64.S: Optimise code a little.

	* sysdeps/arm/memset.S: Rewrite.

2003-09-12  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/s390/bits/typesizes.h: New.
	(__SSIZE_T_TYPE): Define to __SWORD_TYPE for gcc 2.95.x and
	__SLONGWORD_TYPE otherwise.

2003-09-14  Ulrich Drepper  <drepper@redhat.com>

	* io/Makefile (CFLAGS-ftw.c): Add -fexceptions.
	(CFLAGS-ftw64.c): Likewise.

2003-09-13  Ulrich Drepper  <drepper@redhat.com>

	* nscd/Makefile (CFLAGS-nscd_getpw_r.c): Add -fexceptions.
	(CFLAGS-nscd_getgr_r.c): Likewise.
	(CFLAGS-nscd_gethst_r.c): Likewise.

2003-09-12  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/if_index.c: Use only non-cancelable
	interfaces.

	* grp/Makefile (CFLAGS-getgrgid_r.c, CFLAGS-getgrnam_r.c,
	CFLAGS-fgetgrent.c, CFLAGS-fgetgrent_r.c, CFLAGS-putgrent.c,
	CFLAGS-initgroups.c, CFLAGS-getgrgid.c): Add -fexceptions.
	* inet/Makefile (CFLAGS-either_ntoh.c, CFLAGS-either_hton.c,
	CFLAGS-getnetgrent.c, CFLAGS-getnetgrent_r.c): Likewise.
	* io/Makefile (CFLAGS-posix_fallocate.c, CFLAGS-posix_fallocate64.c):
	Likewise.
	* misc/Makefile (CFLAGS-err.c): Likewise.
	* posix/Makefile (CFLAGS-getaddrinfo.c, CFLAGS-spawn.c,
	CFLAGS-spawnp.c, CFLAGS-spawni.c, CFLAGS-pause.c, CFLAGS-glob.c,
	CFLAGS-glob64.c): Likewise.
	* pwd/Makefile (CFLAGS-getpw.c): Likewise.
	* shadow/Makefile (CFLAGS-fgetspent.c, CFLAGS-fgetspent_r.c,
	CFLAGS-putspent.c, CFLAGS-getspnam.c, CFLAGS-getspnam_r.c): Likewise.
	* stdio-common/Makefile (CFLAGS-cuserid.c): Likewise.
	* sunrpc/Makefile (CFLAGS-openchild.c): Likewise.

	* stdlib/Makefile (CFLAGS-mkstemp.c): Remove definition.

	* libio/stdio.h: Remove __THROW from cuserid prototype.

	* locale/loadarchive.c: Use only non-cancelable interfaces.
	* resolv/herror.c (herror): Likewise.

	* malloc/hooks.c: Before using IO stream mark stream so it uses
	only non-cancelable interfaces.
	* malloc/malloc.c: Likewise.
	* posix/getopt.c: Likewise.


2003-09-11  Jakub Jelinek  <jakub@redhat.com>

	* Makerules (LDFLAGS-c.so): Remove -u __register_frame.

2003-09-12  Ulrich Drepper  <drepper@redhat.com>

	* stdio-common/stdio_ext.h: Mark most functions with __THROW.

	* misc/err.h: Remove __THROW from all prototypes.

	* posix/getopt.h (__THROW): Define if not already defined.  Add
	__THROW to the getopt functions.

2003-09-11  Ulrich Drepper  <drepper@redhat.com>

	* io/Makefile (CFLAGS-lockf.c): Add -fexceptions.
	(CFLAGS-fts.c): Likewise.
	* io/fcntl.h: Remove __THROW from lockf prototypes.
	* io/fts.h: Remove most __THROW.

2003-09-11  H.J. Lu  <hongjiu.lu@intel.com>

	* elf/tls-macros.h (TLS_IE): Add a stop bit for ia64.
	(TLS_LD): Likewise.
	(TLS_GD): Likewise.

2003-09-11  Jakub Jelinek  <jakub@redhat.com>

	* libio/fileops.c (_IO_new_file_overflow): Add INTUSE to
	_IO_free_backup_area call.

2003-09-10  Chris Demetriou  <cgd@broadcom.com>

	* sysdeps/unix/sysv/linux/mips/pread64.c (__libc_pread64): Fix
	syscall invocation.
	* sysdeps/unix/sysv/linux/mips/pwrite64.c (__libc_pwrite64): Likewise.
	* sysdeps/unix/sysv/linux/mips/pread.c (__libc_pread): Likewise.
	Also, only assert off_t size is 4 for N32 and O32, and clean up
	white space.
	* sysdeps/unix/sysv/linux/mips/pwrite.c (__libc_pwrite): Likewise.

2003-09-10  Roland McGrath  <roland@redhat.com>

	* sysdeps/unix/sysv/linux/tcgetattr.c (__tcgetattr):
	Don't use c_ispeed under [! _HAVE_STRUCT_TERMIOS_C_ISPEED].
	Don't use c_ospeed under [! _HAVE_STRUCT_TERMIOS_C_OSPEED].
	* sysdeps/unix/sysv/linux/tcsetattr.c (tcsetattr): Likewise.
	Reported by Daniel Jacobowitz  <drow@mvista.com>.

2003-09-10  Jakub Jelinek  <jakub@redhat.com>

	* string/Makefile (strop-tests): Add memccpy.
	* string/test-memccpy.c: New test.

2003-09-09  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/sigcontextinfo.h (SIGCONTEXT): Add
	siginfo_t * argument before, change into struct ucontext *.
	(SIGCONTEXT_EXTRA_ARGS): Define to _si,.
	(GET_PC, GET_FRAME, GET_STACK): Adjust for ctx being a pointer
	instead of structure.
	* sysdeps/unix/sysv/linux/x86_64/register-dump.h (REGISTER_DUMP):
	Likewise.

2003-09-09  Ulrich Drepper  <drepper@redhat.com>

	* string/stratcliff.c (main): Check memccpy.

2003-04-11  Jes Sorensen  <jes@wildopensource.com>

	* sysdeps/ia64/memccpy.S: When recovering for src_aligned and the
	character is found during recovery, use correct register when
	determining the position of the found character.

2003-04-01  Jes Sorensen  <jes@wildopensource.com>

	* sysdeps/ia64/memccpy.S: Use speculatively loads for readahead to
	avoid segfaults when reading from unmapped pages. For aligned
	reload and continue, for misaligned, roll back and use byte copy.
	Save ar.ec on entry and restore on exit.

2003-09-09  Chris Demetriou  <cgd@broadcom.com>

	* sysdeps/unix/mips/sysdep.h (PSEUDO_END): Undef before defining.

2003-09-08  Chris Demetriou  <cgd@broadcom.com>

	* sysdeps/mips/mips64/n32/Implies: Move ieee754/ldbl-128 to
	the top of the list.
	* sysdeps/mips/mips64/n64/Implies: Likewise.

2003-09-08  Roland McGrath  <roland@frob.com>

	* sysdeps/unix/sysv/linux/speed.c
	(cfsetospeed): Only set c_ospeed under [_HAVE_STRUCT_TERMIOS_C_OSPEED].
	(cfsetispeed): Only set c_ispeed under [_HAVE_STRUCT_TERMIOS_C_ISPEED].
	* sysdeps/unix/sysv/linux/bits/termios.h
	(_HAVE_STRUCT_TERMIOS_C_ISPEED, _HAVE_STRUCT_TERMIOS_C_OSPEED): Define.
	* sysdeps/unix/sysv/linux/alpha/bits/termios.h: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/bits/termios.h: Likewise.

2003-09-08  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/register-dump.h: Undo last change.
	* sysdeps/unix/sysv/linux/x86_64/sigcontextinfo.h: Likewise.

2003-09-08  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/generic/bits/types.h (__quad_t): Make long int if 64-bit.
	(__u_quad_t): Make unsigned long int if 64-bit.
	(__SQUAD_TYPE): Make long int if 64-bit.
	(__UQUAD_TYPE): Make unsigned long int if 64-bit.
	* sysdeps/unix/sysv/linux/s390/bits/typesizes.h: Remove.

2003-09-08  Ulrich Drepper  <drepper@redhat.com>

	* Makefile (tests): Run check-c++-types.sh if possible.
	* scripts/check-c++-types.h: New file.
	* scripts/data/c++-types-i386-linux-gnu.data: New file.

2003-09-08  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/x86_64/register-dump.h (register_dump):
	Use struct sigcontext.

	* sysdeps/unix/sysv/linux/x86_64/sigcontextinfo.h (SIGCONTEXT):
	Use struct sigcontext.
	(GET_PC): Adopt.
	(GET_FRAME): Likewise.
	(GET_STACK): Likewise.

2003-09-08  Wolfram Gloger  <wg@malloc.de>

	* malloc/malloc.c (sYSMALLOc): Move foreign sbrk accounting into
	contiguous case.  Bug report from Prem Gopalan <prem@mazunetworks.com>.
	(mALLOPt): Avoid requirement of C99.

2003-09-08  Ulrich Drepper  <drepper@redhat.com>

	* libio/bug-ftell.c: Include <sys/types.h>.
	(main): Mark cp as const.

2003-09-07  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/syscalls.list (fcntl): Remove.
	* sysdeps/unix/sysv/linux/x86_64/fcntl.c: Remove.

2003-09-05  Roland McGrath  <roland@redhat.com>

	* sysdeps/unix/sysv/linux/tcgetattr.c (__tcgetattr): Fill in c_ispeed
	and c_ospeed fields.
	* sysdeps/unix/sysv/linux/speed.c (cfsetospeed): Set c_ospeed field.
	(cfsetispeed): Set c_ispeed field.
	* sysdeps/unix/sysv/linux/tcsetattr.c (IBAUD0): Define unconditionally
	to match corresponding speed.c code.

2003-09-06  Ulrich Drepper  <drepper@redhat.com>

	* libio/wfileops.c (_IO_wfile_underflow): Mark beginning of the
	narrow character buffer.
	* libio/Makefile: Add rules to build and run bug-ftell.
	* libio/bug-ftell.c: New file.

	* stdio-common/vfprintf.c: Don't use the first grouping number twice.

	* stdio-common/vfscanf.c (vfscanf): Fix recognition of characters
	matching the decimal point and possibly leading the thousands
	separator.  This caused the recognition of thousands separators to
	always fail.

2003-09-05  Ulrich Drepper  <drepper@redhat.com>

	* libio/fileops.c (_IO_new_file_overflow): Handle switching to
	write mode from read in backup buffer.
	* libio/Makefile (tests): Add bug-ungetc2.
	* libio/bug-ungetc2.c: New file.

2003-09-05  Roland McGrath  <roland@redhat.com>

	* nss/getXXbyYY.c (FUNCTION_NAME): Remove unused variable.

2003-09-04  Roland McGrath  <roland@frob.com>

	* sysdeps/mach/hurd/mmap.c (__mmap): If io_map fails with MIG_BAD_ID,
	EOPNOTSUPP, or ENOSYS, change it to ENODEV.

2003-09-04  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/unix/sysv/linux/ia64/bits/sigstack.h (MINSIGSTKSZ):
	Fix a typo.

2003-09-05  Andreas Jaeger  <aj@suse.de>

	* sysdeps/i386/bits/string.h (__memrchr): Do addition in assembler
	to make it conforming C.
	* sysdeps/i386/i486/bits/string.h (__memrchr): Likewise.

	* sysdeps/unix/sysv/linux/i386/fcntl.c (__fcntl_nocancel): Change
	prototype to use variable argument lists and get the possible one
	argument via va_arg.
	* sysdeps/unix/sysv/linux/fcntl.c (__fcntl_nocancel): Likewise.
	* sysdeps/unix/sysv/linux/x86_64/fcntl.c: New.

2003-09-04  Ulrich Drepper  <drepper@redhat.com>

	* posix/unistd.h: Add back __THROW to sysconf, pathconf, fpathconf.

	* sysdeps/unix/sysv/linux/pathconf.c (__statfs_filesize_max):
	Report correct value for vxfs.
	* sysdeps/unix/sysv/linux/linux_fsinfo.h: Define VXFS_SUPER_MAGIC.

	* gmon/gmon.c: Use only not-cancelable syscalls to write profiling
	data.

	* sysdeps/generic/utmp_file.c: Use not-cancelable syscalls all
	over the place.  It would be allowed to have these functions as
	cancellation points but the cleanup would be ugly and a lot of
	work.

	* sysdeps/generic/not-cancel.h (fcntl_not_cancel): Define.
	* sysdeps/unix/sysv/linux/not-cancel.h (fcntl_not_cancel): Define.

	* include/fcntl.h (__fcntl_nocancel): Declare.
	* sysdeps/unix/sysv/linux/fcntl.c: New file.
	* sysdeps/unix/sysv/linux/i386/fcntl.c (__libc_fcntl): Only enable
	cancellation if absolutely needed.
	(__fcntl_nocancel): Define.

	* posix/unistd.h (gethostid): Remove __THROW.  Clarify comment.
	* sysdeps/unix/sysv/linux/Makefile (CFLAGS-gethostid.c): Add
	-fexceptions.
	* sysdeps/unix/sysv/linux/gethostid.c (gethostid): Use
	extend_alloca.

	* resolv/res_init.c (__res_nclose): Use close_not_cancel_no_status
	instead of __close.

	* nss/getXXbyYY.c (FUNCTION_NAME): Add a few casts.  Remove
	unnecessary errno handling.

	* nss/getXXbyYY_r.c (INTERNAL): Use better variable name.
	Initialize it in all cases.  Change it to be a bit more like the
	code we had before.

2003-09-04  Jakub Jelinek  <jakub@redhat.com>

	* libio/fileops.c (_IO_file_read, _IO_new_file_write): Add
	__builtin_expect.
	(_IO_file_open): Likewise.  Use close_not_cancel.

2003-09-04  Ulrich Drepper  <drepper@redhat.com>

	* libio/libio.h: Define _IO_FLAGS2_NOTCANCEL.
	* libio/fileops.c [_LIBC]: Remove close macro.
	(_IO_file_open): If _IO_FLAGS2_NOTCANCEL is set, use open_not_cancel.
	(_IO_new_file_open): Recognize 'c' flag in mode string.
	(_IO_file_read): If _IO_FLAGS2_NOTCANCEL is set use read_not_cancel.
	(_IO_new_file_write): If _IO_FLAGS2_NOTCANCEL is set use
	write_not_cancel.
	* iconv/gconv_conf.c: Use fopen with 'c' mode flag.
	* inet/rcmd.c: Likewise.
	* inet/ruserpass.c: Likewise.
	* intl/localealias.c: Likewise.
	* malloc/mtrace.c: Likewise.
	* misc/getpass.c: Likewise.
	* misc/getttyent.c: Likewise.
	* misc/mntent_r.c: Likewise.
	* misc/getusershell.c: Likewise.
	* nss/nsswitch.c: Likewise.
	* resolv/res_hconf.c: Likewise.
	* resolv/res_init.c: Likewise.
	* sysdeps/unix/sysv/linux/getsysstats.c: Likewise.
	* time/getdate.c: Likewise.
	* time/tzfile.c: Likewise.
	* misc/fstab.h: Undo last change.
	* misc/mntent.h: Likewise.
	* misc/Makefile: Remove CFLAGS-mntent_r.c, CFLAGS-mntent.c, and
	CFLAGS-fstab.c definition.

2003-09-04  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/generic/unwind.h (_Unwind_GetBSP): Add prototype.

2003-09-03  Ulrich Drepper  <drepper@redhat.com>

	* nss/getXXbyYY_r.c (INTERNAL): Explicitly set errno and avoid
	returning ERANGE if this wasn't intended.

2003-09-03  Jakub Jelinek  <jakub@redhat.com>

	* intl/loadmsgcat.c (open, close, read, mmap, munmap): Define as
	function-like macros.

2003-09-03  Ulrich Drepper  <drepper@redhat.com>

	* grp/Makefile (CFLAGS-getgrent_r.c): Add -fexceptions.
	(CFLAGS-getgrent.c): Likewise.
	* pwd/Makefile (CFLAGS-getpwent_r.c): Add -fexceptions.
	(CFLAGS-getpwent.c): Likewise.
	* shadow/Makefile (CFLAGS-getspent_r.c): Add -fexceptions.
	(CFLAGS-getspent.c): Likewise.

	* inet/Makefile: Add -fexceptions to CFLAGS for the various
	getXXent and getXXbyYY functions.

	* locale/loadlocale.c: Use not-cancelable variants of open, close,
	and read.

2003-09-02  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/alpha/Makefile (sysdep_routines): Remove
	rt_sigsuspend, rt_sigprocmask, rt_sigtimedwait, rt_sigqueueinfo and
	rt_sigpending.
	* sysdeps/unix/sysv/linux/alpha/sigaction.c (__syscall_rt_sigaction):
	New prototype.
	* sysdeps/unix/sysv/linux/arm/syscalls.list (__syscall_*): Remove
	unused __syscall_ stubs.
	* sysdeps/unix/sysv/linux/arm/Makefile (sysdep_routines): Remove
	rt_*.
	* sysdeps/unix/sysv/linux/cris/Makefile: Removed.
	* sysdeps/unix/sysv/linux/mips/mips64/syscalls.list
	(__syscall_recvfrom, __syscall_sendto): Remove unused aliases.
	* sysdeps/unix/sysv/linux/mips/syscalls.list (__syscall_*): Remove
	unused __syscall_ stubs.
	* sysdeps/unix/sysv/linux/mips/Makefile (sysdep_routines): Remove rt_*.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/syscalls.list
	(__syscall_*): Remove unused __syscall_ stubs.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/syscalls.list
	(__syscall_*): Likewise.
	* sysdeps/unix/sysv/linux/powerpc/Makefile (sysdep_routines): Remove
	rt_*.
	* sysdeps/unix/sysv/linux/s390/s390-64/syscalls.list (__syscall_*):
	Remove unused __syscall_ stubs.
	* sysdeps/unix/sysv/linux/sh/Makefile (sysdep_routines): Remove rt_*.
	* sysdeps/unix/sysv/linux/rt_sigaction.c: Removed.
	* sysdeps/unix/sysv/linux/rt_sigpending.c: Removed.
	* sysdeps/unix/sysv/linux/rt_sigprocmask.c: Removed.
	* sysdeps/unix/sysv/linux/rt_sigqueueinfo.c: Removed.
	* sysdeps/unix/sysv/linux/rt_sigreturn.c: Removed.
	* sysdeps/unix/sysv/linux/rt_sigsuspend.c: Removed.
	* sysdeps/unix/sysv/linux/rt_sigtimedwait.c: Removed.
	* sysdeps/unix/sysv/linux/s_pread64.c: Removed.
	* sysdeps/unix/sysv/linux/s_pwrite64.c: Removed.
	* sysdeps/unix/sysv/linux/alpha/gethostname.c: Remove unused
	__syscall_* prototypes.
	* sysdeps/unix/sysv/linux/alpha/ipc_priv.h: Likewise.
	* sysdeps/unix/sysv/linux/alpha/msgctl.c: Likewise.
	* sysdeps/unix/sysv/linux/alpha/semctl.c: Likewise.
	* sysdeps/unix/sysv/linux/alpha/shmctl.c: Likewise.
	* sysdeps/unix/sysv/linux/arm/sigaction.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/chown.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/fchown.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/fcntl.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/fxstat.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/getegid.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/geteuid.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/setuid.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/getgid.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/getgroups.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/getmsg.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/xstat.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/getresgid.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/getresuid.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/getrlimit.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/getuid.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/lchown.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/lockf64.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/lxstat.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/putmsg.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/setfsgid.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/setfsuid.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/setgid.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/setgroups.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/setregid.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/setresgid.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/setresuid.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/setreuid.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/setrlimit.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/sigaction.c: Likewise.
	* sysdeps/unix/sysv/linux/ia64/fxstat.c: Likewise.
	* sysdeps/unix/sysv/linux/ia64/lxstat.c: Likewise.
	* sysdeps/unix/sysv/linux/ia64/sigaction.c: Likewise.
	* sysdeps/unix/sysv/linux/ia64/sigpending.c: Likewise.
	* sysdeps/unix/sysv/linux/ia64/sigprocmask.c: Likewise.
	* sysdeps/unix/sysv/linux/ia64/sigsuspend.c: Likewise.
	* sysdeps/unix/sysv/linux/ia64/xstat.c: Likewise.
	* sysdeps/unix/sysv/linux/m68k/chown.c: Likewise.
	* sysdeps/unix/sysv/linux/mips/ftruncate64.c: Likewise.
	* sysdeps/unix/sysv/linux/mips/pread.c: Likewise.
	* sysdeps/unix/sysv/linux/mips/pread64.c: Likewise.
	* sysdeps/unix/sysv/linux/mips/ptrace.c: Likewise.
	* sysdeps/unix/sysv/linux/mips/pwrite.c: Likewise.
	* sysdeps/unix/sysv/linux/mips/pwrite64.c: Likewise.
	* sysdeps/unix/sysv/linux/mips/sigaction.c: Likewise.
	* sysdeps/unix/sysv/linux/mips/truncate64.c: Likewise.
	* sysdeps/unix/sysv/linux/mips/ustat.c: Likewise.
	* sysdeps/unix/sysv/linux/mips/xmknod.c: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/chown.c: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/ioctl.c: Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-32/chown.c: Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-32/lchown.c: Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-64/xstat.c: Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-64/fxstat.c: Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-64/lxstat.c: Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-64/sigaction.c: Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-64/sigpending.c: Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-64/sigprocmask.c: Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-64/sigsuspend.c: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc64/sigpending.c: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc64/sigprocmask.c: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/sigaction.c: Likewise.
	* sysdeps/unix/sysv/linux/pwrite.c: Likewise.
	* sysdeps/unix/sysv/linux/execve.c: Likewise.
	* sysdeps/unix/sysv/linux/aio_sigqueue.c: Likewise.
	* sysdeps/unix/sysv/linux/reboot.c: Likewise.
	* sysdeps/unix/sysv/linux/_exit.c: Likewise.
	* sysdeps/unix/sysv/linux/ftruncate64.c: Likewise.
	* sysdeps/unix/sysv/linux/pwrite64.c: Likewise.
	* sysdeps/unix/sysv/linux/fxstat64.c: Likewise.
	* sysdeps/unix/sysv/linux/gai_sigqueue.c: Likewise.
	* sysdeps/unix/sysv/linux/readahead.c: Likewise.
	* sysdeps/unix/sysv/linux/getcwd.c: Likewise.
	* sysdeps/unix/sysv/linux/sigwait.c: Likewise.
	* sysdeps/unix/sysv/linux/getdents.c: Likewise.
	* sysdeps/unix/sysv/linux/readv.c: Likewise.
	* sysdeps/unix/sysv/linux/getpriority.c: Likewise.
	* sysdeps/unix/sysv/linux/sigaction.c: Likewise.
	* sysdeps/unix/sysv/linux/ipc_priv.h: Likewise.
	* sysdeps/unix/sysv/linux/llseek.c: Likewise.
	* sysdeps/unix/sysv/linux/sysctl.c: Likewise.
	* sysdeps/unix/sysv/linux/lxstat64.c: Likewise.
	* sysdeps/unix/sysv/linux/mmap64.c: Likewise.
	* sysdeps/unix/sysv/linux/ustat.c: Likewise.
	* sysdeps/unix/sysv/linux/poll.c: Likewise.
	* sysdeps/unix/sysv/linux/pread64.c: Likewise.
	* sysdeps/unix/sysv/linux/writev.c: Likewise.
	* sysdeps/unix/sysv/linux/pread.c: Likewise.
	* sysdeps/unix/sysv/linux/ptrace.c: Likewise.
	* sysdeps/unix/sysv/linux/sigpending.c: Likewise.
	* sysdeps/unix/sysv/linux/sigprocmask.c: Likewise.
	* sysdeps/unix/sysv/linux/sigqueue.c: Likewise.
	* sysdeps/unix/sysv/linux/sigsuspend.c: Likewise.
	* sysdeps/unix/sysv/linux/sigtimedwait.c: Likewise.
	* sysdeps/unix/sysv/linux/sigwaitinfo.c: Likewise.
	* sysdeps/unix/sysv/linux/truncate64.c: Likewise.
	* sysdeps/unix/sysv/linux/xmknod.c: Likewise.
	* sysdeps/unix/sysv/linux/xstat64.c: Likewise.

2003-09-02  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/i386/sysdep.h (PSEUDO): Revert last change.
	* sysdeps/unix/sysv/linux/powerpc/syscalls.list: New file.
	* sysdeps/unix/sysv/linux/sparc/syscalls.list: New file.

2003-09-02  Ulrich Drepper  <drepper@redhat.com>

	* stdio-common/Makefile (CFLAGS-vprintf.c): Add -fexceptions.

	* intl/loadmsgcat.c: For _LIBC, call not cancelable versions of
	open, close, and read.

	* sysdeps/unix/sysv/linux/i386/sysdep.h (PSEUDO): Also define
	*_nocancel name.

	* sysdeps/unix/sysv/linux/i386/syscalls.list: Add waitpid.

	* libio/Makefile (CFLAGS-oldtmpfile.c): Add -fexceptions.
	* sysdeps/generic/tmpfile.c (tmpfile): Use __unlink instead of remove.
	* libio/oldtmpfile.c (__old_tmpfile): Likewise.

	* misc/Makefile (CFLAGS-getusershell.c): Add -fexceptions.

	* io/Makefile (CFLAGS-statfs.c): Add -fexceptions.
	(CFLAGS-fstatfs.c): Likewise.
	(CFLAGS-statvfs.c): Likewise.
	(CFLAGS-fstatvfs.c): Likewise.

2003-09-01  Ulrich Drepper  <drepper@redhat.com>

	* misc/Makefile (CFLAGS-getsysstats.c): Add -fexceptions.
	* posix/unistd.h: Remove __THROW from pathconf, fpathconf,
	sysconf.
	* posix/Makefile (CFLAGS-sysconf.c): Add -fexceptions.
	(CFLAGS-pathconf.c): Likewise.
	(CFLAGS-fpathconf.c): Likewise.

	* misc/Makefile (CFLAGS-fstab.c): Add -fexceptions.
	* misc/fstab.h: Remove all __THROW.
	* misc/Makefile (CFLAGS-mntent.c): Add -fexceptions.
	(CFLAGS-mntent_r.c): Likewise.
	* misc/mntent.h: Remove most __THROW.

	* misc/Makefile (CFLAGS-mkstemp.c): Add -fexceptions.
	(CFLAGS-mkstemp64.c): Likewise.

	* sysdeps/generic/wordexp.c (parse_comm): Disable cancellation
	around call to exec_comm.
	* posix/wordexp.h: Remove __THROW from wordexp.
	* posix/Makefile (CFLAGS-wordexp.c): Add -fexceptions.

	* sysdeps/unix/sysv/linux/getloadavg.c (getloadavg): Use
	not-cancelable functions.

	* libio/Makefile (CFLAGS-oldiofopen.c): Add -fexceptions.
	(CFLAGS-iofopen.c): Likewise.
	(CFLAGS-iofopen64.c): Likewise.

	* stdlib/fmtmsg.c (fmtmsg): Disable cancellation around output
	functions.
	* stdlib/Makefile (CFLAGS-fmtmsg.c): Add -fexceptions.
	* stdlib/fmtmsg.h: Remove __THROW from fmtmsg.

	* stdlib/stdlib.h: Remove __THROW from posix_openpt and getpt.
	* login/Makefile (CFLAGS-getpt.c): Add -fexceptions.

2003-09-01  Thorsten Kukuk  <kukuk@suse.de>

	* nis/nss_compat/compat-spwd.c (getspnam_plususer): Return
	NSS_STATUS_SUCCESS if entry was found.
	(getspent_next_file): Store user in blacklist after entry
	was found, use innetgr.

2003-09-01  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/powerpc/powerpc32/posix_fadvise.c: New.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/posix_fadvise64.c: New.

	* sysdeps/generic/dl-tls.c (_dl_determine_tlsoffset): Fix tls offset
	computation for TCB_AT_TP.  Support l_firstbyte_offset != 0 for
	DTV_AT_TP, optimize.

2003-08-31  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* sysdeps/unix/sysv/linux/sh/Versions: Add posix_fadvise64 and
	posix_fallocate64 at GLIBC_2.3.3.
	* sysdeps/unix/sysv/linux/sh/sysdep.h (PSEUDO_ERRVAL): Define.
	(PSEUDO_END_ERRVAL, ret_ERRVAL): Likewise.

2003-08-08  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/unix/sysv/linux/ia64/syscalls.list: Remove __syscall_
	functions.

2003-08-31  Ulrich Drepper  <drepper@redhat.com>

	* libio/libioP.h (_IO_acquire_lock_fct): Define as inline function.
	Code by Richard Henderson.

2003-08-31  Philip Blundell  <philb@gnu.org>

	* sysdeps/unix/sysv/linux/arm/Versions: Add posix_fadvise64 and
	posix_fallocate64 at GLIBC_2.3.3.

2003-08-31  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/x86_64/bsd-_setjmp.S: Use HIDDEN_JUMPTARGET.
	* include/setjmp.h: Add libc_hidden_proto for __sigsetjmp.

2003-08-30  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/generic/sysdep.h (cfi_window_save, CFI_WINDOW_SAVE): Define.
	* sysdeps/unix/sysv/linux/sparc/bits/setjmp.h: Allow file to be
	included multiple times.
	* sysdeps/unix/sysv/linux/sparc/sparc32/clone.S (__clone): Pass
	ptid, tls, ctid arguments to the kernel.
	* sysdeps/unix/sysv/linux/sparc/sparc32/getpagesize.c (__getpagesize):
	Use INTERNAL_SYSCALL instead of __syscall_getpagesize.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sigaction.c
	(__libc_sigaction): Use INLINE_SYSCALL instead of
	__syscall_rt_sigaction.
	* sysdeps/unix/sysv/linux/sparc/sparc32/syscalls.list
	(__syscall_getgroups, __syscall_getpagesize, __syscall__llseek,
	__syscall_setfsgid, __syscall_setfsuid, __syscall_setgid,
	__syscall_setgroups, __syscall_setregid, __syscall_setreuid,
	__syscall_ipc, __syscall_setuid, __syscall_rt_sigaction,
	__syscall_rt_sigpending, __syscall_rt_sigprocmask,
	__syscall_rt_sigqueueinfo, __syscall_rt_sigsuspend,
	__syscall_rt_sigtimedwait): Remove unneeded syscall stubs.
	* sysdeps/unix/sysv/linux/sparc/sparc32/Makefile (sysdep_routines):
	Remove rt_sigsuspend, rt_sigprocmask, rt_sigtimedwait,
	rt_sigqueueinfo, rt_sigaction and rt_sigpending.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sysdep.h
	(__CLONE_SYSCALL_STRING): Define.
	* sysdeps/unix/sysv/linux/sparc/sparc32/socket.S (__socket): Add
	CFI directives.
	* sysdeps/unix/sysv/linux/sparc/sparc64/sysdep.h
	(__CLONE_SYSCALL_STRING): Define.
	* sysdeps/unix/sysv/linux/sparc/sysdep.h (INLINE_CLONE_SYSCALL):
	Define.
	* sysdeps/unix/sysv/linux/sparc/system.c: New file.

2003-08-30  Ulrich Drepper  <drepper@redhat.com>

	* sunrpc/rpc/clnt.h: Remove a few __THROW.
	* sunrpc/Makefile (CFLAGS-auth_unix.c): Add -fexceptions.
	(CFLAGS-key_call.c): Likewise.
	(CFLAGS-pmap_rmt.c): Likewise.
	(CFLAGS-clnt_perr.c): Likewise.
	* sunrpc/rpc/auth.h: Remove serveral __THROW.

	* inet/Makefile (CFLAGS-gethstbyad_r.c): Add -fexceptions.
	(CFLAGS-gethstbynm_r.c): Likewise.
	(CFLAGS-gethstbynm2_r.c): Likewise.
	(CFLAGS-rcmd.c): Likewise.
	* resolv/Makefile (CFLAGS-res_hconf.c): Add -fexceptions.

	* argp/Makefile (CFLAGS-argp-help.c): Add -fexceptions.
	(CFLAGS-argp-fmtstream.c): Likewise.
	* argp/argp.h: Remove a number of __THROW.

	* misc/sys/syslog.h (vsyslog): Remove __THROW.

	* misc/Makefile (CFLAGS-getpass.c): Add -fexceptions.
	* misc/getpass.c (getpass): Add cleanup handler to ensure the
	stream is closed even if the thread is canceled.
	(call_fclose): New function.
	* posix/unistd.h: Remove __THROW from getpass prototype.

	* posix/Makefile (CFLAGS-getopt.c): Add -fexceptions.

	* signal/signal.h (psignal): Remove __THROW.
	* stdio-common/Makefile (CFLAGS-psignal.c): Add -fexceptions.

	* misc/Makefile (CFLAGS-error.c): Define.
	* misc/error.c (error): Disable cancellation handling around the
	actual output.  The message should in any case be printed.
	(error_at_line): Likewise.

	* misc/error.h: Protect parameter names with leading __.

2003-08-28  Carlos O'Donell  <carlos@baldric.uwo.ca>

	* sysdeps/unix/sysv/linux/hppa/syscalls.list: Add semtimedop.

2003-08-29  Jakub Jelinek  <jakub@redhat.com>

	* libio/iofgetpos64.c (_IO_new_fgetpos64): Move lock release to the
	end.

2003-08-29  Ulrich Drepper  <drepper@redhat.com>

	* libio/stdio.h: Remove a few more __THROW.

2003-08-29  Jakub Jelinek  <jakub@redhat.com>

	* libio/Makefile: Compile fputc.c, fputwc.c, freopen64.c, freopen.c,
	fseek.c, fseeko64.c, fseeko.c, ftello64.c, ftello.c, fwide.c, getc.c,
	getchar.c, getwc.c, getwchar.c, iofclose.c, iofflush.c, iofgetpos64.c,
	iofgetpos.c, iofgets.c, iofgetws.c, iofputs.c, iofputws.c, iofread.c,
	iofsetpos64.c, iofsetpos.c, ioftell.c, iofwrite.c, iogetdelim.c,
	iogetline.c, iogets.c, iogetwline.c, ioputs.c, ioseekoff.c,
	ioseekpos.c, iosetbuffer.c, iosetvbuf.c, ioungetc.c, ioungetwc.c,
	oldfileops.c, oldiofclose.c, oldiofgetpos64.c, oldiofgetpos.c,
	oldiofsetpos64.c, oldiofsetpos.c, peekc.c, putc.c, putchar.c, putwc.c,
	putwchar.c and rewind.c with exceptions.
	* sysdeps/generic/bits/stdio-lock.h (_IO_acquire_lock,
	_IO_release_lock): Define.
	* libio/fileops.c (_IO_new_file_underflow): Use it.
	* libio/fputc.c (fputc): Likewise.
	* libio/fputwc.c (fputwc): Likewise.
	* libio/freopen64.c (freopen64):
	* libio/freopen.c (freopen): Likewise.
	* libio/fseek.c (fseek): Likewise.
	* libio/fseeko64.c (fseeko64): Likewise.
	* libio/fseeko.c (fseeko): Likewise.
	* libio/ftello64.c (ftello64): Likewise.
	* libio/ftello.c (ftello): Likewise.
	* libio/fwide.c (fwide): Likewise.
	* libio/getc.c (_IO_getc): Likewise.
	* libio/getchar.c (getchar): Likewise.
	* libio/getwc.c (_IO_getwc): Likewise.
	* libio/getwchar.c (getwchar): Likewise.
	* libio/iofclose.c (_IO_new_fclose):
	* libio/iofflush.c (_IO_fflush): Likewise.
	* libio/iofgetpos64.c (_IO_new_fgetpos64): Likewise.
	* libio/iofgetpos.c (_IO_new_fgetpos): Likewise.
	* libio/iofgets.c (_IO_fgets): Likewise.
	* libio/iofgetws.c (fgetws): Likewise.
	* libio/iofputs.c (_IO_fputs): Likewise.
